EQEMu Changelog (Started on Sept 24, 2003 15:50)
-------------------------------------------------------
== 08/26/2014 ==
Uleat: Implemented 'Smart' Player Trade transfers. Trades are processed by containers, stackables and then all remaining. QueryServ logs have been updated to match these transactions.
Note: QueryServ logs previously listed 'Items' on the main entry table. This indicated the number of slots affected and not the actual number of items.
This field now indicates the actual number of items transferred. For non-stackable, the value is '1' and stackable is the number of charges. A _detail_count
property has been added to both 'Trade' and 'Handin' structs to indicate the number of details recorded..though, not tracked..it could be added.

== 08/24/2014 ==
Uleat: Fix (attempted) for zone crashes related to zone shut-down. This change disables all Mob AI and disables/deletes all Mob timers once Zone::ShutDown() is called. More areas will be addressed as reports come in.
Note: Perl and Lua quests tested to work..please post any aberrant behavior. (I finally set my spell-check to US English...)
Akkadius: Character creation process crash fix and query cleanup
Akkadius: Created `character_lookup` table for applications that mirrors all `character_` table fields minus blob fields for application lookups
	- A 2.4GB character_ table will take 7 seconds to query on a SSD versus .1s on the character_lookup table
	- This also causes applications like Magelo to burst reads of the entire character table because of the blob fields that come with the reads, as much as 500-600MB/s even if a indexed id filter is provided
	- This field is synchronized on player save and has 0.001s DB hit
	- When we split out from the blob, ideally this table can be removed
	- Required SQL: utils\sql\git\required\2014_08_24_character_lookup.sql

== 08/23/2014 ==
Akkadius: Changed zone process window title format, example: 'crushbone :: clients: 6 inst_id: 1 inst_ver: 0 :: port: 7015'
Akkadius: Most of the following changes are QueryServ related, fully implemented its original functionality to be able to offload
	intensive or metric based logging to a remote server process that could exist on another server entirely
Akkadius: Implemented Player Event Logging Types (Go to table `qs_player_events`):
			1 = Player_Log_Quest,
			2 = Player_Log_Zoning,
			3 = Player_Log_Deaths,
			4 = Player_Log_Connect_State,
			5 = Player_Log_Levels,
			6 = Player_Log_Keyring_Addition,
			7 = Player_Log_QGlobal_Update,
			8 = Player_Log_Task_Updates,
			9 = Player_Log_AA_Purchases,
			10 = Player_Log_Trade_Skill_Events,
			11 = Player_Log_Issued_Commands,
			12 = Player_Log_Money_Transactions,
			13 = Player_Log_Alternate_Currency_Transactions,
		- All QueryServ logging will be implemented with a front end in EoC 2.0 very soon
		- Architecture page: http://wiki.eqemulator.org/p?QueryServ_Architecture
Akkadius: Changed all QS Error related logging to 'QUERYSERV__ERROR'
Akkadius: (Natedog) (Crash Fix) Legacy MySQL bug revert for loading AA's COALESCE( from COALESCE (
Akkadius: Implemented Perl Quest objects (LUA still needed to be exported):
	- quest::qs_send_query("MySQL query") - Will send a raw query to the QueryServ process, useful for custom logging
	- quest::qs_player_event(char_id, event_desc); - Will process a quest type event to table `qs_player_events` 
Akkadius: Added MySQL Tables
	- `qs_player_aa_rate_hourly`
	- `qs_player_events` 
	- Source table structures from:
		- utils\sql\git\queryserv\required\08_23_2014_player_events_and_player_aa_rate_hourly
		To get the complete QueryServ schema, source from here:
		- utils\sql\git\queryserv\required\Complete_QueryServ_Table_Structures.sql
Akkadius: Added rules for each logging type, source rules here with them enabled by default:
	- utils\sql\git\queryserv\required\Complete_QueryServ_Rules_Enabled.sql
Akkadius: Spawn related logging cleanup
Akkadius: General code cleanup
Akkadius: More to come for QueryServ 

== 08/22/2014 ==
Uleat: Rework of Trade::FinishedTrade() and Trade::ResetTrade() to parse items a little more intelligently.

Trade window items are now sent to client inventory in this order:
	- Bags
	- Partial stack movements
	- All remaining items

If any of these procedures cause any problems, please post them immediately.

== 08/20/2014 ==
Uleat: Rework of Trade::AddEntity() - function used to move items into the trade window. Now accepts argument for 'stack_size' and updates client properly.
Note: I tested trade with Titanium:{SoF,SoD,UF,RoF} in both directions and no client generated an OP_MoveItem event for attempting to place a stackable
onto a partial stack already in the trade window. The only way to achieve stacking is to click on the receiving client. If there is a partial stack remaining
on the cursor after the OP_MoveItem event, and there is room available, the client will generate subsequent events to move the remaining count.

== 08/19/2014 ==
Akkadius: Implemented a Stop_Return feature (Accidental item handin prevention) that will be symmetrically used with plugin::return_items that I am currently running live testing on EZ before releasing to EQEmu. This does not hurt to have this in the source.
Akkadius: Fixed crash where 'attacker' validation is not being checked
Akkadius: Removed petition console spam that does not follow traditional logging and is useless
Akkadius: Made fix with SympatheticProcChances where it was checking for TempItem->Focus.Effect instead of TempItemAug->Focus.Effect

== 08/18/2014 ==
Uleat: Fix for https://github.com/EQEmu/Server/issues/127 -- also activated a remarked action in doors.cpp to eliminate a memory leak.

== 08/16/2014 ==
KLS: (addmoreice) Trying out some unstable DB changes.  Do backup your database before trying them as master will be considered unstable for a few days at least.
Uleat (Noudness): Fixed a floating-point comparison error that led to the notorious 'client bounce' (this is not related to the
'mob falling' due to not having maps installed.) This fix also eliminates a sizeable amount of unnecessary out-going packets due
to invalid orientation corrections.
Note: This patch is probably of significant enough importance that admins may wish to manually apply this to older server builds.
The number of packets reduced per second should be approximately (num_stationary_close_clients * (num_close_clients - 1)). This will
likely have the most effect in zones like: Nexus, Bazaar, Guilds (Halls) and RAID INSTANCES - where players don't move around a lot.

== 08/15/2014 ==
Uleat: Reactivated the Bot::Spawn() code for sending post-spawn wear change updates..temporary until I can sort out the proper usage.

== 08/13/2014 ==
Uleat (Kingly_Krab): Fix for bot chest armor graphic glitch. (fix also caused RoF #wc to work properly)

== 08/02/2014 ==
Kayen: Implemented spell_news fields
- npc_no_los (check if LOS is required for spells) 
- InCombat, OutofCombat - Used together to restrict spells to only be cast while 
in/out of combat (beneficial) or if target is in/out of combat (detrimental).
-min_dist, min_dist_mod, max_dist, max_dist_mod - Scales spell power based on targets distance from caster.
*This will require further work to fully implement but will work with 90% of live spells as is.
*If making custom spells do not include effects that can't be scaled (like a spell trigger)
- min_rage sets minimum distance range that must be away from target.

Required SQL: utils/sql/git/required/2014_08_02_spells_new.sql

== 07/31/2014 ==
Uleat: More inventory slot constant conversions. This should be the bulk of everything..but, due to the size of the server code, there
may be some hidden ones. (client_packet.cpp and the client translators still need a thorough review.)
Note: Please report any abnormal behaviour with inventory-related content..each diff file was reviewed 3 times..but, things CAN be missed.
Uleat: Test fix for client crashes in Bazaar, while actively selling, with a charm in the Trader's Satchel.

== 07/27/2014 ==
Uleat: More updates to the dictionary. Added a 'constants' file for each client translator..these will tie-in to the dictionary. Started
replacement of hard-coded numeric values with a pre-defined constant. This will help in the transition.

== 07/16/2014 ==
Uleat: Initial commit of new client/server 'dictionaries' - work in-progress... Changed equipment slot references to reflect new naming
conventions. Lua enumerations maintain both the old and new names as to not break existing scripts..but, the old names are deprecated.


== 07/14/2014 ==
KLS: Changes to CMake build
	-Lua builds by default now
	-Common has been renamed common
	-Binary files will now be put into ${CMAKE_BINARY_DIR}/bin instead of ${CMAKE_BINARY_DIR}/Bin
	The last two are of note to people on non-windows systems as case sensitivity is important.  Edit your scripts accordingly, thank you.


== 07/10/2014 ==
Kayen: Updated table npc_spells to now support defensive and ranged procs. 
Note: Proc rate modifier work as it does for spell effects (ie 200 = 200% baseline chance modifier)
Table is also now contains 12 AI spell casting variables that can be set to fine tune casting behaviors per spell set.
Global default rules have also been added that can further fine tune all content if no specific variables are set.

Descriptions of new AI casting fields in npc_spells
'fail_recast' AI spell recast time(MS) when an spell is cast but fails (ie stunned)
'engaged_no_sp_recast_min' AI spell recast time(MS) checked when no spell is cast while engaged in combat. (min time in random)
'engaged_no_sp_recast_max' AI spell recast time(MS) checked when no spell is cast while engaged in combat. (max time in random)
'engaged_b_self_chance' Chance during first AI Cast check to do a beneficial spell on self (ie check to heal self)
'engaged_b_other_chance' Chance during second AI Cast check to do a beneficial spell on others.(ie check to heal others)
'engaged_d_chance' 'Chance during third AI Cast check to do a determental spell on others (ie check to nuke others)
'pursue_no_sp_recast_min' AI spell recast time(MS) checked when no spell is cast while chasing target. (min time in random)
'pursue_no_sp_recast_max' AI spell recast time(MS) checked when no spell is cast while chasing target. (max time in random)
'pursue_d_chance' Chance while chasing target to cast a detrimental spell.
'idle_no_sp_recast_min' AI spell recast time(MS) checked when no spell is cast while idle. (min time in random)
'idle_no_sp_recast_max' AI spell recast time(MS) checked when no spell is cast while idle. (max time in random)
'idle_b_chance' Chance to cast a beneficial spell while idle (ie cast heal on self while out of combat).

Kayen: Updated table npc_types, adding field 'ranged_type' and 'ammo_idfile'
'ranged_type' Will set what skill / animation is used when NPC uses a ranged attacked (special ability 11)
'ammo_idfile' Will set what projectile graphic an NPC uses in a ranged attacked (special ability 11) Format IT#### (same as item 'idfile')
(*Set to IT11118 for some fun*)
Added parameters: SPECATK_RANGED_ATK = 11
Param0: Min Ranged distance (default: 25)
Param1: Max Ranged distance (default: 250)
Param2: Percent Chance to Hit modifier
Param3: Percent Total Damage modifier

Kayen: Updated to Chance to Hit code with how bonuses are applied to be consistent for all effects.
Added field to npc_types 'Avoidance' which will modify chance to avoid melee 
Added rules to set max and min chance to hit from melee/ranged (Default 95% / 5%)

Required SQL: utils/sql/git/required/2014_07_10_npc_spells.sql
Optional SQL: utils/sql/git/optional/2014_07_10_AICastingRules.sql


== 07/5/2014 ==
Kayen: Updated SE_Sanctuary - Adjust way hate lowering effect worked to be more accurate
Kayen: Updated SE_SympatheticProc - Revised proc rate formula to be accurate to live.
Sympathetic foci on items with proc rate mod will now benefit from that modifier.
Sympathetic foci can now be placed on AA's (This should always be slot1 in the AA)
Kayen: Implemented SE_IllusionPersistence- Allows illusions to last until you die or the illusion is forcibly removed.
Kayen: Added rule 'PreNerftBardAEDot' for SE_BardAEDot to allow it to once again do damage to moving targets. (Set to true)
Kayen: Completely revised SE_SkillProc, SE_LimitToSkill, SE_SkillProcSuccess to overall just work better and more accurately, AA support. 

Required SQL: utils/sql/git/required/2014_07_04_AA_Update.sql


== 07/2/2014 ==
Kayen: Implemented SE_Sanctuary - Places caster at bottom hate list, effect fades if caster cast spell on targets other than self.
Kayen: Implemented SE_ResourceTap - Coverts a percent of dmg from dmg spells(DD/DoT) to hp/mana/end.
Kayen: Implemented SE_FactionModPct - Modifies faction gains and losses by percent.
Kayen: Re-Implemented SE_TriggerMeleeThreshold and SE_TriggerSpellThreshold correctly - Trigger spell if owner of buff
takes more than the specified damage amount in a SINGLE hit, then fade the buff.
Kayen: Implemented SE_LimitSpellClass - Focus Limits spell to pre defined categories. (3=Cures,3=Offensive, 6=Lifetap)
Kayen: Changed SE_LimitMaxMana to SE_MeleeVulnerability - Weakness/Mitigation verse melee damage
(Despite lives SPA lable as the former it clearly is not what the effect does from all spell examples)
Kayen: Updated SE_BardAEDot to no longer damage target while target is moving (consistent with live)
Kayen: Update SE_InterruptCasting: Will now work for instant spells (as well as over time).

== 06/25/2014 ==
Kayen: Updated SE_Hate (Renamed from SE_Hate2) to now properly work for instant +/- hate spells.
Kayen: Updated SE_FadingMemories - Base value will be properly utilized to set % chance for fade effect to work.
Kayen: Implemented SE_StrikeThough (Was incorrectly defined as implemented previously) - Works same as item bonus.
Kayen: Update SE_Taunt - Limit value if present will now add instant hate.
Kayen: Implemented SE_MassGroupBuff - Allows next group buff cast to be a MGB (AA now uses this)
Kayen: Implemented SE_IllusionOther - Allows next Illusion buff (self only) cast to be cast on target. (AA now uses this)
Kayen: Update SE_AETaunt - Base value will now determine AE taunt range (This will not result in any change to currently used spells).
Kayen: Udpated SE_ReclaimPet - Correct forumla for mana returned to properly return 75% of actual pet spell mana cost.
Kayen: Implemented SE_ImprovedReclaimEnergy - Modifies % mana returned from SE_ReclaimPet.
Kayen: Implemented SE_HeadShot, SE_HeadShotLevel - Defines headshot damage and level requirements.
Revised HeadShot mechanic so damage now receives all archery bonuses, proc chance can be set to either (lives new Proc Per minute
system, or flat chance based on dex (formula updated).
Kayen: Implemented SE_Assassinate, SE_AssassinateLevel - Defines assassinate damage and level requirements.
Revised Assassinate mechanic so damage now receives all backstab bonuses, proc chance can be set to either (lives new Proc Per minute
system, or flat chance based on dex (formula updated). Assassinate can now proc from THROW if behind target, various other adjustments.
Kayen: Fix to AA Finishing Blow missing aa_effects data, update required SQL.
Revised Finishing blow so that damage now receives all melee bonus. Support also for this effect if placed on items or spells.
Kayen: Implemented SE_PetMeleeMitigation - Bonus applied to pet owner. Gives AC to owner's pet.

Required SQL: utils/sql/git/required/2014_06_25_AA_Update.sql
Optional SQL: utils/sql/git/optiional/2014_06_29_HeadShotRules.sql


== 06/17/2014 ==
Kayen: Implemented SE_AStacker, SE_BStacker, SE_CStacker, SE_DStacker.
These effects when present in buffs prevent each other from stacking, 
Any effect with B prevents A, C prevents B, D prevents C.
Kayen: Implemented SE_DamageModifier2 (Stacks with SE_DamageModifier, mods damage by skill type)
Kayen: Implemented SE_AddHatePct (Modifies +/- your total hate on NPC by percent)
Kayen: Implemented SE_AddHateOverTimePct (Modifies +/- your total hate on NPC by percent over time)
Kayen: Implemented SE_DoubleRiposte (Modifies +/- your double riposte chance) *Not used in any live effects
Kayen: Implemented SE_Berserk (Sets client as 'Berserk' giving chance to crippling blow) *Not used in any live effects
Kayen: Implemented SE_Vampirsm (Stackable lifetap from melee effect) *Not used in any live effects
Kayen: Minor fixes to how lifetap from melee effects are calced. Removed arbitrary hard cap of 100%, Negative value will now dmg client.
Kayen: Fix to issue that prevented NPC's from receiving HP Regeneration derived from spell buffs.
Kayen: Fixes and Updates for melee and spell mitigation runes.
Kayen: Update to SE_NegateAttack, 'max' value can now set upper limit of damage absorbed. DOT ticks will no longer be absorbed.
Kayen: Implemented SE_Metabolism - Modifies food/drink consumption rates. [Data for AA is already in database]
Kayen: Update to SE_BalanaceMana, SE_BalanceHP to support limit value which caps max mana/hp that can be taken per player.

== 06/13/2014 ==
Kayen: For table 'npc_spell_effects_entries' setting se_max for damage shield effects (59) will now determine the DS Type (ie burning)
Setting se_max to 1 for SkillDamageTaken effects (127) will allow for stackable mitigation/weakness same as quest function ModSkillDmgTaken.
Kayen: Implemented SE_AlterNPCLevel (not currently used on live). Will +/- to NPC level. When fade will revert back to original level.
Kayen: Implemented 'special_abilities' 38 ALLOW_BENEFICIAL (Allows an NPC to recieve player buffs/heals)
Kayen: Implemented 'special_abilities' 39 DISABLE_MELEE (Prevents NPC from auto attacking, will still aggro)
Note: These two special abilities were previously implemented and still remain as quest functions. (SetDisableMelee() and SetAllowBeneficial())

== 06/8/2014 ==
KLS: Changed lua API: eq.get_globals(client, npc) has been removed.  Use eq.get_globals(npc, client) instead.
There's a bug with something in gcc 4.6.3 (maybe other versions) on x86 that this is attempting to combat.

== 05/17/2014 ==
Secrets: Identified the opcode/struct for guild ranks in Rain of Fear+ clients.
Secrets: Implemented a work-around for Rain of Fear clients to have all guild permissions until proper database support is added for newer ranks.

== 05/14/2014 ==
Kayen: Rooted NPC's will no longer target players with Divine Aura effect if they are the closest target and other targets exist on the hate list.

== 05/12/2014 ==
Uleat: Re-arranged functions in Item.cpp to somewhat match the order they are declared in Item.h. Should make finding their location a little easier when using declarations as a guide. (This will facilitate readability of an upcoming change...)

== 05/07/2014 ==
Kayen: AA/Item/Spells that allow pets to critical and flurry will now work on the owners swarm pets consistent with live.

== 05/05/2014 ==
Uleat: Oops! Wrong state check (conn_state != client_state)
Uleat: Test fix to eliminate seemingly random crashes when an AE spell is being used. (Possible access to uninstantiated pointers during client connection process when someone casts a beneficial AE spell within range of a connecting client.)

== 04/29/2014 ==
KLS: Implemented new map code based on some of Derision's earlier work.  Old maps still work with this system and don't need to be regenerated. We're still working on a new azone solution for better/more efficient maps.

== 04/27/2014 ==
Kayen: Implemented new table 'npc_spells_effects' and 'npc_spells_effects_entires'.
       Implemented new field in 'npc_spell_effects_id' in npc_types.
       

These are used to directly apply spell effect bonuses to NPC's without requirings spells/buffs.
Example: Allow an npc to spawn with an innate 50 pt damage shield and a 5% chance to critical hit.
Please see the wiki page: http://wiki.eqemulator.org/p?npc_spell_effects_entries for details.
*NPC's can now do critical heals / damage spells if bonus is applied from table.

Required SQL: utils/sql/git/required/2014_04_27_AISpellEffects.sql
Note: 30 examples of spell effects have been included by default in this sql. Edited/removed as needed.


== 04/25/2014 ==
cavedude: Corrected a crash in spawn_conditions caused by NPCs on a one way path.
cavedude: Added strict column to spawn_events which will prevent an event from enabling if it's mid-cycle.
cavedude: Prevented disabled or strict spawn_events from enabling when the zone first boots.
cavedude: Fixed the quest function toggle_spawn_event under Perl.

If you're using the quest function toggle_spawn_event (worked on Lua only) it has changed syntax to: 
toggle_spawn_event(int event_id, bool enable, bool strict, bool reset_base)

Required SQL: utils/sql/git/required/2014_04_25_spawn_events.sql

== 04/23/2014 ==
Kayen: Improved SE_LimitCombatSkills will now more accurately determine if a spell is a combat proc.
Kayen: SE_LimitInstant will now also work when set to include instant spells.

Optional SQL: utils/sql/git/optional/2014_04_23_FocusComabtProcs.sql
Note: Set to false, if enabled will allow all combat procs to receive spell focuses.

== 04/21/2014 ==
Secrets: Crash fix for more hatelist crashes.
Secrets: Hate list fixes, again.
Secrets: Revert of hatelist changes.

== 04/20/2014 ==
Secrets: Changed the functionality of EQDEBUG cmake flag. It now suppresses logs, but shows crashes in any scenario when set to 1. It will also now show crashes even if the log system is disabled.
KLS: Change to how quest signals work, signals with no delay will now be added to the signal queue.  This addresses an odd timing issue where NPCs are in a state of life/death flux when a signal from event_death goes off.
KLS: Added cmake flags to define how logging behavior works for each different log type.
Secrets: Crash fix for Hatelist crash observed

== 04/18/2014 ==
Akkadius: Added #command error message suppression for those who don't want to see 'Command is not recognized' constantly
	- You need to have rule 'Chat:SuppressCommandErrors' set to true, this is set to false by default
	- Required SQL: 2014_04_18_Suppress_Command_Error.sql

== 04/15/2014 ==
Akkadius: Exported $client->SendMarqueeMessage(type, priority, fade_in, fade_out, duration, msg) - Will be available for simple plugin use
Akkadius: Exported $client->ExpeditionMessage(THIS, ExpdID, Message) - In use with custom expedition mod that will be released soon

== 04/12/2014 ==
Kayen: Fixed an with the slow mitigation code that would cause it to spam the message. Optimized the way the variable is handled for slow mitigation.

Required SQL: utils/sql/git/required/2014_04_12_SlowMitigation.sql
Note: This changes the variable type in the sql table from FLOAT to INT and updates your database.
(When setting slow mitigation 50 = 50%, 100 = 100% ect. You can also set > 100 which will cause slow to become haste now with appropriate in game msg given)

== 04/10/2014 ==
Kayen: Added 'no_target_hotkey' field to npc_types table. This will prevent the NPC from being targeted with F8 (Warning: Will also turn it's name YELLOW)
Kayen: Added a rule to make all (Player cast) Swarm Pets not targetable with F8 (nearest NPC) by default (Warning: Will also turn pets names YELLOW). This is semi-hack but it works.
Kayen: Player cast swarm pets can now be healed and buffed consistent with live.

Optional SQL: utils/sql/git/optional/2014_04_10_SwarmPetNotTargetableWithHotKey.sql
Required SQL: utils/sql/git/required/2014_04_10_No_Target_With_Hotkey.sql
Note: For the required new npc_types field you DO NOT need to set values for swarm pets if you enable the above rule.

== 04/09/2014 ==
Kayen: Implemented ability to use the actual live spell projectile graphics that are defined in the modern spell file.
   *This is disabled by default. Recommend enabling if your server uses an UF+ spell file AND most of your players use UF+ clients.
Kayen: Expanded the PERL ProjectileAnim(mob, item_id, [IsArrow?, speed, angle, tilt, arc, IDFile]) so you can now just set the weapon model graphic IT####
Example: ProjectileAnim($npc, 0, 0, 1, 0, 0, 0, "IT10747")  This will shoot an SK 2.0 sword.
Kayen: Updated wizard innate critical damage modifier to be from 20-70% of base damage (based on live parses)


Optional SQL: utils/sql/git/optional/2014_04_09_SpellProjectileRule.sql
Note: This sql also contains a query to check if your spell file is compatible.

== 04/06/2014 ==
Uleat: Changed Mob::CanThisClassDualWield() behavior. This should let non-monk/beastlord dual-wielding classes attack with either fist as long as the other hand is occupied.
Notes:
	See this thread for more information and to provide feedback: http://www.eqemulator.org/forums/showthread.php?p=229328#post229328

== 04/05/2014 ==
Akkadius: Fix for the Fix for the Fix: Rule Combat:OneProcPerWeapon was created so that you can revert to the original proc functionality 
	for custom servers that have balanced their content around having more than 1 aug proc on weapons. By having this rule set to 'false' you revert this functionality. 
	This rule is set to 'true' by default as the original functionality from Live was intended to be
Akkadius: (Performance Adjustment) Removed AsyncLoadVariables from InterserverTimer.Check() in both zone and world. By watching the MySQL general.log file on mass zone idle activity, you can
	see that the query 'SELECT varname, value, unix_timestamp() FROM variables where unix_timestamp(ts) >= timestamp' is called every 10 seconds. This function is loading
	variables that are initially loaded on World and Zone bootup. When running a large amount of zone servers, the amount of MySQL chatter that is produced is enormous and 
	unnecessary. For example, if I ran 400 zone servers, I would see 3,456,000 unnecessary queries from all idle or active zone processes in a 24 hour interval.
Secrets: Added a rule to enable multiple procs from the same weapon's other slots if a proc is deemed to trigger, Defaults to true.
	If Combat:OneProcPerWeapon is not enabled, we reset the try for that weapon regardless of if we procced or not.
	This is for some servers that may want to have as many procs triggering from weapons as possible in a single round.
	
Optional SQL: utils/sql/git/optional/2014_04_05_ProcRules.sql
	
== 04/04/2014 ==
Kayen: Implemented 'Physical Resists' (Resist Type 9) to be consistent with live based on extensive parsing.
       SQL will add new field to npc_types 'PhR' and fill in database with values consistent with observations.          

Required SQL: utils/sql/git/optional/2014_04_04_PhysicalResists.sql

== 04/03/2014 ==
Kayen: Implemented live like spell projectiles (ie. Mage Bolts). 

Optional SQL: utils/sql/git/optional/2014_04_03_SpellProjectileRules.sql
Note: The rules in this SQL are for setting the item id for the graphic used by the projectile on different clients.
	
== 04/01/2014 ==
demonstar55: Implemented ability for a merchant to open and close shop.
	Lua quest functions: e.self:MerchantOpenShop() and e.self:MerchantCloseShop()
	GM Commands: #merchant_open_shop (short: #open_shop) and #merchant_close_shop (short: #close_shop)
		default to status 100, just in case you need to force the merchants status
Trevius: Fixed potential endless quest loop with EVENT_COMBAT and WipeHateList().

== 03/31/2014 ==
Uleat: Fix for unconscious skillups.
Uleat: Fix for crash issue with nullptr reference in recent Client::SummonItem() work.
Uleat: Added rule for GM Status check code in Client::SummonItem().
Note: Rule default is set to 250..but, implementation is on hold until load item code handles the database 'minstatus' field.
Uleat: Added RuleB(Bots, BotLevelsWithOwner). Bots will auto-update as their owner levels/de-levels. Appearance packets are sent to show the 'leveling effect' as well as updating client entities.
Trevius: Prevented an endless loop crash related to EVENT_TASK_STAGE_COMPLETE.

Optional Bot SQL: utils/sql/git/bot/optional/2014_03_31_BotLevelsWithOwnerRule.sql
Note: This sql is required to activate the optional behavior.

== 03/27/2014 ==
Kayen: SE_Gate will now use have a fail chance as defined by its base value in the spell data.
Kayen: SE_Succor will now have a baseline fail chance of (2%). Rule added to adjust this as needed.
Kayen: SE_FeignDeath will now have a fail chance as defined by its base value in the spell data.

Optional SQL: utils/sql/git/optional/2014_03_27_SuccorFailRule.sql

== 03/22/2014 ==
Uleat: Moved the existing 'load_bots' and 'drop_bots' sqls into the emu git repository for the time being. Look to the
	/utils/sql/git/bots/ folder to find them. The 'load_bots' sql has been updated to include the below fix, as well as
	collecting the multiple files into one. This should allow HeidiSQL to now run  it properly. (You will still need to
	search for the optional scripts for the time being.)
Uleat: Fixed bot guild script failure. For existing bot databases only, use this sql file to update the affected table and view.

Required Bot SQL: 2014_03_22_BotGuildMember_ScriptFailureFix.sql

== 03/19/2014 ==
Kayen: Further refinements to root, charm, mez and fear behaviors - See commit message for full details

New rule for 'Fear' break chance, and updates to default settings of various rules.
Optional SQL: utils/sql/git/optional/2014_03_19_RulesUpdates.sql


== 03/18/2014 ==
Uleat: Fixed the name/account discrepancy in the Client::SummonItem() code as well as the origin of the mistake (thanks K_K!)
Uleat: Condensed and rearranged certain snippets of code in SummonItem(). Added a 'augslotvisible' check to validation check.
Note: If you are experiencing issues with SummonItem, please enable 'INVENTORY_ERROR' logging if it not active on your server.

== 03/17/2014 ==
Uleat: Updated Client::SummonItem() to check for valid item combinations when augmentations are passed.
Uleat: Changed the return type of Client::SummonItem() from void to bool. Calling methods and APIs have not been update as yet.
Uleat: Fixed the RoF Item structure to properly pass the 'augrestrict' variable. RoF clients now show restrictions in the Item Information window.

Optional SQL: 2014/03/17_EnforceAugmentRules.sql
Note: This adds the rules Inventory:EnforceAugmentRestriction, Inventory:EnforceAugmentUsability and Inventory:EnforceAugmentWear.
	If you run into script/recipe issues, running this sql file will set the default enforcement rules to false.
	If you still run into issues, you may want to check that your scripts are not trying to augment non-common items.
	Please post any failures as bugs and be sure to include the base item ID, as well as any augment IDs that you are using.

== 03/12/2014 ==
Kayen: Melee/Magic runes are now calculated as bonuses. Resolved issues with runes not working and not fading properly.

== 03/08/2014 ==
Kayen: Revision to lull/harmony/pacification code to be consistent with live based on extensive personal parsing.
*Lulls on initial cast do not check regular resists (MR ect) but only apply a flat ~7.5 % resist chance + level modifier
*If Lull is resisted, a second resistance check is made this time using regular resists and a charisma modifier (same as charm)
which if 'resisted' will cause the caster to gain aggro.

== 03/05/2014 ==
demonstar55: Corrected rogue's evade to be single target
sorvani: fixed crash issue 119

== 03/04/2014 ==
Sorvani: Created RemoveFromInstance and RemoveAllFromInstance to remove a single player or all players in an instance.
Sorvani: Exported to Lua as eq.remove_from_instance(instance_id) and eq.remove_all_from_instance(instance_id).
Kayen: Revision to root code to be consistent with live based on extensive personal parsing.
*ROOT has a 40% chance to do a resist check to break each buff tick.
*If multiple roots on target. Root in first slot will always and only be check to break from nukes.
*If multiple roots on target and broken by spell. Roots are removed ONE at a time in order of buff slot.
*Roots on beneficial spells can not be broken by spell damage.

Optional SQL: utils/sql/git/optional/2014_03_04_RootRule.sql

== 03/03/2014 ==
demonstar55: Implemented deadly strikes and gave rogues higher innate throwing crit chance

New rules: Combat:RogueCritThrowingChance, Combat:RogueDeadlyStrikeChance, Combat:RogueDeadlyStrikeMod
	Defaults should give fairly close to live results

== 03/02/2014 ==
Kayen: Revision to charm code to be consistent with live based on extensive personal parsing.
*Charisma ONLY effects the initial resist check when charm is cast with 10 CHA = -1 Resist mod up to 200 CHA
*Charisma DOES NOT extend charm durations.

Optional SQL: utils/sql/git/optional/2014_03_02_CharmRules.sql

demonstar55: Melee Crits, HoTs, DoTs messages should now be filtered correctly on all clients.
	Clients that also support seeing others DoTs will now see them if they don't filter them
	note: some newer clients have a 'mine only' option for HoTs but it functions the same as show

== 02/27/2014 ==
cavedude: Exported TrainDisc to Lua.

== 02/26/2014 ==
Kayen: Implemented SE_FrenziedDevestation - increase critical spell chacnce and 2x mana cost for DD spells
Kayen: Fixed SE_SpellProcChance - Now works on spell dervived procs
cavedude: Added two new NPC special_abilities. ALWAYS_FLEE, which forces the NPC to always flee ignoring FleeIfNotAlone and FLEE_PERCENT which allows you to change the HP an individual NPC will flee at. If no value is set, the rule is used as normal.
cavedude: Fixed an issue where rectangular roamboxes could cause an NPC to get stuck on a single coord. 
cavedude: Added a new roambox column, mindelay allowing you to have more control over the roambox delay.
Uleat: Fix for 'sqrt' failure on vs2010 clients
image: Added idle zone timer to save CPU cycles.

Required SQL: utils/sql/git/required/2014_02_26_roambox_update.sql

== 02/24/2014 ==
cavedude: Better flee runspeed calculation. Added rule Combat:FleeMultiplier to alter this behavior.
Sorvani: Updated GetUnusedInstanceID to not recycle instance ID's unless it has reached max (65535)

== 02/23/2014 ==
Secrets: Exported the client object SendTargetCommand to Perl.
cavedude: Merchants will now keep better track of charges.

== 02/20/2014 ==
Kayen: Implemented SE_MitigateDotDamage	- dot spell mitigation rune with max value
Kayen: Implemented SE_DistanceRemoval - removed from target when target moves X amount of distance away from where initially hit.

Required SQL: utils/sql/git/2014_02_20_buff_updates.sql

== 02/18/2014 ==
Kayen: Implemented SE_TriggerOnReqCaster - triggers a spell which a certain criteria are met (below X amount of hp,mana,end, number of pets on hatelist)
Kayen: Implemented SE_ImprovedTaunt	- Locks Aggro On Caster and Decrease other Players Aggro by X% on NPC targets below level Y
Kayen: Fixed an error where SE_ChangeAggro was adding its bonus x 2 for spell generated aggro. (this applies also to spell casting subtlety AA reduction) 

== 02/14/2014 ==
Kayen: Fixes for buffs not fading under certain conditions in revised numhits system, and other fixes.
Kayen: Implemented support for spell_new field CastRestrictions (limits what type of targets spells can effect).
*A detailed list describing what the values used in this field do can be found in Mob::PassCastRestriction*
Kayen: Implemented support for spell_new field not_reflectable, no_partial_resists.

Required SQL: utils/sql/git/2014_02_13_spells_new_updates.sql
Names many unknown fields in the table.

== 02/13/2014 ==
Sorvani: Renamed the instance_lockout and instance_lockout_player tables to instance_list and instance_list_player. Cleaned up the Database::GetUnusedInstanceID logic.

Required SQL: utils/sql/git/2014_02_13_Rename_instance_lockout_tables.sql

== 02/10/2014 ==
demonstar55 (Secrets): Re-wrote the entity list to be a std::map. This should be used for direct entityID lookups and is noticably faster performance-wise. Also should result in less nil pointers potentially.
Secrets: Fixed a crash issue that could occur on #repop related to quest timers.
Kayen: Divine Arbiration and other similar spell effects will now utilize a spell range check.
Kayen: Revised how heal amount is calculated to properly incorporate all current focus effects/bonuses.
Kayen: Various updates/fixes/clean-ups to focus effect related code. Focus effect limits should now all work properly.

== 02/09/2014 ==
Sorvani: Added new spawn condition onchange action: DoRepopIfReady. Choosing this will not repop mobs when the spawn condition is enabled if they have an existing respawn timer. Additionally, this condition will not even attempt repop when the condition is is changed to disabled. Will be in use on PEQ for: Cragbeast Queen in Natimbi.
Secrets: Fixed a weird crash issue with deletion of pointers if task loading fails.

== 02/2/2014 ==
Kayen: Revised how spell/dot damage is calculated to properly incorporate all current focus effects/bonuses.

Required SQL: utils/sql/git/2014_02_02_SpellCriticalsAA.sql

== 01/27/2014 ==
Kayen: Implemented SE_CriticalMend  (chance to critical monk mend)
Kayen: Implemented SE_IncreaseChanceMemwipe (increases the chance to wipe hate with memory blurr)
Kayen: Implemented SE_FcStunTimeMod (modify stun duration from casted spells)
Kayen: Implemented SE_StunBashChance (increase chance to stun from bash)

Required SQL: utils/sql/git/2014_01_27_CritcalMendAA.sql

== 01/26/2014 ==
Kayen: Revised 'dispel' type spell effects (ie cancel magic) to be consistent with live

== 01/23/2014 ==
Kayen: Implemented SE_FfLimitUseType (focus limit to numhits type)

== 01/20/2014 ==
cavedude: Live-Like weather system (Thanks to robregen for figuring it out!)
demonstar55: Implemented not_extendable spell flag
demonstar55: Moved Spell Casting Reinforcement to DB
demonstar55: Moved Mez Mastery to DB
Kayen: Complete revision of the numhits systems to utilize 'numhits type' field in spell file.

== 01/18/2014 ==
sorvani: Implemented for Lua eq.get_characters_in_instance(uint16 instance_id), return a Lua HashTable
demonstar55: NPCs will now cast their charms.

== 01/13/2014 ==
Kayen: Numerous minor fixes to spell effects.
Kayen: Changed SE_ArcheryDoubleAttack -> SE_DoubleRangedAttack (now works with throwing ect)
Kayen: Changed SE_IncreaseHitDmgTaken -> SE_TriggerMeleeThreshold (now only works on melee)
Kayen: Changed SE_MitigateMeleeDamageSP -> SE_MeleeThresholdGuard
Kayen: Implemented SE_SpellThresholdGuard (Partial Spell Rune that only is lowered if spell hits are over X amount of damage)
Kayen: Implemented SE_TriggerSpellThreshold (implemented  Trigger effect on X amount of spell damage taken)
Kayen: Changed SE_ReduceHealing -> SE_FcHealAmtIncoming (focus limited Add/Remove amount of healing on target by X amount)
Kayen: Change SE_CriticalHealChance2 -> SE_CriticalHealDecay	
Kayen: Change SE_CriticalHealOverTime2 -> SE_CriticalRegenDecay	
Kayen: Implemented SE_CriticalDotDecay	
Note: 'Decay' effects means the chance to critical decays based on the level of the spell using the effect (like focus decay)
Kayen: Implemented SE_FfLimitUseMin (focus limit to require a min amount of numhits value)
Kayen: Implemented SE_FcLimitUse (focus to increases numhits count by percent)
Kayen: Implemented SE_LimitRace	(Limits to spells cast by a certain race)
Kayen: Implemented SE_FcMute  (silences casting of spells that contain specific spell effects) ie silence only heals

== 01/09/2014 ==
demonstar55: Add pet size preservation like live (zone, camp, etc)

== 01/07/2014 ==
demonstar55: Moved pet can attack check to before it tries to attack, which is more live like.

== 01/03/2014 ==
demonstar55: Crash prevention for emote.

== 01/02/2014 ==
demonstar55: Stuns from beneficial spells (Harvest) ignore immunity

== 12/26/2013 ==
demonstar55: Added classes_required to merchantlist (same bitmask as items)

== 12/24/2013 ==
Secrets (Akkadius): Perl $client->SilentMessage("Message"); addition, this is a pre-req for a Perl plugin I've shared with EQEmu. This function essentially mimics a player speaking with an NPC - which is used in popup window responses 
Secrets: Added functionality to Perl for $client->PlayMP3("name of file"). 
  Usage varies, but typically you can place an MP3/WAV/XMI in the EQDir//sounds, pfs, s3d, or root client folder and it will play through this Perl function. Example, $client->PlayMP3("combattheme1.mp3") or $client->PlayMP3("TUTBTrade1.mp3")
  All clients except Secrets of Faydwer and 6.2 have their opcodes identified for this function. The struct + supported params is the same throughout versions. 
  Use $client->PlayMP3 with an invalid sound file to stop playback or simply wait for it to end.
KLS: Added functionality to Lua for Client:PlayMP3(filename)
KLS: Added functionality to Lua for Client:SendMarqueeMessage(type, priority/opacity, fade_in_time_ms, fade_out_time_ms, duration_ms, msg)
  
== 12/16/2013 ==
Kayen: Implemented SE_ArcheryDoubleAttack (Chance to do an extra archery attack)
Kayen: Implemented SE_ShieldEquipDmgMod (Increase damage in primary hand if shield equiped)
Kayen: Implemented SE_ShieldEquipHateMod (Increase hate generated if shield equiped)
Kayen: Implemented SE_TriggerOnAmountValue (Trigger spell if HP/Mana/End bellow X value or num pet on target)

== 12/16/2013 ==
Kayen: Fix to SE_BlockNextSpellFocus to make it functional again.

== 12/15/2013 ==
demonstar55: Moved the blocked buff check down so we get spell effects like on live
Kayen: Implemented SE_ReduceHealing (Reduces amount of healing on target by X amount)
Kayen: Implemented SE_CastonFocusEffect (Triggers spell as part of a focus, when that focus effect is used)
Kayen: Implemented SE_IncreaseHitDmgTaken (Effect is triggered when X amount of damage is taken)
Kayen: More fixes for various spell triggers/procs to now properly use their resist modifier.

== 12/14/2013 ==
demonstar55: Blocked buffs shouldn't fail, they should just not be applied.
JJ: Changed enable/disable recipe to confirm change made.

== 12/13/2013 ==
Kayen: Implemented additional functionality for SE_CurrentHP utilizing base2 values. (ie limit to body type)
Kayen: Implemented SE_MitigateMeleeDamageSP (Partial Melee Rune that only is lowered if melee hits are over X amount of damage)
Kayen: Implemented SE_SpellOnAmtDmgTaken (Effect is triggered when X amount of damage is taken)
Kayen: Fix for various spell triggers/procs to now properly use their resist modifier.
Kayen: Fix to mob->ModSkillDmgTaken(skill_num, value), setting value to -1 will now properly effect all skills.

== 12/11/2013 ==
demonstar55: Fixed issue with crippling blow from berserker frenzy not actually doing anything
demonstar55: Fix haste caps

== 12/04/2013 ==
demonstar55: Fixed SpellType_Charm case in AICastSpell

== 12/03/2013 ==
demonstar55: Added #showspellslist to view a mobs spell list
demonstar55: Fix procing off of unattackable things

== 12/02/2013 ==
JJ: Bandaid fix to CopyCharacter function.

== 11/29/2013 ==
demonstar55: Stacking issues should be resolved now, probably could be optimized more, but went from 3 loops that do stuff to 3 where only 2 really does stuff and one breaks early in most cases, so slightly better

== 11/23/2013 ==
Secrets: Fixed an issue related to a zone crash where the count of the abilities in an AA was 0, leading to a size 0 buffer issue.

== 11/19/2013 ==
Secrets: Fixed an issue with two zone crashes reported on PEQ related to the buff restrictions code and AAs.
demonstar55: Partially make use of dot_stacking_exempt (case when it's 1 is implemented, -1 case isn't)

== 11/18/2013 ==
demonstar55: Added assistradius to npc_types, defaults to aggroradius if set to 0 (old behaviour)

== 11/17/2013 ==
Sorvani: fixed leash and tether special abilities to use the specified range correctly.
demonstar55: Rewrote the Mob::_GetMovementSpeed fix an issue that arose from the change on 11/11
	- Added the rule Character:BaseRunSpeedCap (default 158) so people can customize what their runspeed cap is. Hardcapped to 225 so stuff doesn't get too crazy.

== 11/16/2013 ==
Leere: Fixed the drinking message for auto-consume, it will again correctly show up for forced consumption instead.
demonstar55: Added Mob::DoCastingChecks() which will check for various fail conditions while the casting bar is up. This is called after Mob::DoCastSpell() starts the casting and before it returns.

== 11/15/2013 ==
demonstar55: Fixed Mob::CalcFocusEffect()'s SE_LimitEffect
Leere: Fixed a stacking issue for SE_StackingCommand_Block

== 11/13/2013 ==
demonstar55: Implemented bard song effect cap. You can set the base cap with the rule Character:BaseInstrumentSoftCap, defaults to 36 or "3.6" as it is sometimes referred to.
demonstar55: Fix Echo of Taelosia and Ayonae's Tutelage to increase the mod cap instead of further improving the instrument mod
demonstar55: Implemented Singing/Instrument Mastery as an AA bonus.

== 11/11/2013 ==
demonstar55: Changed the way walk speed is calculated to allow mobs to have their walk speed equal a 100% movement reduction

== 11/09/2013 ==
Leere: Fixed Bard mana regen, they now only are affected by items and AA.

== 11/07/2013 ==
KLS: Added a system to use the BaseData system in the client.
KLS: Added an optional utility to import spells, skill caps and base data (will import from ./import and export to ./export).

Be sure to source the SQL and run shared_memory.

== 11/06/2013 ==
JJ: (Kingly_Krab) Fix for #npcedit qglobal command.

== 11/01/2013 ==
JJ: Added in-game commands to enable/disable tradeskill recipes
-Commands: #enablerecipe recipe_id, #disablerecipe recipe_id
-Perl: quest::enablerecipe(recipe_id), quest::disablerecipe(recipe_id)
-Lua: eq.enable_recipe(recipe_id), eq.disable_recipe(recipe_id)

== 10/31/2013 ==
Leere: Add the ability to disable a tradeskill recipe

== 10/28/2013 ==
Uleat: Client patch prep work for extending usable skill range (no apparent issues with Ti through RoF[12-10-2012] testing - i.e., clients showed proper skills and they didn't crash)
Uleat: This final patch aligns the existing server PlayerProfile_Struct with the previous changes. The pp_struct, as well as the character 'pp' blob, remains unchanged in size and alignment. The only difference is that the first trailing 100 bytes of the unknown array have been re-assigned to the skills array, and the unknown array decreased by the same amount.
Notes:
	- The existing configuration will allow the use of any new skills up to 99
	- Due to this new segment of the blob having never been written to properly, we may have erratic data there that needs to be cleared before use
	- None of the new skills are coded to use these 'new' skill slots
	- A per-client method will still need to be observed when coding for the new skill uses

== 10/27/2013 ==
Uleat: Attempted fix for high level (12) debug compile failures
Notes:
	- Explicit Windows vs. Linux code was not changed due to my inability to compile Linux code
	- Only CMake accessible flags were corrected if adding the 'std' namespace did not correct the issue
	- the tag [CODEBUG] was added to failed code identifed by the above note
	- If you are having compile issues after this patch is committed, look to the changes here first
Uleat: Changed riposte fail check to proper failure criteria - (x == a && x == b, where a != b) never passes, so skills a and b can riposte (discovery find, no known reported occurences)
Uleat: Enforced naming standard on my recent changes (Sorry for any inconviencies)
Uleat: Moved DeityTypes enumeration from eq_constants.h to deity.h (expanded utility of accessors, but are yet to be implemented)
Uleat: Changed ItemUseType to ItemInstTypes to better reflect the definition (also to free-up the namespace)
Uleat: Changed ItemClass to ItemClassTypes
Uleat: Converted MATERIAL defines to MaterialUseSlots enumeration - use of scripted 'Bracer' and 'Max' are deprecated
Uleat: Changed ItemTypes to ItemUseTypes - retained the 'ItemType' prefix to avoid too much confusion. Also adopted the '1H Piercing' model found in later clients
Uleat: Converted SkillType typedef enumeration to SkillUseTypes enumeration - Some prep work for adding the newer skills
Uleat: Prepped the client patch files for larger skill buffer size (not active)

== 10/24/2013 ==
demonstar55: Fix some memory leaks in Mob::SpellOnTarget

== 10/21/2013 ==
demonstar55: Changed GetMinLevel return 0 for more cases that EQ uses for some reason ...
demonstar55: Added buff level restrictions, set the Spells:BuffLevelRestrictions to false to have the old behavior.

== 10/18/2013 ==
Uleat: Expanded the 'Bag Type' enumeration to include all known values. Also, set in place additional 'Bag Type' to 'Skill Type' conversions. Some of these will need to be verified before activation.
Uleat: Cleaned up some unused enumerations to show a move towards standardization. More to come...

== 10/12/2013 ==
demonstar55: Allow Titanium and lower clients to enter Tutorial zone from character select
Bad_Captain: Fixed merc crash issue by updating special_abilities & vwMercNpcTypes (Sorvani).
Bad_Captain: Bots- added out of combat bard songs & #bot bardoutofcombat on|off command to turn them on/off.

== 10/11/2013 ==
JJ: (demonstar55) Allow use of Go Home button when Tutorial still selected in RoF.

== 10/10/2013 ==
Secrets: Fixed zone shutdown (or #reloadqst) reinitalization of Perl. This should allow for Perl 5.14 and later to work on Windows under the new quest system.
demonstar55: Beneficial single target buffs shouldn't have their mana/timers set if they fail to cast after the Mob::SpellOnTarget call in Mob::SpellFinished
JJ: Revert change to EnterWorldPacket introduced on 22 April 2013 to fix inability to enter Tutorial or Go Home from character select screen.

== 10/09/2013 ==
demonstar55: Fixed some more instances of the AA timer being eaten

== 10/08/2013 ==
demonstar55: Added IsBuffSpell(spell_id) that will return true if the spell has a duration, so would end up in effects/song/discs etc windows on the client
demonstar55: Replaced instances of using CalcBuffDuration to determine if a spell was a buff with IsBuffSpell
demonstar55: Removed Mob::HasBuffIcon since it was doing what IsBuffSpell does in a more convoluted way with a rather misleading name
demonstar55: Fixed issues that arose from the 10/03/2013 change

== 10/05/2013 ==
Sorvani: fixed issue with stackable items being created with 0 charges cause by fix to SummonItems

== 10/03/2013 ==
demonstar55: Fix when the random +1 tick is added to nerf extension focus effects to where they should be

== 09/30/2013 ==
Sorvani: Changed SummonItem to only summon an item with max charges when said default value is present and not on zero charges
demonstar55: Fixed issue with #showstats showing your level for a bunch of values

== 09/13/2013 ==
demonstar55: Add support for /pet hold on and /pet hold off (UF and RoF)

== 08/29/2013 ==
KLS: Removed Common Profiler and Zone Profiler.  They're well past outdated status and are just code bloat.
KLS: Fix for reported issue on forums with skills that could potentially be trained before a player achieved the level to train.

== 08/20/2013 ==
Uleat: Fix for bot pet spell buff corruption (existing db issues will correct themselves through pet death attrition)

== 07/18/2013 ==
KLS: Fix for crash in special_abilities code due to existing use of some dangerous code we didn't catch before.

== 07/15/2013 ==
Sorvani: fix for lua_general.cpp funtion get_spawn_condition
Uleat: added non-extensioned wildcard filter to \\...\dependencies\.gitignore to fix tortoisegit inclusion errors (fixes commit and display overlay issues.)

== 07/13/2013 ==
KLS: Added packet class and helper functions to Lua.
KLS: Added quest event: event_unhandled_opcode

== 07/11/2013 ==
KLS: Added a few lua functions.
KLS: Redid the npcspecialatk system with a new system that is more flexible but a little more complicated (this will break any 3rd party tools that deal with them).

Instead of a string such as "ERS" to denote "Enrage Rampage Summon" abilities are indexed by their ability number, level and params separated by '^'.
It is stored in the following format: ability,level[,param0,param1,param2,param3,param4,param5,param6,param7] Params will be read until there are 8 total or a '^' is reached.
Eg: 'ERS' -> '2,1^3,1^1,1

Levels allow us to dictate how abilities behave that may be different even though they're the same ability.
Params allow us to further refine behaviors on a case by case basis.  Passing 0 as a param will use the default value.

NOTE: Be sure to source 2013_07_11_NPC_Special_Abilities.sql.  Also due to the large impact this has on a database it is very HIGHLY SUGGESTED to BACKUP YOUR DATABASE FIRST.

The following are the special abilities currently in the game as well as their levels and parameters currently in use:

SPECATK_SUMMON = 1
Level 1: Summon target to NPC
Level 2: Summon NPC to target
Param0: Cooldown in ms (default: 6000)
Param1: HP ratio required to summon (default: 97)

SPECATK_ENRAGE = 2
Param0: HP ratio required to enrage (default: rule NPC:StartEnrageValue)
Param1: Enrage duration in ms (default: 10000)
Param2: Enrage cooldown in ms (default: 360000)

SPECATK_RAMPAGE = 3
Param0: Proc chance (default: 20)
Param1: Rampage target count (default: rule Combat:MaxRampageTargets)
Param2: Percent of a normal attack damage to deal (default: 100)
Param3: Flat damage bonus to add to the rampage attack (default: 0)
Param4: Ignore % armor for this attack (default 0)
Param5: Ignore flat armor for this attack (default 0)
Param6: Percent of npc's natual crit that can go toward this rampage (default: 100) 
Param7: Flat crit bonus on top of npc's natual crit that can go toward this attack (default 0)

SPECATK_AREA_RAMPAGE = 4
Param0: Proc chance (default: 20)
Param1: Rampage target count (default: 1)
Param2: Percent of a normal attack damage to deal (default: 100)
Param3: Flat damage bonus to add to the rampage attack (default: 0)
Param4: Ignore % armor for this attack (default 0)
Param5: Ignore flat armor for this attack (default 0)
Param6: Percent of npc's natual crit that can go toward this rampage (default: 100) 
Param7: Flat crit bonus on top of npc's natual crit that can go toward this attack (default 0)

SPECATK_FLURRY = 5
Param0: Proc chance (default: rule Combat:NPCFlurryChance)
Param1: Flurry attack count (default: rule Combat:MaxFlurryHits)
Param2: Percent of a normal attack damage to deal (default: 100)
Param3: Flat damage bonus to add to the flurry attack (default: 0)
Param4: Ignore % armor for this attack (default 0)
Param5: Ignore flat armor for this attack (default 0)
Param6: Percent of npc's natual crit that can go toward this attack (default: 100) 
Param7: Flat crit bonus on top of npc's natual crit that can go toward this attack (default 0)

Ex: Normal Flurry with 25% proc rate and 100% crit chance that ignores 500 armor.
5,1,25,0,0,0,0,500,0,100

SPECATK_TRIPLE = 6
SPECATK_QUAD = 7
SPECATK_INNATE_DW = 8
SPECATK_BANE = 9
SPECATK_MAGICAL = 10
SPECATK_RANGED_ATK = 11
UNSLOWABLE = 12
UNMEZABLE = 13
UNCHARMABLE = 14
UNSTUNABLE = 15
UNSNAREABLE = 16
UNFEARABLE = 17
UNDISPELLABLE = 18
IMMUNE_MELEE = 19
IMMUNE_MAGIC = 20
IMMUNE_FLEEING = 21
IMMUNE_MELEE_EXCEPT_BANE = 22
IMMUNE_MELEE_NONMAGICAL = 23
IMMUNE_AGGRO = 24
IMMUNE_AGGRO_ON = 25
IMMUNE_CASTING_FROM_RANGE = 26
IMMUNE_FEIGN_DEATH = 27
IMMUNE_TAUNT = 28

NPC_TUNNELVISION = 29
Param0: Aggro modifier on non-tanks (default: rule Aggro:TunnelVisionAggroMod)

NPC_NO_BUFFHEAL_FRIENDS = 30
IMMUNE_PACIFY = 31

LEASH = 32
Param0: Range (default: aggro range * aggro range)

TETHER = 33
Param0: Range (default: aggro range * aggro range)

DESTRUCTIBLE_OBJECT = 34
NO_HARM_FROM_CLIENT = 35

The following Lua API functions were added to deal with the new system:
Integer GetSpecialAbility(Integer ability);
Integer GetSpecialAbilityParam(Integer ability, Integer param);
Void SetSpecialAbility(Integer ability, Integer level);
Void SetSpecialAbilityParam(Integer ability, Integer param, Integer value);
Void ClearSpecialAbilities();
Void ProcessSpecialAbilities(String str);

The old API functions that worked with letters still exist for backwards compatibility reasons but wont be updated further.

== 07/08/2013 ==
Secrets: Cleanup of some log functions that did not have an 'off' function.**
Secrets: Unknown opcode messages only show on EQDEBUG* >= 5 or higher now. (including the dumped packet)

*NOTE: We recommend for debugging and feature development that you keep EQDEBUG to 5 or higher. For production environments, we recommend 1 to help with CPU performance on windows machines and disk I/O on all platforms.
**Affected filters:
NET__ERROR
NET__DEBUG

== 07/05/2013 ==
KLS: Added some lua functions
KLS: Fixed some lua functions
KLS: Perl now will (like lua) keep track of the values you return from EVENT_*.  This allows perl to use the extra behavior in things like EVENT_DEATH.  Now generally the perl system is now considered deprecated (in favor of lua in the long term) I felt this was too big a change to pass up adding when I got it working.

== 07/02/2013 ==
KLS: Exported eq.follow(entity_id, [distance]) and eq.stop_follow() to lua.

== 07/01/2013 ==
demonstar55: Fix Monster Summoning related to giants/cyclops
demonstar55: Prevent Monster Summoning from summoning a portal in bothunder
KLS: Merge of lua branch to master
See: http://www.eqemulator.org/forums/showthread.php?t=37008 for more detailed information on what is added.
Upgrade notes:
	-'templates' quest folder needs to be renamed 'global'
	-'items' quest folder needs to be moved into the 'global' folder
	-'spells' quest folder needs to be moved into the 'global' folder
	-EVENT_PROXIMITY_SAY needs to be enabled via quest before it will work, calling quest::enable_proximity_say() in EVENT_SPAWN will suffice.
	-quest::handleturnin, quest::completehandin, quest::resethandin, and quest::clearhandin have been removed. Take a look at https://code.google.com/p/projecteqquests/source/browse/trunk/quests/plugins/check_handin.pl plugin::mq_process_items, plugin::check_mq_handin, plugin::clear_mq_handin for MQ viable replacements.
	-Some spell quests that overwrote the effects from the spell they were cast on no longer function properly on perl, it's suggested you make the spells empty or rewrite the broken quests in lua and return a non-zero value.
	-Some item quests have changed in a subtle way, though it's unlikely any quests are impacted and the thread has more information if you found any of your quests broke.  As far as I know for example: PEQ didn't have to update any of its nearly 70 item quests.
	-Cazic Touch (982) no longer shouts the name of the thing it is targeting without a script.
	-EVENT_DEATH now triggers before the death is complete.  For the old functionality you may use EVENT_DEATH_COMPLETE.  It might be a good idea to replace all EVENT_DEATH with EVENT_DEATH_COMPLETE in existing spells.
	
We sought to minimize changes required but it's still a bit disruptive so take a few minutes when upgrading to make sure everything is correct.  Most notably quest::clearhandin was used in some popular plugins to avoid a dupe involved with its code and now that it's gone those will not function if fixes are not applied.

== 06/16/2013 ==
Secrets: Fixed an issue with RoF items and Req/Rec level above 100 appearing yellow. Recommended to enable the #iteminfo command for items that have a req/rec above 100 to display proper information regarding the info.

== 06/15/2013 ==
KLS: (image) Potentially could bypass some spell checks by passing a specially crafted spell slot.  This has been addressed.

== 06/12/2013 ==
KLS: Merge Hateborne's hp cap stuff
KLS: We haven't updated changelog in a while but there's been:
	-Some string stuff
	-A lot of fixes to things like caps.
	-More work on custom mod stuff (including examples)
	-Fix for login not bailing out if it cant connect to a db
	-Quite a few warning changes.

== 05/09/2013 ==
Uleat: (Updated: 06/12/2013) Fixed a few observed bot issues and an beneficial AE casting bug:
	Added missing Bot primary weapon proc call (secondary and ranged already exist)
	Added Bard Bot instrumentation bonuses
	Added checks to avoid AE Buff casting on enemy mobs
	Fixed a few typos in 'Vah Shir'-related code
	(Please post any discrepancies as bugs)

== 05/05/2013 ==
Tabasco: Added EVENT_ITEM_TICK for interactive item quest scripts.  (See https://github.com/josheb/quests_dc/blob/master/items/12204.pl)
	Added simple account flags.  Would this work better as an additional qglobal category?
	Added SendMessage to EQW, useful for using CURL to broadcast to the server.
	Added WorldShutDown to EQW for timed world shutdowns, also updated console worldshutdown command to optionally use timed behavior.
	Added numerous modding hooks and mod_functions.cpp for easy custom formulas or future lua integration.
	Added various rules for monk AC bonus weight, archery bonuses, kick/bash stuns and mob stun levels.
required SQL: 2013_05_05_Account_Flags.sql
required SQL: 2013_05_05_Item_Tick.sql

== 04/28/2013 ==
PiB: Implement CRC16 using CRC32.

== 04/27/2013 ==
PiB: Verify OP_Ack size & fix crash in BasePacket::build_raw_header_dump due to uninitialised timestamp.
Derision: Verify minimum size of OP_Packet, OP_Fragment and OP_OutOfOrderAck.

== 04/24/2013 ==
Bad_Captain: Fixed a couple of merc stat issues.
Bad_Captain: Removed unneeded bot pet AI.
Bad_Captain: Fixed a few bot aggro issues. (Uleat)

== 04/20/2013 ==
JJ: Fixed rare case where heals from buffs could go negative.

== 04/12/2013 ==
Derision: Moved entity_list.Clear() prior to destruction of Perl objects in zone shutdown as I was seeing a segfault due to attempts to call EVENT_HATE_LIST as mobs were being destroyed.

== 04/09/2013 ==
demonstar55: Realized I was an idiot, changed salvage script to be better
optional SQL: 2013_04_09_SalvageCleanOld.sql - run if ran old script

== 04/08/2013 ==
demonstar55: Implemented Salvage AA
required SQL: 2013_04_08_Salvage.sql
script: generate_salvage.py - will generate the entries for some exceptions for salvage returns.

== 04/04/2013 ==
demonstar55: Implemented SE_ForageAdditionalItems as a bonus
required SQL: 2013_04_04_NaturesBounty.sql

== 04/03/2013 ==
demonstar55: Overloaded Mob::Say_StringID with the option to provide a message type
demonstar55: Switched rest of the Pet Messages to MT_PetResponse (Leader commands intentionally left the old way)

== 04/2/2013 ==
Bad_Captain: Fixed Merc lack of use of heal over time spells (causing excessive healing).
Bad_Captain: Fixed pet mitigation/AC issues.

== 04/01/2013 ==
demonstar55: AA reuse timers now start when you hit the button and are reset upon failure
demonstar55: Instant Cast bard AAs can now be used while singing a song

== 03/30/2013 ==
demonstar55: Fixed most of the pet talking, all use StringIDs now. Pet now informs you when it taunts.

== 03/23/2013 ==
demonstar55: Fix issues with escape not always working and fixed SE_FadingMemories to have the message since the message isn't part of the spell data.
    Escape now uses just the spell and not the AA Actoin
    Fading Memories now only uses the AA Action to eat mana

== 03/21/2013 ==
Bad_Captain: Fixed merc buffing bugs.
Bad_Captain: Added checks before dismissing merc to prevent possible bugged mercs.
Bad_Captain: Merged in Secret's merc memory leak fixes.

== 03/20/2013 ==
demonstar55: Fixed stacking issues with SE_Limit* (ex. Unholy Aura Discipline and Aura of Reverence)

== 03/18/2013 ==
Bad_Captain: Fixed zone crash due to merc focus effects & tribute.
Bad_Captain: Fixed merc aggro issues when client in melee range & spell recast timers. 
Bad_Captain: Added melee DPS spells/disciplines & support.

== 03/17/2013 ==
Secrets: Fixed that pesky merc memleak.
Secrets: Bit of code cleanup regarding mercs.

== 03/15/2013 ==
Derision: RoF: Added ENCODE for Resurrect_struct (Accepting a rez should now work).
Derision: Fixed a couple of memory leaks in Rez code.

== 03/14/2013 ==
JJ: (NatedogEZ) Fix for hate list random never selecting last member of hate list.
Bad_Captain: Fixed Merc spell recast timers. 
Bad_Captain: Changed how Mercs add mobs to their hate lists (should prevent IsEngaged() issues).
Bad_Captain: Initial Caster DPS Merc spell casting AI, including initial Merc stance implementation. 
Bad_Captain: Mercs now suspend when their owner dies to prevent them being bugged (until it can be fixed).

OPTIONAL SQL: 2013_03_14_Merc_Spells.sql

== 03/09/2013 ==
Zaela_S: Stop mobs aggroing on dead players when using RespawnFromHover.
Derision: Removed _log message from zone/CatchSignal on Linux as it can deadlock on shutdown if another signal is received while the _log call is being processed.
Derision: Added some error logging into ZoneDatabase::NPCSpawnDB for #npcspawn create.

== 03/07/2013 ==
af4t: Melee tomes with names beginning "Skill:" (e.g. RNG Warder's Wrath, etc) can be memorized now, by hand-in-to-guildmaster or right-click-from-inventory.

== 03/02/2013 ==
af4t: Stop NPCs aggroing each other with buffs/beneficial spells.

== 03/2/2013 ==
Bad_Captain: Fixed Merc depop bug.
Bad_Captain: Added merc rest regen.
Bad_Captain: Fixed merc group spell casting bug where mercs would continue to try to cast group buffs on pets of caster who didn't have Pet Affinity AA.


== 03/1/2013 ==
Bad_Captain: Fixed Merc duplicate save bug.
Bad_Captain: Focus items, spell_scale and heal_scale now work implemented and new merc equipment (with focus items).
Bad_Captain: Added checks during merc hire, unsuspend, & timer update for states where a merc can't be hired, unsuspended, or can't be retained due to insufficient funds, no room in group, in raid, invalid merc data, etc, and give appropriate feedback.
Bad_Captain: Added rules for charging of merc purchase and upkeep costs.

REQUIRED SQL: 2013_03_1_Merc_Rules_and_Equipment.sql

== 02/27/2013 ==
KLS: Changed how shared memory works:
    Instead of System V/windows pagefile shared memory we now have shared memory that's backed by the filesystem.
    What that means is basically instead of EMuSharedMem(shared library) we now have shared_memory(executable), shared memory will be persistent between runs until you delete or reload it using the shared_memory executable.
    
    STEPS FOR PEOPLE WHO CAN'T BE BOTHERED TO FIGURE IT OUT:
        1) Create a directory in the place you run world/zone named shared and make sure files can write there.
        2) Run the shared_memory executable from the same place you run world/zone (it's basically doing the loading we would do on startup so will take a moment).
        3) Run world/zone/whatever

== 02/25/2013 ==
af4t: Add Touch of the Wicked AA redux to SK Improved Harm Touch and Leech Touch.

== 02/22/2013 ==
demonstar55: Mobs will now be removed from XTargets when they get back to their way point, should be last instance of XTarget mobs not clearing when they are not aggroed anymore

== 02/19/2013 ==
Derision: World should no longer crash if the start_zone query fails at character creation.

== 02/18/2013 ==
Bad_Captain: Moved merc save to merc table, save merc buffs, added cure and rez spells to healer merc.
JJ: Chat garbled for drunk characters.
Derision: Charmed pets should no longer be targettable with F8. Charmed pets no longer get a surname of Soandso's Pet.
demonstar55: Added potionbelt tool tip
KLS: Added EVENT_DEATH to Player Quests

REQUIRED SQL: 2013_02_18_Merc_Rules_and_Tables.sql
OPTIONAL SQL: 2013_02_18_Merc_Spells.sql

== 02/17/2013 ==
Derision: Added optional guildid and minstatus parameters to quest::gmsay(<messsage>, [color], [toworld], [guildid], [minstatus])
Derision: Client version is now returned by the stream proxy as a number.
Derision: Fixed bug where BecomeTrader packets were only being sent to the Trader, not all other clients in the bazaar.

== 02/16/2013 ==
demonstar55: Fix AA reuse timer calc
demonstar55: Remove old filters and change all remaining old to new (Also fix Auction filtering out OOC as well due to incorrect define)

== 02/12/2013 ==
Kayen: AA fix

REQUIRED SQL: utils/sql/svn/2504_required_aa_updates.sql

== 02/11/2013 ==
Derision: RoF: Added ENCODE for OP_BeginCast (fixes no sound during spell casting). Corrected OP_DeleteSpell.

== 02/10/2013 ==
JJ: (demonstar55) Language skill up should use proper function.
JJ: SetLanguageSkill now updates client immediately. Both functions do proper limit checks.
    Added two missing languages. Skill level 0 in a spoken language now shows 'in an unknown tongue'.
JJ: Initial implementation of a GarbleMessage function and implemented for languages. Can be shared with drunk speaking.

== 02/09/2013 ==
KLS: Was pointed out to me that we're in violation of ActiveState Licensing terms for their perl distribution.
To rectify this we have removed the Windows perl binaries from the source.

== 02/06/2013 ==
Uleat: Changed conversion of bot armor colors from long to unsigned long. Conversion error led to #FFFFFFFF for all returns.

== 02/05/2013 ==
cavedude00: Added heading to start_zones
Uleat: Fixed the 'nude' bot issue. Mob::texture was not set to the appropriate value and forcing an unclad body model.
Uleat: Fixed the show/hide helm feature. Added rebroadcast of packet so that changes take place immediately instead of after zoning.
KLS: Addressed several (completely stupid and inexcusable) bugs in the avoidance code that made it impossible to dodge and parry in certain situations. 
As a note: please don't touch the avoidance code if you don't know what you're doing, seriously.

Required SQL: utils/sql/svn/2482_required_start_zones.sql

== 02/03/2013 ==
Trevius: RoF: More work on Bazaar Traders.
Sorvani: Items with more than 1 charge should be purchased at max charges again. This does not fix players recharging by sell/buyback method. That will come in the future.

== 02/02/2013 ==
Trevius: RoF: Fixed some opcodes related to surnames and traders.  Surnames can now be cleared.
JJ: Fix to #spawn: Automatically truncate name if too long so spawn will happen as expected rather than a NameTooLong NPC.
JJ: Fix to #spawn: Output actual NPC result after creation rather than projected result before.

== 02/01/2013 ==
Trevius: RoF: Loading Spell Sets now unmems spells before meming the new set.
Trevius: RoF: Turning on Trader mode in bazaar now works, but no further trader functionality is available yet.
Akkadius: Fixed an issue where global_npc.pl was not initializing (initially)

== 01/31/2013 ==
cavedude00: (demonstar55) Rune aggro fix
cavedude00: (Drajor) Tradeskill skillneeded fix.

== 01/30/2013 ==
Kayen: Various AA fixes, mostly related to SOF display issues.

REQUIRED SQL: utils/sql/svn/2471_required_aa_updates.sql


== 01/29/2013 ==
Secrets: Another attempt to fix this bot/merc group crash on zoning.
cavedude: Added $client->GetInstanceID() Perl export.

== 01/28/2013 ==
Secrets: Fixed a crash issue involving invalid buff slots in SpellEffect code. (Crash fix.)
Secrets: QuestParserCollection no longer processes EventPlayer in the case that a player zones and the group is still valid via linkdeath. (Crash fix.)
Secrets: Added the command #augmentitem. Does the same thing that the #bot augmentitem command does but without the bot command needing to be active. Default 250 status.
JJ: Added quest::depop_withtimer() which will depop NPC and start spawn timer (a replacement for $npc->Depop(1) code if desired)

== 01/27/2013 ==
Trevius: Fixed a bug introduced in Rev2448 that caused some spell casting to use all of a player's mana.
Trevius: Mercenary buffs now display in the Target Buffs window.
Trevius: RoF: Populated a couple more bit fields in the spawn struct.
Trevius: Mercenaries are no longer targetable with NPC targeting hotkeys.

== 01/26/2013 ==
Derision: RoF: Updated spell buffs in the PP to account for instrument_mod/bard_modifier.
Sorvani: Missed a spot on the stun proc aggro change.
Trevius: Fixed Mercenary Upkeep Timers and Stances again for UF and SoD.
Trevius: Fixed Mercenary Upkeep Timers to properly restart after the timer is up for all clients.
Bad_Captain: Mercs - Initial spell casting AI committed.
KLS: Added crash logging for Windows builds.
Trevius: Mercenaries now despawn when a player camps out or disconnects in any way.
Trevius: Players with a Mercenary spawned can now be invited to and join another group with their mercenary.
Sorvani: (Demonstar55): Moved stunproc rule implmentation to catch all cases

OPTIONAL SQL: utils/sql/svn/mercs.sql		-- rerun for updated merc stats & merc spell lists

== 01/25/2013 ==
Sorvani: Implemented max aggro from stun proc set to 400. It is rule based set rule to -1 for unlimited.
Derision: RoF: Should fix x10 Buff bug.
Trevius: Reworked some of the code dealing with Mercenary packets and spawning them.  There is still some work to be done, but the basics are more solid now.
Trevius: Mercenaries function much more consistently now for Hiring, Suspending, Unsuspending, Dismissing.
Trevius: Mercenaries no longer fail to group up after being hired, unsuspended or after zoning/logging in.

== 01/24/2013 ==
Trevius: RoF: The #fixmob command can now go up to race 724 when cycling through races.
Trevius: RoF: The #npcstats command no longer truncates itemlinks.

== 01/23/2013 ==
Trevius: RoF: Corrected multiple opcodes.
Trevius: RoF: Apply Poison is now functional.
Trevius: RoF: /getguildmotd is working.
Trevius: RoF: GM commands /changename, /summon, /emotezone, and /emoteworld are working.
Trevius: RoF: Sense Traps is now working.
Trevius: RoF: Potion Belt is now functional.
Trevius: RoF: /who and /who all now display the correct player counts.

== 01/21/2013 ==
Akkadius: Should have fixed some scenarios where the global_npc.pl script wasn't unloading correctly
Trevius: RoF: Alternate Currencies now display correctly in the inventory window.
Trevius: Changed one of the mercenary data packets to use the same packet Live does instead of the Merchant packet.
Uleat: RoF: Aligned the extended client slots back into slottype 0. Previously, corpse looting stopped after looting the ninth slot. (There's still an issue addressing slots 31 and 32..this cannot be efficiently corrected until an inventory rework is performed.)
Uleat: Fixed a corpse looting issue where the power source item (slot 9999) was being omitted from the corpse inventory. A previous oversight on my part. Also refined message reporting. (RoF: increased corpse slot limit to 34)
Uleat: Power Source items will now report in 'worn' instead of 'inv' when using #peekinv.

== 01/20/2013 ==
KLS: intN types have changed to more closely reflect C99 and C++11 types: 
intN was an unsigned int of N bits -> it is now a signed int of N bits.
sintN was a signed int of N bits -> it has been removed in favor of intN.
uintN is still unsigned.
The existing types in the code have been changed automatically(intN -> uintN, sintN -> intN), but keep this in mind when developing in the future.

== 01/19/2013 ==
Akkadius: Implemented global_npc.pl, this is very similar to global_player.pl where any normal NPC script will run dual-stack or in tandem with the global_npc.pl located in the templates folder
Akkadius: Implemented the ability to modify EXP and AAEXP modifiers per Level, these are loaded from an optional table (level_exp_mods) that is attached to the commit, you MUST enable the rule first!
Akkadius: Added #reloadlevelmods - which will reload level mods from the `level_exp_mods` table
Derision: RoF: Guild name now appears in the Guild Management window and over player's heads. /guildstatus now works. Guild members status now updates in the GMW.
Uleat: Corrected the BulkSendInventory process for incomplete item trade returns resulting from a server crash. Previous code used an external reference and items were never moved..and hence, lost once a new trade occurred.
Uleat: Added mlog messages to existing BulkSendInventory code to report hidden item movements and deletions. All BSI and helper processes now log movements/deletions.
Uleat: Added two new client pre-entry inventory validation methods - RemoveDuplicateLore and MoveSlotNotAllowed. Duplicate lore was not checked and IsSlotAllowed failures were not handled. Both were causes of persistent desyncs.
Uleat: Corrected a bug in ItemInst::IsSlotAllowed that 'passed' PowerSource slot checks regardless of ItemInst::Slots value.
Uleat: [Client-Server Inventory Desyncronization] Most CSD bugs should now be corrected, or at least, compensated for. Please post any desync issues as a new bug post or pm a Dev or GM if it involves an exploit.

Optional SQL: \utils\sql\svn\2428_optional_levelbasedexpmods.sql

== 01/18/2013 ==
Akkadius: Fixed an size value of hp_regen_rate for NPC's so values don't roll over into negative values
KLS: EQEmu has been setup to use CMake, this is mandatory.
Visit http://www.eqemulator.net/wiki/wikka.php?wakka=CMake for instructions on Windows/GCC.

== 01/17/2013 ==
Uleat: Added opcode handlers for OpenInventory(SoF and SoD) and OpenContainer(SoF, SoD, UF and RoF). Both still need slot translators.
Uleat: Changed internal SwapItem method from void to bool return. Added appropriate code to handle returns.
Uleat: Added an abbreviated form of the resync code - SwapItemResync. Handles failed item swaps on a case-by-case basis.
Uleat: Fixed a bug that allowed duplication of non-stackable, charged items..lore or otherwise. (Sorry cheaters...)

== 01/16/2013 ==
Derision: RoF: Updated OP_LogServer encode based on a live packet in order to enable 'Enter Tutorial from character select.
Secrets: Added five new functions to perl for clients: GetBindX, GetBindY, GetBindZ, GetBindHeading, and GetBindZoneID. They all have an optional parameter of index of playerprofile's bindpoint.
Secrets: Added an optional parameter to GetBind for index.

== 01/15/2013 ==
Derision: RoF: Added Encode for OP_TaskDescription and removed RoF specific code for it from tasks.cpp
Derision: Fixed some compiler warnings.
Trevius: RoF: Varlinks and Saylinks now display properly for RoF.
Trevius: RoF: Started work on Mercenaries.  They are partially functional but need more work.
Trevius: RoF: Started work on Guilds.  The guild window can now display members, but the guild name does not yet display.

== 01/14/2013 ==
Derision: RoF: Fixed bug that was causing only one task to show in the Active Task window.
Derision: Fixed potential crash in QuestManager::varlink. Removed some unused variables that gcc was warning about.

== 01/13/2013 ==
Derision: RoF: Encoded OP_TaskHistoryReply and added temporary handling for short OP_TaskActivity packets until encode is down for that.
Derision: Deleted Anniversary/HoT/VoA and Live patches.
Derision: Updated StaticGetZoneName with all zones currently in the PEQ database.
Trevius: RoF: Disciplines now update without zoning.

== 01/12/2013 ==
Derision: RoF: Personal Tribute and the Pet Buff Window now work.
Derision: Fixed potential crash in SendPetBuffsToClient. 
Derision: RoF: Accounted for the fact the Duplicate Lore item message now includes the item's name.
Trevius: RoF: The Task Selector Window is now functional.

== 01/11/2013 ==
JJ: Added rule check to zone - no need to load Merc Templates if Mercs aren't allowed.

== 01/10/2013 ==
Trevius: RoF: Corrected multiple opcodes.
Trevius: RoF: #finditem now displays itemlinks correctly.
Trevius: RoF: Started work/testing to get Tasks functioning. Don't click tasks in the history tab or client will freeze.
Trevius: Added some possible crash fixes.
Bad_Captain: Mercs - temp fix for possible crash when dying with RespawnFromHover on, fixed infinite stats (buffs continually adding to stats).

== 01/09/2013 ==
Derision: RoF: Corrected LDoN merchant opcodes, added encode for OP_AdventureMerchantSell. Updated PP with available LDoN points.
Bad_Captain: Mercs - removed debug messages, fixed regen.

== 01/08/2013 ==
Derision: RoF: Marked position of Monk 'Mend' skill cooldown timer in PP. Fixed a typo.
Bad_Captain: Mercs - Merged from branch. Initial merc commit to trunk with semi-functional tank mercs.
Uleat: RoF: Changed opcode so that is handled properly. (Was writing to the log about twice-per-second.)
Trevius: RoF: Death no longer crashes players and the respawn window is now functional.
Trevius: RoF: More work on slot conversions.  This time for the cursor buffer.
Trevius: RoF: Some work on Guild Master Training packets, but still only seeing languages displayed.

REQUIRED SQL: utils/sql/svn/2383_required_group_ismerc.sql				-- adds ismerc column to group_id table
OPTIONAL SQL: utils/sql/svn/2380_optional_merc_rules.sql						-- Contains rules for mercs including rule to enable mercs
OPTIONAL SQL: utils/sql/svn/2380_optional_merc_merchant_npctypes_update.sql		-- Contains npc_types & spawn updates for merc merchants in PoK
OPTIONAL SQL: utils/sql/svn/2380_optional_merc_data.sql							-- Contains basic merc data, template info, & merc merchant entries
OPTIONAL SQL: utils/sql/svn/mercs.sql											-- Contains merc stats & armor - to be replaced as needed with updated stats, spells, etc. Allows a complete resourcing of file	

== 01/07/2013 ==
Trevius: RoF: /who and /who all now function properly.
Trevius: RoF: Adjusted/corrected some of the slot conversion functions.
Kayen: Various AA Fixes including a critical crash bug.

REQUIRED SQL: utils/sql/svn/2376_required_aa_updates.sql

== 01/06/2013 ==
Kayen: Fix for missing and incorrect Healing Adept AA values.
Trevius: RoF: Possible crash fix for logging in on some server builds.
Trevius: RoF: Added VoA to the #cvs command output.
Derision: RoF: Short buffs should appear in the song/short buff box.
Lerxst/Hateborne: Updated Mob::TryDivineSave to allow someone to be saved even if there are no additional effects to be cast and rearranged the buff fading so the spell effect isn't lost before it can be cast.

REQUIRED SQL: utils/sql/svn/2370_required_aa_updates.sql

== 01/05/2013 ==
Trevius: RoF: Tradeskill combines (auto-combine and experiment) are now functional.
Trevius: RoF: The Popup Message window is now functional.
Trevius: RoF: Increased the max race id for #race to 724 (the max for RoF).
Trevius: RoF: Corrected the opcode for Augmenting Items and adjusted the struct, but it looks like it may require considerable work to implement the new augment system.
Akkadius: Trap Zone Crash issue where message is empty
Akkadius: Fixed a warning regarding AC
Vaion: RoF: Books now work properly.

== 01/04/2013 ==
Trevius: RoF: Looting items and loot all are now functional.
Trevius: RoF: Trading to NPCs and Players is now functional.
Trevius: RoF: AA Purchases are now functional.
Trevius: RoF: Opening Tradeskill Objects is now possible.
Trevius: RoF: Moving items into Tradeskill Objects is now possible, but combines will bug the client.
Uleat: QS: Added 4 additional logging options [MerchantLogTransactions], [PlayerLogDeletes], [PlayerLogHandins], [PlayerLogMoves]
Uleat: QS: PlayerLogHandins is partially enabled..currently logs NPCtypeID and Client-side trade information only.
Uleat: QS: Renamed 1 existing source files to maintain logging name continuity [PlayerLogTrades].
Uleat: Fixed minor issue that was causing armor glitches with RoF clients from UF and lower clients.
Uleat: Fixed minor bug in the #iteminfo command where the material value reported 0x20xx.

REQUIRED SQL: utils/sql/svn/2361_required_qs_rule_values.sql
REQUIRED SQL: utils/sql/queryserv/2361_QueryServ.sql
REQUIRED SQL: utils/sql/queryserv/2304_QueryServ.sql (rename '2304_qs_playertradelog.sql' - Does not need to be re-sourced)

== 01/03/2013 ==
Trevius: RoF: Fixed slot conversion issues for Bank and Shared Bank
Trevius: RoF: Normal Merchants are now fully functional for buy/sell
Trevius: RoF: Item Links now display item stats when clicked, but the links are still truncated.
Trevius: RoF: Corrected the Illusion Struct and corrected some opcodes.
Trevius: RoF: Updated the DeleteSpawn struct and added an encode for it.
Trevius: RoF: Hopefully fixed Consuming food/drink.

== 01/02/2013 ==
Vaion: RoF: Crash prevention for Item Preview window.
Trevius: RoF: Finished identifying basically all of the remaining RoF opcodes.
Akkadius: Fix for Guild Crash again...

==01/01/2013==
Uleat: Fixed the wear change issue where the server was not translating the SoF, SoD and UF clients' update request properly.
Uleat: Fixed the non-clickable quest reward bug triggered when the item was in a container and the player traded the item or zoned.
Vaion: RoF: Found Opcode for Item Previews.  Made base packet support so that Item Preview (Alt+Right Click) works.  Still a few issues to hash out.

==12/31/2012==
Derision: RoF: Added encode/decode for BlockedBuffs and OP_FindPerson. Added opcodes for FindPerson and RestState
Derision: RoF: Found XP/AAXP in the PP. Updated OP_ExpUpdate/OP_LevelUpdate.

==12/30/2012==
Derision: RoF: Did some work on buffs & buff removal. OP_SetChatServer2 for UCS. Encode for OP_HPUpdate

==12/29/2012==
Derision: RoF: Added Leadership AA into the PP. Few opcodes to make Track work.
Derision: RoF: Some spell related opcodes and PetCommands struct update.
Vaion: RoF: Fixed OP_PetCommands and OP_TargetCommand to correct opcodes.  Identified OP_Jump.
Vaion: Fix for an issue with attuneable augments and an issue in guild bank.
Sorvani: Fix for pets causing a crash. Do not set rule > 25!
Trevius: RoF: Corrected wearchange packet structure.
Trevius: RoF: Added new arguments to #wc ( #wc [wear slot] [material] [ [hero_forge_model] [elite_material] ] ) - Example: "#wc 1 5 6"
Trevius: RoF: Hero's Forge Robes can now be used with #wc by using wear slot 7 - Example: "#wc 7 6 11"
Akkadius: Guild Bank crash fix, checking for valid items before going through the iterator

REQUIRED SQL: utils/sql/queryserv/2340_required_maxbuffslotspet.sql

==12/28/2012==
Derision: RoF: Found GM and PVP flags in PP.
Derision: RoF: Found endurance & some group/raid leadership stuff in PP.
Sorvani: Restricted pet buffs to 25. could be made a rule when/if the extpp gets changed to handle it.
Sorvani: Changed a few more VS2010 projects to build as $ProjectName

==12/27/2012==
Sorvani: Removed #PRAGMA statements around OP_CharacterCreate from patch files now that real problem with RuleI is resolved.
Derision: RoF: Found more of the Spawn_Struct bitfield values.

==12/26/2102==
Secrets: Fixed an issue where the pets code was counting the wrong number of buffs to load, resulting in invalid memory. "And no one likes getting in the middle of invalid memory!"
Derision: RoF: Updated position/movement related structs (per SEQ), OP_Animation encode and CombatDamage_Struct
Akkadius: Increased max item ID to 300000 (You will need to replace your EmuShareMem.dll for sure next build!
Akkadius: Fixed an issue where initiating CreateDatabaseEntry() for a door would reset version back to 0, it now grabs the current version the door is saved in.
Sorvani: Fixed quest::summonitem to summon charged items with max charges if no charge amount specified
KLS: Fixed an issue with RuleI returning an unsigned int32 instead of a signed int32.  This is a critical vulnerability, please update right away.

==12/24/2012==
Akkadius: Fixed an issue where quest::createdoor would return a door id of 0 when doors exist with version -1 (All Zones)

==12/23/2012==
Trevius: RoF - Fixed the item struct so items can be loaded properly.
Trevius: RoF - Added back all of the opcodes that were previously identified and a few more.
Derision: RoF - Commented out lots of Guild opcodes that were causing crashes.
Derision: RoF - Updated RequestClientZoneChange struct and encode. Altered default Bitfields setting to only apply tyo NPCs
Derision: RoF - Updated RoF.cpp to remove all the warnings in a Linux compile

==12/22/2012==
Secrets: Fixed the x64 portability issue reported by Akkadius. No idea how long this has been broke but at least it's fixed.

==12/21/2012==
Sorvani: Items with zero charges remaining and located in a bag will no longer get set to MaxCharges when looted from a corpse. Round 2.
Sorvani: (Hateborne) copy paste issue in Mob::TryDivineSave corrected
Trevius: RoF - Fixed the Character Select Struct, which should prevent an error when trying to enter world on certain characters.
Trevius: RoF - Character Creation is now functional.
Trevius: RoF - Identified more fields in the Player Profile and added the correct checksum so the current packet should work (thanks Derision).
Trevius: RoF - Added the opcode for max characters to allow up to 10 chars to be created per account instead of 0 (thanks Noport).
Trevius: RoF - Fixed Drakkin Appearances at Character Select.  Appears that all facial/body features are now perfectly aligned.
Uleat: QueryServ player trade log code is now enabled. Set the rules_value to true to enable logging.

REQUIRED SQL: utils/sql/queryserv/2304_qs_playertradelog.sql

==12/20/2012==
Akkadius: Changed maxlevel default value and value for lootdrop_entries, this is a thing more affecting servers with higher than 127 so this doesn't affect many people.

OPTIONAL SQL: utils/sql/svn/2300_optional_loot_changes.sql

==12/19/2012==
Trevius: RoF - More work on RoF Structs and added the Client Version stuff.
Trevius: RoF - Removed/Disabled most opcodes until we are further along and then I will add them all back in and populate the rest.
Trevius: RoF - Added a new packet dealing with membership status, but it may need more work.
Uleat: Added inspect message functionality for SoF+ clients.
Uleat: Added bot command #bot setinspectmessage (use #bot setinspectmessage help)

REQUIRED SQL: utils/sql/svn/2299_required_inspectmessage_fields.sql

==12/18/2012==
Lerxst: Added the RoF.cpp files to the patches folder of the project for the vs2008 people.

==12/17/2012==
Sorvani: Added the RoF.cpp files to the patches folder of the project for the windows people.
Akkadius: Added EntityList::GetDoorsByDoorID(int32 id) which is exported to Perl $entity_list->GetDoorsByDoorID
Akkadius: Added Door Class object $Door->GetDoorID(); to return the obvious Door ID for the entity

==12/15/2012==
Trevius: Initial addition of the RoF client.  Currently disabled by default.  Uncomment the 2 RoF lines in common/patches/patches.cpp to enable the client.

==12/13/2012==
Sorvani: (Uleat) Player Inspect works for Titanium users again. Spell casting from a clicky effect checks that the item is still in the slot it was cast from before applying the affect and removing the charge (if applicable).

==12/08/2012==
Secrets/Akkadius: Implemented the customary ability to scale an NPC's spell damage or healing % by a modifier loaded from the npc data in npc_types
	This will allow an NPC to do for example 150% of the damage of their damage spells if spellscale is set to '150'
	'healscale' field needs to be set to affect heals in a similar manner
	Both of these can also be accessed via ModifyNPCStat through 'healscale' and 'spellscale'
	
REQUIRED SQL: utils/sql/svn/2283_required_npc_changes.sql

==12/06/2012==
Secrets: Fixed OP_PVPStats in HoT to the proper opcode, OP_WebLink. You can use $client->SendWebLink("website"); in perl to use this functionality to pop open a web browser ingame.

==12/05/2012==
Akkadius: Ability to send signals through the Telnet console to character: signalcharbyname <playername> <id>

==12/04/2012==
Sorvani: (Uleat) Update to inspect (SoF+) and corpses to related to handling power sources. Titanium inspect still broken.
Vaion: Renamed the rule for targeting swarm pets so that it make sense with the code.

OPTIONAL SQL: utils/sql/svn/2280_optional_rule_targetableswarmpet-rename.sql

==12/3/2012==
Vaion: New rule created for handling whether swarm pets are targetable or not.  Set to false for default to allow targeting swarm pets.

OPTIONAL SQL: utils/sql/svn/2278_optional_rule_targetableswarmpet.sql

==12/2/2012==
Secrets: Pets can no longer proc from any hand other than their primary hand. This fixes an issue where beastlord pets could proc two, three or four from dual wielding/double attacking pets (as well as a general mechanics fix).
Secrets: NPCs will no longer attempt to heal through walls. There is now a LOS check for friendly NPC heals through walls. This was especially apparent in the PEQ database in Splitpaw, where you could have maybe 10 NPCs healing through walls at a time. I don't recall this ever happening on live past OoW. If this is incorrect revert it and make it a rule.

==12/1/2012==
Vaion: Swarm Pets are now untargetable.  They still gain aggro, are attackable and can be casted on by NPCs, but clients cannot target them.
Sorvani: Items with 0 charges will no longer get a free recharge when players die. Changed the TargetName property for all projects to be $(ProjectName). The only project that will have a new name is chatserver. It is now called ucs matching the linux build.

==11/27/2012==
Sorvani: fix for newly created items with unlmiited charges to actually be usable.
Sorvani: (Uleat) Lore check is now made for items inside bags being trade before the trade completes.
Akkadius: Started first works of implementing QueryServ for what it was meant to be used
Akkadius: Moved QueryServ to it's own configuration block in the eqemu_config.xml (example):
	<qsdatabase>
		<host>localhost</host>
		<port>3306</port>
		<username>root</username>
		<password>password</password>
		<db>queryserv</db>
	</qsdatabase>
Akkadius: QueryServ can now be used on a separate server and can use an entirely separate database as it was meant to
Akkadius: Added 'loottable_id` to NPC::ModifyNPCStat which also changes quest::ModifyNPCStat(identifier, newValue); as well
Akkadius: Fixed heap corruption in quest_globals that would occur if a value over 64 bytes was created
Akkadius: Changed value size in qglobals from 64 bytes to 128 bytes
Akkadius: Added #reloadworld - This command will reload every single zones Perl quests and repop them
Secrets: Minor code fix for qglobals. Since we removed the id field from qglobals, I suppose we shouldn't use it in code.
Secrets: Warning fix for a quest function.
Secrets: Fixed a crash issue where player corpses did not exist at all in a function (ie; they were disabled) yet we are trying to use an invalid pointer
Secrets: durp, i'm retarded. memleak fix.

Perl Changes:
Akkadius: Added EVENT_DISCONNECT to global_player.pl/player.pl - Event that triggers whenever a character disconnects from the world
Akkadius: Added EVENT_CONNECT to global_player.pl/player.pl - Event that triggers whenever a character connects to the world
Akkadius: Added EVENT_TASK_UPDATE to global_player.pl/player.pl - Event that triggers whenever a donecount is incremented in a task, exports variables: $donecount, $activity_id and $task_id
Akkadius: Added EVENT_TASK_COMPLETE to global_player.pl/player.pl - Event that triggers whenever a task is complete, this can sort of be checked in EVENT_TASK_STAGE_COMPLETED already but this is more finite, exports variables: $donecount, $activity_id and $task_id
Akkadius: Added EVENT_TASK_FAIL to global_player.pl/player.pl - Event that triggers whenever a task has failed, exports variables: $task_id
Akkadius: Added $client->SignalClient($data), it uses the client as the initiator and the client that gets sent the data, good for entity_list iterations through client
Akkadius: Exported $client->AddAlternateCurrencyValue(currency_id, amount); originally created by KLS
Akkadius: Added quest::gettaskactivitydonecount(task, activity); which obviously will get the amount done in a task based on task and activity
Akkadius: Added cross zone client signalling capability by character ID: quest::crosszonesignalclientbycharid(char_id, data);
Akkadius: Added cross zone client signalling capability by character Name: quest::crosszonesignalclientbyname(Name, data);
Akkadius: Added cross zone client messaging capability by character Name: quest::crosszonemessageplayerbyname(Type, Name, Message);
Akkadius: Added the ability to flow #commands through Perl, by flow meaning if the command doesn't process through the traditional command system, it will dump the output to EVENT_SAY in player.pl/global_player.pl based on rule Chat:FlowCommandstoPerl_EVENT_SAY

QueryServ Changes:
* I plan on adding much more logging to this server, but for now I've started with the following:
* QueryServ requires rules to be enabled before packets get sent to QueryServ, otherwise World/Zone doesn't need to even craft the packets for logging
Akkadius: Logging all player kills through QueryServ, you need to have QueryServ:PlayerLogNPCKills Rule Enabled, type: 0 = Solo, 1 = Group, 2 = Raid
Akkadius: Player trades logging started but definitely not finished
Akkadius: Removed the rules system from QueryServ, rules should only be read from World/Zone

REQUIRED SQL: utils/sql/queryserv/2268_QueryServ.sql

Database Changes:
Akkadius: Added a field in `character_` called `firstlogon` that will essentially be booled true when a player logs on, it handles a characters online status between world and zone and ultimately gets used in EVENT_CONNECT
Akkadius: Completely dropped the `id` column in `quest_globals`, the (`charid`, `npcid`, `zoneid`, `name`) fields will act as the primary keys, tested and working fine. This solves capping out on ID's as they are unecessary.
Akkadius: Changed value size of `quest_globals` field `value` from 64 bytes to 128 bytes
Akkadius: Removed an AA that was causing heap corruption

REQUIRED SQL: utils/sql/svn/2268_required_updates.sql

==11/25/2012==
JJ: Initial fix for /MQZone detection to reduce false positives.
Sorvani: Corrected Improved Familiar pre-req and commited Vaion's AA update to fix animation Empathy.
Required SQL: utils/sql/svn/2264_required_aa_updates.sql

==11/24/2012==
Sorvani: (Vaion) Added /pet no cast and /pet focus
Required SQL: utils/sql/svn/2262_required_pet_discipline_update.sql

==11/23/2012==
cavedude: (Tabasco) Re-added probability, setting it to 100 (default) effectively bypasses probability and no additional roll is made. Setting it to 0 prevents the table from being rolled at all, so you can disable the table but still keep the entries if needed.
Required SQL: utils/sql/svn/2260_probability.sql

==11/22/2012==
Sorvani: Tabasco sent in this bugfix: Ranged attack crash
It doesn't happen every time, but if an NPC is flagged for ranged attacks and they kill their target, the AIProcess function continues on under the assumption that the target is still available.

I just adjusted it to set a flag and do the actual attack at the end of the function. I haven't been able to reproduce the crash since.

==10/31/2012==
Akkadius: Added the ability to govern player max levels through the source per character. It will look for a qglobal named 'CharMaxLevel', type 5 qglobal, if the rule is enabled and the character flag is set, they will not be able to pass that level.
Optional SQL: utils/sql/svn/2243_optional_char_max_level_rule.sql

==10/22/2012==
Lerxst2112: Fixed issue in AddMoneyToPP where the amount of silver was being added to copper instead of the leftover copper.

==10/03/2012==
Sorvani: Disabled optimization around the DECODE(OP_CharacterCreate) in all SoF+ patches to force character creation to validate correctly.

==10/02/2012==
Sorvani: A NPC that is immune to Mez, Slow, Fear, Charm, or Snare will now generate aggro based on the respective spell's normal aggro.

==09/28/2012==
Sorvani: SE_SummonCorpse will now work in raid groups.

==09/27/2012==
Bad_Captain: Bots- Changed #bot healrotation timer to allow decimal values.
Bad_Captain: Bots- Rewrote bot AAs to load from DB.
Bad_Captain: Bots- Synced bot code to client code for aabonuses, attack, spell casting, etc., as the result of the client aabonuses changes.

==09/23/2012==
Kayen: Fix for crippling blow chance, other minor fixes related to bonuses.

==09/20/2012==
Kayen: AA dbase table fixes - Archery Mastery, Fury of Magic.

REQUIRED SQL: utils/sql/svn/2215_required_aa_updates	

==09/19/2012==
KLS: Faction mods (Race, Class, Deity) can now be added on the fly, without adding database columns or editing the code. Source in the database change, run utils/factionmod.pl, and then drop the faction_list table to convert.

REQUIRED SQL: utils/sql/svn/2214_faction_list_mod.sql

==09/18/2012==
cavedude: Overhauled loot system. I've outlined the new system on the forums here: http://www.eqemulator.org/forums/showthread.php?t=35770

REQUIRED SQL: utils/sql/svn/2213_loot_changes.sql

==09/16/2012==
Kayen: Implemented SE_HealFromMana changed to SE_HealGroupFromMana - now implemented correctly.

==09/14/2012==
Kayen: Implemented SE_CriticalHealRate - Focus that increase chance for heals cast on you to critical.
Kayen: Implemented SE_IncreaseNumHits - Focus that can inceases max number of hits a buff can have before being removed.
Kayen: Removed SE_Twinproc - This is not an actual spell effect, Twin proc is now correctly implemented as on live using SE_Twincast.
Kayen: Implemented SE_TwoHandBluntBlock - Chance to block when using two hand blunt weapon (similiar to shield block).
Kayen: SE_NegateEffect will now negate all AA, item and spell bonuses for the specified effects.
Kayen: Added support to allow for certain bonuses to now properly be calculated when cast as debuffs (ie decrease chance to critical hit)
Kayen: Implemented rule to allow certain bonuses to be calculated by adding together the value from each item, instead of taking the highest value. 
  *Ie. Add together all worn cleave effects, ferocity effects ect.

OPTIONAL SQL: utils/sql/svn/2209_optional_additive_bonus_rule.sql (disabled by default)

==09/13/2012==
cavedude: Uleat implemented the following changes:

The bandolier function should no longer CAUSE desyncs. Its use can still be affected by previous issues, just like any manual swap. Message cues have been temporarily added to certain procedures to indicate to the player that a possible desync condition exists and that they should zone or relog to correct the situation immediately.

The chance of player corpses becoming bugged should now be minimal. Corpse processing was changed to better emulate client behavior when 'RespawnFromHover' is set to true or false. Message cues and #commands were added to help determine whether a corpse is bugged. (Previously, queued cursor items were sent to the corpse..but, the packet builder did not include the 8000-series of items when a player looted their corpse.)

Tweaked several areas where item swaps were not handled properly, or at all, and the client-server inventories became desyncronized. Additional areas are still suspect for causing desync's. (A 'ResyncInventory' method is in-work to eliminate the need for item deletion...)

Client::SummonItem now limits the size of a summoned stack to the value of stacksize in the database. If you are using script to summon stacks greater than item->stacksize, this action was/is incorrect and you will need to modify your 'quest' to summon multiple stacks.


command changes:
	#equipitem - modified partial stack movements..if a partial stack would be left on cursor, the action now fails.
	#corpse - added subcommand 'InspectLoot'..works for client and npc corpses..additional information with client.
	#peekinv - added stack size(charges) to report and modified the cursor depth reporting of bag slots.
	#zopp - new command for troubleshooting..forces a client 'trade' or 'summon' to desync the client inventory.

references:
	http://www.eqemulator.org/forums/showthread.php?t=35604 - CSD Support Patch
	http://www.eqemulator.org/forums/showthread.php?t=35629 - CSD Bugged Corpse Patch
	http://www.eqemulator.org/forums/showthread.php?t=35699 - CSD Bandolier Patch
	
cavedude: (demonstar55) Damage shields by default will no longer count towards EXP gain. (Rule also added to change this behaviour.)
cavedude: (demonstar55) Extended targets should now clear when aggro is lost using skills.
cavedude: (demonstar55) AAs with shorter reuse timers should now reset if the cast failed (interrupted.)
KLS: Fixed a cause of raids disbanding on zoning.

OPTIONAL SQL: INSERT INTO `rule_values` VALUES (1, 'Combat:EXPFromDmgShield', 'false', 'Determine if damage from a damage shield counts for EXP gain.');

==09/12/2012==
Kayen: Implemented NPC Special Attack 'i'. Immune to Taunt.
Kayen: Implemented: SOF+ live like stacking of AA's that belong to the same series in the AA window (Expection: AA's that use hot keys).
Kayen: Implemented SE_SpellEffectResistChance - Increase chance to resist specific spell effects ie. Charm
Kayen: Revision to how AA focus effects are handled to correclty utilize live AA data.
Kayen: Almost all 'General' and most 'Archetype' AA's implemented through Underfoot.
Kayen: aaID data (AA.h) updated through VoA expansion.

Following AA effects are now implemented as bonuses: You must update your 'aa_effects' table with 'required_aa_updates.sql' for these to work.
MISC AA: Spell Casting Subtlety now implemented with bonus SE_ChangeAggro
MISC AA: Many AA that are spell focus effects now implemented using live data.
MISC AA: Finishing Blow ect, will now implemented using bonus, SE_FinishingBlow and SE_FinishingBlowLvl.
ENC  AA: Total Domination now implemented with bonus SE_CharmBreakChance.
SK   AA: Soul Abrasion now implemented with bonus SE_ImprovedDamage2.
*Many fixes to previously implemented AA effects.

REQUIRED SQL: utils/sql/svn/2208_required_aa_updates	
OPTIONAL SQL: utils/sql/svn/2208_optional_aa_stacking_rule.sql (If false will disable AA stacking for all clients)
OPTIONAL SQL: utils/sql/svn/2208_optional_EnableSoulAbrasionAA
 *If using an older server spell file (pre SOF), will need to run this to correctly populate the 'spellgroups' field.

=======
==09/07/2012==
Bad_Captain: Bots- Fixed an issue where bots couldn't have spells with target type of ST_GroupClientAndPet cast on them.
Bad_Captain: Bots- Added #bot healrotations command. Please see forums for more information.

==09/04/2012==
cavedude: Added NPC:UseMultiQuest rule to turn multiquest support on or off.

OPTIONAL SQL: INSERT INTO `rule_values` VALUES (1, 'NPC:UseMultiQuest', 'false', 'If true, NPC will remember items handed to them for classic multiquest support.');

==09/03/2012==
Akkadius: First set of efforts to clean up Windows compiling. See:
	http://www.eqemulator.org/forums/showthread.php?p=212217#post212217
	- Cleaned up x64 compiles, x86 compiles coming right up
	- Removed pragma comments and forced them to be used under 'Additional Dependencies' (Windows)
Akkadius: Fixed-up Release & Debug 32-bit compiles
Akkadius: Uploading includes and libraries for both x64 and x86 so that VS2010 can automatically reference those libraries and requires no configuration
Akkadius: All project types have had includes and libraries linked to the appropriate machine type
Akkadius: Most project types have been set to /MP (Multiprocessor compile) and Warning Level 1 to filter most of the garbage
Akkadius: Got the rest of the VS2010 compiles working on a fresh SVN:
		Debug x64|x64 = Debug x64|x64
		Debug|Win32 = Debug|Win32
		Debug|x64 = Debug|x64
		DebugBots x64|x64 = DebugBots x64|x64
		DebugBots|Win32 = DebugBots|Win32
		Release x64|x64 = Release x64|x64
		Release|Win32 = Release|Win32
		ReleaseBots x64|x64 = ReleaseBots x64|x64
		ReleaseBots|Win32 = ReleaseBots|Win32
		ReleaseBots|x64 = ReleaseBots|x64

==09/02/2012==
cavedude: (image) Added Classic Multiquest support.
cavedude: Added quest::clearhandin and #clearquestitems so that multiquest can co-exist with out current system without issues.

REQUIRED plugin: utils/defaults/plugins/check_handin.pl (Or use PEQ quests repo)

==08/27/2012==
Akkadius: (Uleat) Temporary dupe fix until we can iron this out the way it should be (Not use signed ints in the blob). This should trap a majority of it to client saves.
Akkadius: Account shared platinum field type change (signed to unsigned) to no longer allow negative values...

REQUIRED SQL: utils/sql/svn/2195_required_sharedplatupdates.sql

==08/17/2012==
Kayen: Taunt skill updated to work consistent with live.
  *You can now taunt NPC's over the users level. (RULE: TauntOverLevel)
  *Taunt success chance should be accurate to live. Penalty of not being at max skill lv can be adjusted with (RULE: Combat:TauntSkillFalloff)
  *Live messages for taunt success and failure are now implemented. (Note: Only NPC races that can 'talk' will say the success message).
Bad_Captain: Bots- Fixed an issue when with bot spell timers that could lead to a crash.
Kayen: Fixed SQL files from rev2185+ that were not saved as .sql 

OPTIONAL SQL: utils/sql/svn/2189_optional_taunt_rules 
OPTIONAL SQL: utils/sql/svn/2185_optional_NPCFlurryChance_rule (run this again)
  
==08/16/2012==
Kayen: Complete revision of the Death Save and Divine Save effects and related bonuses to be consistent with live.
  *Death Save (Death Pact/DI) will no longer fire on death. It should only fire when less 15% HP but not killed.
  *Death Save chance is determined soley by charisma of client with the buff. (RULE: DeathSaveCharismaMod)
  *Divine Intervention baseline is now correctly set to 8000HP (from 50k) (RULE: DivineInterventionHeal)
  *AA Touch of the Divine provides upon failure of first Death Save, a second roll and if successful will
   do a portion of the original heal value. (Ie DI=8000HP with ToTD-3(60%) your heal will be 8000*0.6 = 4800HP)
  *Implemented functionality for later expansion Death Save effects (Divine Intercession ect)
   These can add heal value to the base heal which is limited by level (ie Heal 10,0000+8000 if client less then level 80)
   
  *Divine Save (AA Unfailing Divinity) only fire upon death of client with this effect and is independent of Death Save effect.
  *Increased ranks of AA only increase the chance of firing upon death. Heal value does NOT increase with rank.
  *Upon firing you will still recieve the Divine Aura like buff, which now also correctly removes all determental effects.
Kayen: Implemented: SE_Purify - Removes determental buffs. Value determines how many buffs are removed.
Kayen: Added RULE MaxCastTimeReduction - Max percent your spell cast time can be reduced by spell haste(is/was 50%).

Following AA effects are now implemented as bonuses: You must update your 'aa_effects' table with 'required_aa_updates.sql' for these to work.
MISC AA: Internal Metronome/Channeling Focus now implemented with bonus, SE_ChannelChanceSpells.
MISC AA: Concentration now correctly implemented with bonus, SE_ChannelChanceItems.
MISC AA: Pet Affinity now implemented with bonus, SE_GivePetGroupTarget.
MISC AA: Spell Casting Expertise, Mastery of the Past ect will prevent fizzles from spells under certain level, SE_MasteryofPast.
BRD  AA: Extended Notes/Sionachie's Crescendo will increase ranage of songs with bonus, SE_SongRange.
BRD	 AA: Jam Fest now implemented with bonus, SE_CastingLevel2.
CLR  AA: Unfailing Divinity now implemented with bonus SE_Unfailing Divinity.
CLR  AA: Touch of the Divine now implemented with bonus SE_DivineSave.
DRU  AA: Enchanted root/Viscid Root (was implemented completely wrong), now uses bonus SE_RootBreakChance.
  *If a root is cast on the target and target has this AA it will decrease the chance for that root to break
   from any damage spells. The damage spells can be cast by any one, not just the client with the bonus.
   Added RULE: RootBreakFromSpells - Baseline is/was set at 20% chance from nukes.


REQUIRED SQL: utils/sql/svn/2188_required_aa_updates	
OPTIONAL SQL: utils/sql/svn/2188_optional_miscspelleffect_rules

==08/13/2012==
Kayen: Update to how chance to hit bonuses are applied.
  *Accuracy spell effect will now stack with Hit Chance spell effect. (Accuracy/15 = 1% chance to hit).
  *Skill specific Hit Chance effects should stack correctly now.
  *Accuracy/Hit Chance effects that DECREASE your chance to hit will now function.
Kayen: Minor update to duel wield, chance bonuses will be correctly applied to baseline dw chance.
Kayen: Implemented Perl MOB Quest Object SetFlurryChance(value) (ie 50 = 50% chance for NPC flurry if special atk "F")
Kayen: Implemented Perl MOB Quest Object GetFlurryChance(value) returns flurry chance.
Kayen: Added rule to adjust server wide flurry chance (Default = 20%) *Perl object will override this.
	
Following AA effects are now implemented as bonuses: You must update your 'aa_effects' table with 'required_aa_updates.sql' for these to work.
MISC AA: Dead Aim, Precision of the Hunter, Scout's Efficiency will now calculate from bonus SE_Accuracy.
MISC AA: Combat Agility line will now calculate from bonus SE_AvoidMeleeChance. (Now implemented through SoD) 
MISC AA: Combat Stability line will now calculate from bonus SE_CombatStability. (Now implemented through SoD)
MISC AA: Double Riposte, Return Kick now calculated from bonus SE_GiveDoubleRiposte. (New AA's implemented that use this)
MISC AA: Natural Durability, should be working correctly now from bonus SE_MaxHP.
MISC AA: Ambidexterity will now apply properly to increase chance to duel wield from bonus SE_Ambidexterity.
MISC AA: Flurry,Rapid Strikes will now properly be applied from bonus SE_Flurry. (New AA's implemented that use this)
MISC AA: Pet AA's that give flurry chance will now be applied by bonus, SE_PetFlurry.
MAG  AA: Elemental Agility was incorrectly giving melee mitigation instead of avoidance, to now use SE_PetAvoidance.
MAG  AA: Elemental Durability will now add to pet max hp with bonus, SE_PetMaxHP.

REQUIRED SQL: utils/sql/svn/2185_required_aa_updates	
OPTIONAL SQL: utils/sql/svn/2185_optional_NPCFlurryChance_rule

==08/12/2012==
Bad_Captain: Fixed an issue when using bots where you would not get xp when your pet did most of the damage and you are not grouped.
Bad_Captain: Added rule to enable receiving xp from bots not in your group. Defaults to false. 

OPTIONAL SQL: utils/sql/svn/2183_optional_bot_xp_rule.sql 

==08/08/2012==
Kayen: Updates to critical hit calcuations to be consistent with live. 
  *Baseline critical rate is determined by DEX stat (255 dex = 2%),this baseline is then modified by item,spell and AA critical chance bonuses. 
  *Pet critical baseline is determined by the rate from AA effects that give pets the ability to critical. (Can not crit w/o this effect)
Kayen: Slay Undead effect will now be working consistent with live. 
  *Slay rate is no longer effected by critical hit rate, it uses it's own predetermined rates from the spell effect data. 
  *Damage modification will now be much closer to that of lives utilizing the spell effects damage modifier. 
  *Example(AA Slay Undead I - Rate: 225 (2.25%) Damage Mod: 680%)
  *Note that that spell effects using Slay Undead (Holyforge) will stack with AA and increase the damage and the rate.
Kayen: Crippling Blow's derived from spell effects will now be calculated consistent with live. 
  *Cippling blow chance is determined by modifying your critical hit chance. 
  *Example (Savage Onslaught - 200% chance to crippling blow) If you have a base chance to critical hit of 10% 
   and you score a critical hit, you will then have a 20% chance to crippling blow.
Kayen: Fixed effect for AA 'War Cry' will now provide group fear immunity for duration.
Kayen: Few new AA's added including shaman Ancestral Aid and Spirit Channeling.
   
Following AA effects are now implemented as bonuses: You must update your 'aa_effects' table with 'required_aa_updates.sql' for these to work.
MISC AA: 'Combat Fury', 'Fury of the Ages' will now calculate from bonus SE_CriticalHitChance. 
MISC AA: 'Veteran's Wrath' will now calculate from bonus SE_CriticalDmgMod.
MISC AA: All AA that give pet criticals will be calculated from SE_PetCriticalHit.
PAL AA: 'Slay Undead', 'Vanquish Undead' will now calculate from bonus SE_SlayUndead. (Holyforge now works correctly)

REQUIRED SQL: utils/sql/svn/2178_required_aa_updates

==08/06/2012==
Kayen: Fixes to rev2176 - Double Attack, EndlessQuiver, Run Speed.
REQUIRED SQL: utils/sql/svn/2176_required_aa_updates will need to be applied again for Run Speed fix.

==08/05/2012==  
Kayen: Complete revision of how double attack chance is calculate to be consistent with live.
Kayen: Berserker 'Frenzy' skill attack will now function as it does on live. Gives a chance for 1-3 attacks using frenzy skill specific damage.
*Note: This will be a considerable nerf to bersekers because it was previously coded to give actual melee rounds using weapon damage.
Kayen: Implemented a few miscellaneous new AA's, mostly from DODH. (These will show in OoW Window in Titanium)
Kayen: Added almost all remaining spell effects into spdat.h (~90% defined).
Kayen: Alternate Advancement Update: In the process of coverting most of the hard coded AA data out of the source and into the 'aa_effects' table
using live data. These effects are then reimplemented using the bonus system in the broadest possible way, most of these effects will
also be useable as regular spell/item effects. This will allow developers in the future to adjust,implement and customize AA effects 
without requiring source changes. Beware in doing this, many AA effects that were previously either implemented incorrectly or with values 
not consistent with live data will be adjusted to be as accurate as possible.

Following AA effects are now implemented as bonuses: You must update your 'aa_effects' table with 'required_aa_updates.sql' for these to work.
MISC AA: All innate run speed AA's have been converted to use bonus SE_BaseMovementSpeed. 
MISC AA: All bind wound related AA have been converted to use bonuses, SE_ImprovedBindWound, SE_MaxBindWound.
MISC AA: Shield Block will now be calculated using bonuses, SE_ShieldBlock.
MISC AA: Sinister Strike will now correctly allow your off hand weapon to recieve a weapon damage bonus, SE_SecondaryDmgInc.
MISC AA: Strengthened Strike/Vicious Smash/Kick Mastery will now accurately to live add skill damage to respective special abilities.
MISC AA: StrikeThrough, Tactical Mastery - will now be calculated from bonus, SE_Strikethrough2.
MISC AA: Ferocity, Knight's Advantage ect - will now be calculated from bonus SE_DoubleAttackChance.
MISC AA: Harmonious Attacks, Bestial Frenzy - will allow double attack chance using bonus SE_GiveDoubleAttack (any class can be given this) 
MISC AA: Weapon Affinity, will now use SE_ProcChance.
MISC AA: PunishingBlade, SpeedoftheKnight will now allow an extra 2 Handed attack using bonus, SE_ExtraAttackChance.
BRD  AA: Fleet of Foot will now correctly allow bards to run over the speed cap using, SE_IncreaseRunSpeedCap.
WAR  AA: Previously non functional 'Stalwart Endurance' and 'Dauntless Preservence' now working using bonus, SE_FrontalStunResist
MNK  AA: HightenedAwareness - Implemented using bonus, SE_BlockBehind.
MNK  AA: Technique of Master Wu - Will now correclty use a random monk special attack, chance for double/triple attack as SE_DoubleSpecialAttack.
MNK  AA: Dragon Punch - Implemented as now using bonus SE_SpecialAttackKBProc, (base1 = 100 [25% proc chance at 100] base2 = skill)
RNG  AA: Endless Quiver - Implemented as SE_ConsumeProjectile which gives a percent chance NOT to consume an arrow. (EQ base1 = 100)
RNG  AA: Archery Mastery- Implemented as SE_ArcheryDamageModifier which gives a percent increase to archery attacks.
BER  AA: Throwing Mastery - Implemented using SE_DamageModifier.
BER  AA: Blur of Axes, Vicious Frenzy - will now correctly add skill damage to 'Frenzy' skill attacks.
ROG  AA: Triple Backstab, SiezedOpportunity, Chaotic Stab - as bonus, SE_TripleBackstab, SE_FrontalBackstabChance,SE_FrontalBackstabMinDmg. 

REQUIRED SQL: utils/sql/svn/2176_required_aa_updates
Optional SQL: utils/sql/svn/2176_optional_FrenzyBonus_rule
Optional SQL: utils/sql/svn/2176_optional_aa_expansion_sof_fix (Allow AA to show proper expansion in SOF+ clients)


==08/01/2012==  
Bad_Captain: Fixed bot compile issue introduced in Rev 2171.
Bad_Captain: Integrated Kayen's skill attack code with bots' code, as well as other changes from Rev 2171.

==07/31/2012==
Akkadius: (KLS) Fix for global_player.pl synchronization. There was an issue where certain subroutines were not passing as global

==07/26/2012==  
Kayen: Fixed: SE_ImmuneFleeing - Will now disable fleeing if used after mob begins to run, will not effect fleeing from fear.
Kayen: Implemented Perl MOB Quest Object SetDisableMelee(1=Disabled) - Prevents the ability to auto attack.  
Kayen: Implemented Perl MOB Quest Object IsMeleeDisabled()
Sorvani: corrected build name for queryserv project in all the various build types.
 
==07/24/2012==  
Kayen: Implemented: SE_HundredHands (incorrectly marked as already implemented) - Increases/Decrease actual weapon delay by % of value.
Kayen: Implemented: Missing modifications from the Archery/Throw damage pathways.
	*SkillAmount/SkillDamageTaken mods, ability to Block/Dodge/Parry ranged attacks (Can not riposte), other new focus/mod effects.
Kayen: Fixed: aaThrowingMastery will no longer be applied 2x per throw.	
Kayen: Implemented: Damage bonus to skill attacks from specific armor slot AC (ie KICK from BOOT AC) can adjust with rule 'SpecialAttackACBonus'
Kayen: SE_MinDamageModifier should now apply to skill specific effects and to special attacks.
Kayen: Implemented: Complete revision of SE_SkillAttack. (+ required various fixes/adjustments to functions related to special attacks)
	*This spell effect performs a physical attack from a specific skill with a set weapon damage value and chance to hit modifier.
	*Attacks will now calculate correctly and use their actual respected pathways utilizing all skill specific mods/bonus.
Kayen: Implemented Perl MOB Quest Object DoMeleeSkillAttackDmg(target, weapon_damage, skill, chance_mod, focus, CanRiposte) 
Kayen: Implemented Perl MOB Quest Object DoArcheryAttackDmg(target,NULL,NULL, weapon_damage, chance_mod, focus)  
Kayen: Implemented Perl MOB Quest Object DoThrowingAttackDmg(target,NULL,NULL, weapon_damage, chance_mod, focus)		

Optional SQL: utils/sql/svn/2171_optional_SpecialAttackACBonus_rule
	
==07/18/2012==
Kayen: Implemented NPC Special Attack 'K'. Immune to Dispell.
Kayen: Fixed SE_RangedProc to be applied after zoning, calculate proc rate correctly, utilize numhits.
Kayen: Fixed a bug that would cause NPC procrates to be incorrectly effected by equipped weapon delay.
Kayen: Modified functions related to obtaining proc chance to no longer recalculate the 'attack rate' every swing.
Instead it will use the already calculated attack timer values. (Not implement for BOTs, but should be no compile problems).
Kayen: Fixed for buff issue with rev2167.

==07/16/2012==
Kayen: Implemented: SE_SpellProcChance, SE_CharmBreakChance, SE_BalanceMana, SE_DotCritDmgIncrease, SE_TripleAttackChance, SE_Taunt
			SE_BardSongRange, SE_ACv2, SE_ManaRegen_v2,	SE_SpellCriticalFocus, SE_AdditionalHeal2, SE_HealRate2,
			SE_CriticalHealOverTime2, SE_CriticalHealChance2, SE_SkillDamageAmount2, SE_LimitSpellSkill, SE_LimitClass
			SE_LimitExcludeSkill, SE_ShieldBlock, SE_BlockBehind
Kayen: Implemented: SE_Empathy - A focus limited debuff which causes (spells/skill attacks) cast on target to do +X amount more damage.
			*This spell effect is often limited using SE_LimitSpellSkill. 
			*(Ie. If empathy value is 1000 and limited to evocation, all nukes on target using evoc. will get +1000 damage)
Kayen: Implemented: SE_SpellPowerIncrease - Can be used to apply a worn/buff focus effect with limits for...
			1) Additional bard instrument modifiers.
			2) Healing/Damage focus to bard songs. (Note: This is only effect that can do this).
			3) Increase effectiviess of casted/disc Skill Attacks.
			4) General use stackable Healing/Damage focus.
			5) Increase the value of melee runes by focus amount.
Kayen: SE_HPtoMana will no longer drain your HP before the spell is finished casting. Effect now handled as a bonus using best value.	
Kayen: SE_SpellVulunerability will now correctly calculate and apply the highest value if target has mulitple effects.				
Kayen: Fixed an issue where DOTs cast by an NPC on another NPC would not generate hate per tick. Improved how we calc damage from DOTs.		
Kayen: SE_BlockSpellEffect was implemented incorrectly and has been revised to SE_NegateSpellEffect.
		*It is not meant to block buffs, rather it negates the specific spell bonuses or effects from buffs you already have.
		*Currently functional with any effect that is handled under bonuses, and focus effects.
Kayen: Vastly improved how we handle melee/spell runes/partial mitigation runes ect. Should be significantly more efficient.
		*Melee/Spell Mitigation runes and ManaAbsorbPercentDamage effects will now use the best mitigation value if multiple effects.
Kayen: Improved the process we use to get spell/item focus effects. An initial check if the client has a specific focusType
is done while checking for item/spell bonuses. GetFocusEffect will no longer check all inventory and buff slots every cast for the 
focusType if that focusType doesn't exist on the client. This should improve performance since these checks are done 10-20x per cast/proc.

==07/15/2012==
Secrets: Fixed an issue with saylinks above 255 characters. If you do want to use saylinks above 255 characters, it is reccomended you adjust the varchar field in the saylinks table to a "TEXT" field, which supports up to 65535 characters.

==07/13/2012==
Bad_Captain: Fixed another bug that allowed pets to steal xp when using bots.
Bad_Captain: Bots: Persisting spell & discipline timers.
Bad_Captain: Bots: Bot pets will no longer continuously try to get behind a mob if they are tanking.
Bad_Captain: Bots: Fixed potential duplicate lore item bug when trading with bots. 
Bad_Captain: Bots: Fixed bot compile issue from Rev 2160.
Bad_Captain: Bots: Fixed multiple issues with #bot spawn and #bot botgroup load (c0ncrete).
Bad_Captain: Bots: Implemented new #bot defensive command for Warriors and Knights. Includes most of the code required to implement disciplines for bots. Requires disc AI & disc lists.

Required SQL: utils/sql/svn/2164_require_bots_bottimers.sql

==07/09/2012==
Kayen: Fixed issue causing npc special attacks (kick/bash ect) to do extra damage.
Kayen: Fixed major crash bug with rev2159.
cavedude: AFTERDEATH npc_emote will now use emoteid instead of npcid.

==07/08/2012==
Kayen: Implemented: SE_SkillProc, SE_SkillProc2 which can be limited by SE_LimitToSkill - Procs an effect when a specific skill is used
       *Functional with all melee skills, special attacks, backstab, taunt, dodge,block,parry,riposte.
Kayen: Added checks to attack process to prevent mob from performing certain actions after being killed (riposte, defensive proc ect).
Kayen: Fixed bug where if client had delay death effect NPC would not be able to attack them if HP < -11, clients without delay death will now bleed again.
Kayen: Implemented: SE_CastingLevel2, SE_ReduceHate
Kayen: Fix to bug where some spell procs and defensive procs were not loading after zoning.
Kayen: Updated spdat.h with many new live spell effects that were previously 'unused'.

==07/05/2012==
Kayen: Implemented: SE_Manaburn: Drains mana for damage/heal at a defined ratio up to a defined maximum amount of mana.
Kayen: Implemented: SE_CastonNumHitFade: Casts a spell when a buff fades due to its numhits being depleted.	
Kayen: Implemented: support for all remaining live spell effects that use 'numhits'.
	   Significantly optimized how all spell effects that utilize 'numhits' are handled throughout the source. 
Kayen: Fixed: SE_DefensiveProc - Proc rate will now be calculated similiar to live.  *Spell specific rate modifcations will now work.
Kayen: Added Rule: Combat:AvgDefProcsPerMinute (Default = 2.0) Determine defensive procs per minute.
Kayen: Added Rule: Combat:DefProcPerMinAgiContrib (Default = 0.075) Determines how much agility effects proc rate.

Optional SQL: utils/sql/svn/2159_optional_defensiveproc_rules

==06/29/2012==
Kayen: Implemented Perl NPC Quest Object GetSlowMitigation() 
Kayen: Implemented Perl NPC Quest Object GetAttackSpeed() 
Kayen: Implemented Perl NPC Quest Object GetAccuracyRating() 
Kayen: Fixed: Slow Mitigation (was not loading from dbase),optimized its application in source and added lives slow mitigation messages.
		Slow mitigation Messages: 'slighty' 0.00 - 0.25 'partial' 0.25-0.75 'mostly' 0.75-1
Kayen: Implemented: SE_AttackSpeed4: 'Inhibit Melee' effect works different then regular haste/slow effect
		1) If target is hasted (or no haste) Inhibit Melee will decrease attack speed by the Inhibit Melee value.
		2) If target is slowed Inhibit Melee is applied as a percent change to remaining attack speed after regular slow.
		ie. You cast 75% Slow (25 attack speed remains) then apply 25% Inhibit melee (18.75 attack speed remains): Final slow 81.75%
Kayen: Added Rule: Spells:CharismaEffectiveness (Default = 10) Deterimes how much resist modification charisma applies to charm/pacify checks (10 CHA = -1 resist mod).
Kayen: Added Rule: Spells:CharmBreakCheckChance (Default = 25) Determines percent chance for a charm break check to occur each buff tick.
Kayen: Reworked code to that handles charm breaks/lull to be accurate to live and more functional in general.
		1) Each charm buff tick there is a default 25% [Rule.CharmBreakCheckChance] chance to trigger a spell resistance check.
		2) Spell resistance check then adds an additional bonus resist modification based casters Charisma at a default 
		   ratio of 10 CHA per -1 resist mod [Rule.CharismaEffectiveness]
		3) If resisted (ie Charm is to break) Total Domination AA is then applied to give another chance to maintain the charm.
Kayen: Implemented: SE_AdditionalHeal:  Focus Effect that adds an additional heal amount to the casted spell.
Kayen: Implemented: SE_CastOnCure: Casts a spell on cured target.
Kayen: Implemented: SE_CastOnCurer: Casts a spell on the curer of the target.
Kayen: Modified: Mob::TryFadeEffect	to avoid interaction wtih Twinproc effect.	
cavedude: (Uleat) Multiple changes and additions to doors, per the forums.

Optional SQL: utils/sql/svn/2156_optional_charm_break_rule.sql

==06/25/2012==
Trevius: Reviewed and Committed the below by Kayen:
Kayen: Added Rule: AvgSpellProcsPerMinute (Default = 6.0) Determines proc rate of spells applied from sympathetic focus effect
Kayen: Added Rule: ResistFalloff (Default = 67) Max that level that will adjust our resist chance based on level modifiers
Kayen: Adjusted Mob::TrySpellOnKill()
		- Will now check AA, Items and Buffs for SE_SpellOnKill (Same logic problem as TrySpellOnDeath)
		- Level of the npc you killed and the spell_id used to kill it now both passed into the function.
		- SE_TrySpellOnKill will now correctly check if there is a min level of the npc required for the spell effect to work (max value in spelldat)
Kayen: Implemented: SE_SpellOnKill2: For deterimental spells where landing the kill gives x% chance to give a buff.
Kayen: Sympathetic proc now calculates chance to proc a sympathetic spell accurately like live using Procs per minute.
Kayen: Adjusted Mob::TrySpellOnDeath() - Now checks all avialable effects and trys to use each one.
Kayen: Fixed SE_TargetsTarget - Target's Target must be in CombatRange to recieve the effect (Verified from live)
Kayen: Fixed TryApplyEffect - No longer incorrectly lands on the target's target's taget. (Example of spells that use this are Shaman Mending Couterbias)
Kayen: Adjusted Twincast to now select the buff with the highest chance to Twincast and use that, it will also stack with item focus and AA (when implemented).
Kayen: Removed the mana cost portion from twin casting a spell.
Kayen: Fix for SE_SympatheticProc - The focus effect now checks all items/buffs for the focus effect and adds all returned proc spellid's to a list from which one is randomly selected.
Kayen: Implemented SE_FF_Damage_Amount - Focus/Buff that adds damage to the casted spell. Usually found on spell group limited augments and stackable with SE_SpellDamage.
Kayen: Adjusted SE_SpellDamage to be handled properly as a focus effect.
Kayen: Extra damage from Focuses is now calculated correctly for DoTs
Kayen: Implemented Perl NPC Quest Object SetSpellFocusDMG(focus amount) - Focus all npc direct/dot damage spells by value
Kayen: Implemented Perl NPC Quest Object SetSpellFocusHeal(focus amount) - Focus all npc healing spells by value 
Kayen: Implemented Perl Mob Quest Object ModSkillDmgTaken(skill_num,value) - Set a weakness/bonus of weapon attacks to a Mob 
		- Example: mob can be set to take 5% more damage from blunt weapons - ModSkillDmgTaken(0,5)
		- Stacks with spell/item bonuses - Setting skill to -1 will effect all skills
Kayen: Implemented Perl Mob Quest Object GetModSkillDmgTaken(skill_num) - Returns only the quest skill mod for specified skill
Kayen: Implemented Perl Mob Quest Object GetSkillDmgTaken(skill_num) - Returns the total skill damage taken mod for the specified skill (item+spell+quest_mod value)
Kayen: Implemented Perl Mob Quest Object SetAllowBeneficial(false) - Allow a specific Mob to be healed/buffed by a client
Kayen: Implemented Perl Mob Quest Object GetAllowBeneficial() - Returns SetAllowBeneficial flag
Kayen: Implemented Perl Mob Quest Object IsBeneficialAllowed(target) - Returns if target can have beneficial spells cast on them
Kayen: Implemented Perl Mob Quest Object ModVulnerability(resist type, value) - Set Spell Vulnerability of mob by resist type(0-9) ALL = -1
		- Example: mob can be set to take 5% more damage from Fire spells (2,5);
		- Applied effect will stack with spell buff effects.
		- If a resist type SPECIFIC and a resist type ALL mod are applied to the same MOB, the SPECIFIC value will be used if spell cast on MOB is the same resist type.
Kayen: Implemented Perl Mob Quest Object GetModVulnerability(resist type) - Return the quest applied value for each resist (ALL = -1) 

Optional SQL: utils/sql/svn/2154_optional_rule_spell_procs_resists_falloff.sql

==06/22/2012==
Secrets: (demonstar55) Spells now display to all clients and can be filtered as such.
Secrets: Damage Shields now go to the proper filter, and do not show the non-melee damage to everyone.

==06/03/2012==
Akkadius: Added the ability to run a dual-stack global_player.pl with the existing player.pl that will run locally in quests/zone/player.pl or quests/templates/player.pl
	- This allows the player.pl to be ran globally without interference of a local script (quests/zone/player.pl OR quests/templates/player.pl)
	- 'global_player.pl' simply needs to be added to quests/templates/global_player.pl to be parsed otherwise it will not be loaded
	- 'global_player.pl' parses after the local player.pl
	- 'global_player.pl' parses all of the same events a regular player.pl does and will work with any new subroutines added to it in the future
	- Thanks Derision for being a pair of eyes on a part of the diff for this

==06/02/2012==
cavedude: Exported quest::addldonwin(wins, theme); and quest::addldonloss(losses, theme);

==05/30/2012==
Bad_Captain: Fixed bug that allowed pets to steal xp when using bots.
Bad_Captain: Bots: Fixed bug that allowed bots to sometimes cast HoT buffs during combat instead of HoT heals.
Bad_Captain: Bots: Tweaked bard casting chances to restore twisting of multiple songs.
Bad_Captain: Bots: Implemented Shaman cannibalization during combat.

==05/13/2012==
cavedude: Corrected the text merchants give when they refuse to sell to you.
cavedude: The graveyard timer will now resume when a dynamic GY zone boots, instead of resetting.
cavedude: When a corpse is moved to the graveyard, it will no longer attempt to use an instanced version of the zone.
cavedude: Added the ability to load NPC emotes from the DB. Wiki entry for this will be at http://www.eqemulator.net/wiki/wikka.php?wakka=NPCEmotes when I write it up.

REQUIRED SQL: utils/sql/svn/2142_emotes.sql

==05/06/2012==
Akkadius: Added the ability to load a default.pl script underneath quests/templates

==05/05/2012==
Derision: Fixed reference to freed memory in Mob::BardPulse, plus a couple of minor memory leaks in  Load/SavePetInfo
==05/01/2012==
Derision: Corpses no longer appear in Extended Target Auto slots.

==04/30/2012==
Derision: Fixed some minor bugs with Extended Targeting (if the tank/assist/puller had a target before you allocated an XT slot to that function, you would not see the target unti they changed target).

==04/29/2012==
Derision: UF+: Support for the Extended Target window (aside from the Raid target types).
Derision: Fixed Extended Target bugs where CurrentTargetPC targets were incorrectly cleared when leaving a group, and a CurrentTargetPC wasn't updating when they zoned in.

REQUIRED SQL: utils/sql/svn/2136_extended_targets.sql

Note: Default number of Extended Targets is 5. This is stored as a column in character_
GMs can increase a players slots by targetting them and typing #xtargets <n> where n is between 5 and 20.

==04/22/2012==
Trevius: VoA - The AA Window now populated AAs.  AA hotkeys can be created, but purchasing still needs work.

==04/21/2012==
sorvani: Bard AE DoTs should now be affected by mods correctly.

==04/19/2012==
cavedude: quest::buryplayercorpse will now despawn corpses in zones other than the client's current location, preventing dupes. 
cavedude: Added quest::summonallplayercorpses (same syntax as quest::summonburriedplayercorpse) which will depop and summon all of the player's corpses, buried or not.
cavedude: Fixed a bug that caused some summoned corpses to use a static 5 minute decay timer.
cavedude: Changed player_corpses_backup schema to match player_corpses. If the rule is enabled, corpse backups will now be created for players that are high enough level to drop items to their corpses.
cavedude: Added a rule to determine whether or not to remove player corpse backups older than 2 weeks.
cavedude: #corpse now has options to depop a single player corpse, or every corpse belonging to a single player. 
cavedude: You can now specify if a faction hit is temporary (is removed when player camps/zones) or whether or not to display the faction hit to the player in-game.
If temp in npc_faction_entries is set to:
0 (Default): Faction is permanent, player recieves a message. (Same functionality as we had previously.)
1: Faction is temporary, player does not recieve a message.
2: Faction is temporary, player recieves a message.
3: Faction is permanent, but player does not recieve a message.
cavedude: Added an optional argument to quest::faction to utilize the functionality and values listed above.
cavedude: Added minlevel and maxlevel to lootdrop_entries. The player credited with the kill (most hate) has their level checked against both columns, and if they are lower than the specified minlevel, or higer than the max, that item entry if it exists is removed from the NPC before it becomes a corpse. 
cavedude: You can now specify if a NPC automatically repops (rerolls against their spawngroup) or depops after the reverse spawn timer is up.
If despawn in spawngroup is set to:
0 (Default): Do not depop or repop, no depop timer is set. (Same functionality as we had previously.)
1: Despawn the current NPC and repop the spawngroup after the associated spawn2 timer is up (including variance.)
2. Repop, after the value specified in despawn_timer is up (also uses spawn2 variance.)
3: Depop the NPC after the spawn2 timer is up + variance.
4. Depop the NPC after despawn_timer is up + variance.
Example: Setting despawn to 1 will despawn the NPC and immediately respawn the spawngroup after it has been up for the length of its spawn2 timer + variance.
Example: Setting despawn to 4 and despawn_timer to 3600 will depop the NPC after it has been up for an hour + variance. It then will respawn after its normal respawn timer is up.
cavedude: Fixed a crash in groups.cpp.

Required SQL: utils/sql/svn/2133_required_faction_loot_despawn.sql (Backup your data first!)

==04/17/2012==
Bad_Captain: Bots: Added Bot Group Messages and #bot groupmessages command to turn them on or off per bot or for all bots.
Bad_Captain: Bots: Fixed bugs that allowed more bots to be spawned than specified in the Bots:SpawnBotCount rule, fixed bug that allowed more bots to be created than specified in the Bots:CreateBotCount rule, and fixed slow buffing bug.
Bad_Captain: Bots: Various spell ai tweaks (including HoT spells should no longer block other heals from being cast in certain situations and hybrids should use less mana by healing less often).
Bad_Captain: Bots: Removed client xp gain from bots outside the player's group.


==04/14/2012==
Trevius: Fixed inspect for SoF+ clients, which was broken by Rev2128.

==04/15/2012==
Derision: Added support for the 'Looking For Guild' window.

Required SQL: utils/sql/svn/2129_required_lfguild.sql

IMPORTANT NOTE:

To use this feature, you must be running the querserv process. If you are not running queryserv, LFGuild will not work, but your server will
run normally in all other respects.

Underfoot users can bring up the LFGuild Window by pressing the EQ buton and selecting Players/Looking For Guild.

I think all other clients can only access the feature by clicking on the notice boards in the Guild Lobby. To allow them to do this, you must
add the following to the SUB EVENT_CLICKDOOR of your guildlobby/player.pl

if(($doorid >= 5) && ($doorid <= 38))
{
	$client->OpenLFGuildWindow();
}

==04/14/2012==
Trevius: VoA - Corrected a few alignment issues with the item struct and it should be fully aligned now.
Trevius: VoA - Identified a few new item fields including: Prestige, SkillModMax, SkillModExtra, and Power
Trevius: VoA - #summonitem and functions that summon items such as quests are now fixed.
Trevius: VoA - Identified multiple Membership fields, which corrects multiple issues such as limited inventory slots, assigned AA limit, level limit, shared bank, and more.
Trevius: Added packet length verification to all packet handling that was missing it.

==04/13/2012==
Secrets: VoA - Character Creation is now functional. Fixed creation request struct (opcodes were right), and membership is now sent (characters can now be created!)
Secrets: VoA - Membership levels are now sent to the client via the SendMembership opcode. Hardcoded to be like older clients for now. Might need bag slots looked into; upon applying this, bag slots & items went missing.
Secrets: Updated #race command to support races up to 714 (as per the 4/12/2012 client)
Trevius: VoA - Items now display food/drink correctly and consuming them is now functional.
Trevius: VoA - Items no longer display UKNOWN SKILL for skill mods on some items that don't have skill mods set.
Trevius: VoA - Items no longer display Prestige on them.
Trevius: VoA - Buying from merchants is now functional, though selling to merchants is not yet.
Trevius: VoA - Disabled the Guild Member List temporarily to prevent guilded characters from crashing.

==04/12/2012==
Trevius: VoA - Casting Spells and Click Effects on items is now functional.

==04/11/2012==
Trevius: VoA - Corrected the Player Profile which should now be perfectly aligned.
Trevius: VoA - More Opcode and Struct corrections/adjustments.

==04/09/2012==
Trevius: VoA - Identified/corrected some more opcodes and packet structures.
Trevius: VoA - Merchants now display items for sale, but purchasing is not yet functional.
Trevius: VoA - Added new packet for setting the max number of characters allowed to be created on an account (10 for now).

==04/08/2012==
Trevius: VoA - Identified/corrected some more opcodes.
Trevius: VoA - Items can now be moved around through all slots.
Trevius: VoA - Updated structs that use inventory slots to use the new format.  Still need to verify some of the struct changes.

==04/07/2012==
Trevius: Initial addition of the VoA (March 21 2012) client. To enable, you must uncomment the VoA lines in /common/patches.
Trevius: Many of the core systems are basically functional, but this client is still in an early development phase and not recommended for normal players yet.
Trevius: Non-Player Race spawns will cause the client to crash, so it is recommended to test it in an empty zone.
Trevius: Also, items in the bank will cause it to crash, but normal inventory seems to work fine so far.
Trevius: You cannot create a character on this client yet, so you must use an existing character.
Derision: VOA: Fixed zoning. Adjusted spawn encoding.

==04/02/2012==
JJ: Removed additional library and include directories from windows projects as they were not standard locations for all.

==03/29/2012==
Sorvani: Resurrections effects will again be applied to characters who are in a zone where combat is not allowed (GL, PoK etc) when they receive a rez.

==03/19/2012==
Bad_Captain: Bots: A few fixed for #bot stance command 

==03/19/2012==
Bad_Captain: Bots: Implemented bot stances. See forum post. 

Required SQL:
utils/sql/svn/2107_required_bot_stances.sql

==03/2/2012==
Bad_Captain: Fixed potential crash in group roles code when a group member is removed.

==02/28/2012==
Sorvani: Added check for ST_AEBard song before sending spell SPELL_NO_HOLD
Bad_Captain: Implemented Group Roles via UI (SoD+)- Set group roles, maintains across zones, save/load grouprole sets (load doesn't appear to work on UF- may be a client bug as client doesn't send request to the server for saved group roles as SoD client does)
Bad_Captain: Fixed FindType to allow for spell effects > 127. Observed by bots trying to cure corruption (effectid 369) when client has a mount (summonhorse effectid 113: 369-128-128=113).
Bad_Captain: Bots- fixed bot summoning of client corpses, fixed ability to spawn more bots than allowed via server rule (#bot botgroup load was not checking for SpawnBotCount rule), fixed bot issue with receiving buff with Group with Pets target type.

Required SQL:
utils/sql/svn/2104_required_group_roles.sql

==02/11/2012==
Secrets: Fixed two more hanging issues introduced regardless of the item discovery feature was on or off.
Secrets: Fixed a hanging issue introduced regardless of the item discovery feature was on or off. Keep in mind the item discovery feature still takes a reasonable amount of time to work, and this will be fixed in a future update.
Secrets: Added OP_IncreaseStats for use with the #incstats command (and other things, in due time!)
Secrets: Added QueryServ to the VS2008 project in preparation of moving eventlog, hackers, discovered items, and other non-essential database tasks over to it.

==02/03/2012==
Trevius: Added accout_status field to the discovered_items table to make it easier to remove accidental GM item discovery from the table.

Required SQL:
utils/sql/sv/2099_required_discovered_items_account_status.sql

==01/28/2012==
Trevius: The version field in the zone_points table can now be set to -1 if you want all versions of the zone to inherit the same zone points.
Trevius: Added extra option to the "#npcspawn create" command that will try to create the npc_type ID within the standard range for the current zone (zone_id * 1000). Usage: "#npcspawn create 1"

Required SQL:
utils/sql/sv/2098_required_zonepoint_version_changes.sql

==01/14/2012==
Trevius: Added Grid ID to the #npstats command output.

==01/06/2012==
Trevius: Increased MAX_ITEM_ID to 200000 to match the new item ID max.  This is only used for Min Status on items.

==01/02/2012==
Trevius: Fix for loading buffs on suspended pets.

==12/12/2011==
Trevius: Pets set to a petpower of -1 in the pets table will scale stats to the petpower like they used to.

==12/11/2011==
Bad_Captain: Fixed hatelist/aggro bug I introduced in rev 2087 causing NPCs to attack the closest client instead of the top of their hatelist.
Bad_Captain: Updated some live opcodes for EQExtractor.

==12/06/2011==
Leere: Added IsFromSpell to Attack() to allow its use from spell effects. This allows the Rampage AA to actually hit mobs again.
Leere: Added a rule for the minium hasted delay that can be reached for weapons. Default set to 400 based on best guesses from the Moss-Covered Twig tests posted on the net.
Congdar: (ptarp)compile warnings in windows
Bad_Captain: Fixed Enchanter's Mezmerization AA - it was extending buffs 35%, now extends mez spells by 1 tick / rank.
Bad_Captain: Fixed NPC aabonuses issue(s) - NPCs were trying to access nonexistent aabonuses within combat code (hatemod as an example)
Bad_Captain: Temporary Fix on crash due to non-player spell proc from Monster Summoning Pets until I can figure out the cause.
Bad_Captain: Bot changes / fixes including maintaining HP & Mana after camp/zone/death, ability to maintain aggro over clients, taunting toggle command (#bot taunting [on|off]), delay death AA, and others. Please see http://www.eqemulator.org/forums/showthread.php?p=205139#post205139 for all Bot changes.

Required SQL: 2087_required_bots_hp_and_mana_and_spell_updates.sql

==12/05/2011==
Trevius: Crash fix for trying to zone into a flagged zone without having the flag.

==12/04/2011==
Secrets: Added QueryServ for VS2010 x86/x64. QueryServ allows queries to be sent to it for use on an external database, through the means of packets.
Currently, the only thing it logs is a #command input, but that will be expanded onto soon. A suggestion for our developers would be to move any statistic logging stuff (hackers table, eventlog, etc) over to it eventually
to save processing power on the main executable's machine. This will allow for things like discovered items to work a bit more better resource-wise.
Akkadius: Added #advnpcspawn setversion (version#) - This will change the instance version in which the targeted NPC resides in
Akkadius: Added #npcedit setanimation (stand, sit, crouch, dead, loot (0-4)) so that setting animations are much easier. This also makes animations much more reliable setting them with the spawn packet rather than through Perl.
Akkadius: Added /MP switch to VS2008 so that it will compile with multiple processors
Akkadius: Fixed compiles for VS2008 from the Queryserv commit
Secrets: Added #qtest <string>, which will populate the remote database through QueryServ with information as a test only. Requires 255 status by default.
Trevius: LDoN points are now capped at 2,000,000,000 instead of ~16,000, and no longer roll back to 0 if they exceed the cap limit.

Reccomended SQL: (ON QueryServ's database, NOT the main db) utils/sql/queryserver/2079_queryserver.sql


==12/01/2011==
Secrets: v90 toolset bugs reported on forums. In order to use Perl 5.14, you MUST upgrade to VS2010 (preferrably ultimate), if you do not have vs2010, it will default to Perl 5.10 and you will be unable to use the much more stable Perl 5.14, an upgrade is reccomended.
Secrets: Fixed Windows x64 rulesys bug where it would store them as an x64 version of an int (long long) and mess up the ordering of pointers, resulting in certain rules not loading properly.
NOTE: For those having issues compiling vs2010, there will be a guide up shortly to help you set up your dev environment. In the meantime, make sure your "Additional Include" and "Additional Library" paths
are correct and pointing at the right location. Failure to do so will result in mysql header/lib and perl header/lib issues. If you are looking for zlib x64, it's in SVN. 

==11/30/2011==
Secrets: Implemented Visual Studio 11 and Visual Studio 10 project/sln files.
Secrets: Added x64 configuration settings to VS11 and VS10 project files/SLN files. 
Secrets: Changed WIN32 define to _WINDOWS across the board. In the case where WIN32 is needed over WIN64 (ie; assembly references) there is still WIN32 defines and a new WIN64 define.
Secrets: Upgraded ActiveState Perl lib define to 5.14 -- others still work but it is strongly reccomended to use 5.14 as it contains less memory leaks.
Secrets: Added Zlib 1.2.3 x64 to the SVN for use with the windows solution files.
Secrets: Fixed vs2008 project files to reflect the new _WINDOWS define
Secrets: Perl 5.14 Compile Fix

NOTE: Since VS11 is in beta, I only set up the debug options. You should use Vs2010 Ultimate to compile in x64 mode.
NOTE2: Perl 5.14 is stable, but if you absolutely need to use 5.10, ctrl f search for "perl514.lib" and replace it with "perl510.lib"
NOTE3: A forum post will be made for help with compiling Windows x64 on EQEmulator.org, it is an experimental feature but has less issues than x64 linux, imo.

==11/28/2011==
Leere: Fixed a problem with no drop items inside of bags when trading with NPCs. Pets retain buff based procs through zoning now.

==11/26/2011==
Leere: NPCs now have the ability to ignore level limits for stuns. This ability can be turned off via rule. Also added a rule for what the base stun immunity level is for spells with a max level of 0.
Leere: NPCs (and thus pets) are now able to equip items in non-visble slots. They will also look inside of bags that are traded to them for those items.
The pets table was expanded. It can now map to several npc IDs for the same pet type string, based on pet power. (This has replaced the old approach of letting pet power be a direct boost to NPC stats. The intention is to now have distinct npc_type table entries for the various pet power levels that a pet supports.) Pet naming and pet control was likewise moved out of code logic and to the pets table. (The default pet control is now petFamiliar rather than petOther.) Pets can now have items already equipped when summoned. The equipment sets used for that can be shared between pets and also be nested up to a depth of 5.
Pets are no longer stored as part of the profile blobs.
Pets (charmed and summoned) belonging to clients should no longer attempt to assist other NPCs if they hear a call for help.

Required SQL:
utils/sql/sv/2069_required_pets.sql

==11/21/2011==
Akkadius: Implemented NPC Special Attack 'Z'. This will keep clients from being able to attack an NPC altogether similar to live.

==11/17/2011==
Congdar: Fix charms Platinum Disc and Gold Pin. You'll need updated items\CHRMGold.pl and \items\CHRMPlatinum.pl once pushed to the quest repository.

==11/17/2011==
Lerxst: Fixed crash when calculating random focus effect from an augment when the base item had no focus effect.
Also added some bulletproofing in case that isn't the only place an invalid spell id might be passed.

==11/16/2011==
Akkadius: Added the ability to specify doors/objects/ground spawns to load for all versions of the same zone regardless by setting the value to -1. 
This reduces serious redundancy of copying the same data over and over for instances.

Required SQL:
utils/sql/svn/2062_required_version_changes.sql

==11/15/2011==
Trevius: Potential zone crash fix for Discovered Items pointed out by Congdar.

==11/09/2011==
Trevius: Fixes for issues caused by the extra SoF+ item click checks.

==11/05/2011==
Trevius: Added extra checks for SoF+ item clicks.

==11/01/2011==
Trevius: Added Discovered Items table to track who discovered an item for the first time and when.
Trevius: Added new EVENT_DISCOVER_ITEM player event.  It exports the item id to the $itemid variable.
Trevius: Added Rule Character:EnableDiscoveredItems to make item discovery tracking optional.

Required SQL:
utils/sql/svn/2057_required_discovered_items.sql

Optional SQL:
utils/sql/svn/2058_optional_rule_discovered_items.sql

==10/31/2011==
Leere: Changed raid leadership ability costs to match client expectations.
Leere: All stuns should now treat a max level of 0 as meaning level 55.

==10/24/2011==
Akkadius: Mysql CLI changes
Akkadius: Preliminary work to some future additions, added int32 Database::GetGuildDBIDByCharID(int32 char_id)

==10/23/2011==
Akkadius: Another memory leak in parser.cpp, NewEventList never deallocated
Akkadius: Reduced code checking redundancy in several places regarding functions that reference ExecWeaponProc, only valid invalid spells are checked and logged.
Akkadius: (Lerxst/Akkadius) Approximately 8 memory leak fixes based on findings from 'cppcheck', some found in loot, popup windows and a few other places.
Akkadius: (Lerxst) Various quest object fixes, sanity checks and initiator adjustments
Akkadius: (Lerxst) Minor trading code adjustments
Akkadius: (Lerxst) Logic fixes with bot code
Sorvani: Critical hit filter should work again.
Secrets: Reverted my changes.

==10/22/2011==
Derision: Underfoot: Extended Buffs should now last the correct time without needing to zone.

==10/21/2011==
Derision: Fixed rez bug.
Akkadius: Fixed a spell crash that has been reported on The Hidden Forest with TryFadeEffect
Akkadius: Fixed a spell crash with ExecWeaponProc when a spell or weapon procs a spell that does not exist, you can catch the invalid spells in your spells log if you have them enabled

==10/20/2011==
Trevius: Fix for Perl Doors GetID() command.
Akkadius: Mysql #command CLI - Fixed an issue where the query string was being escaped
Akkadius: Mysql #command CLI - Added switches -s and -h. Switch -s providing space between the select lines in a query, -h highlighting every other row to be more readable

==10/19/2011==
KLS: (lerxst2112) Client::Message memory leak
Trevius: Potential crash fix for MoveTo() being used on an NPC that has a grid with wandertype 3.

==10/14/2011==
Leere: More than 6 members of a raid can now receive raid experience.
Sorvani: Added AE Rampage message and filter

==10/11/2011==
KLS: Added Ebon/Radiant crystal reclaim for the clients I have.(Titanium/SoD/Underfoot)
KLS: Seperated buffs from the player profile.
KLS: Seperated buffs allowed me to fix the counters on buffs for the newer clients across zone lines, as well as melee and magic runes are no longer limited to 65k as they are no longer uint16s.
KLS: Added ability to save variables to items. Via $client->SetCustomItemData(13, "SomeVariable", 1024); #give our mainhand some variable.
KLS: Added ability to retrieve items from the inventory in perl with $client->GetItemInInventory(slot_id);
KLS: Fixed Item::IsAugmentable() to return correctly if the first augment slot is not used.
KLS: Updated for latest code and readded Derisions' cross-zone /inviting.  I've been testing it for a while now and can't find any real issues with it so I readded it.
KLS: Added class and race combo's into the database so they can be potentially changed; only SoF+ clients will correctly display this.
KLS: Fixed a bug in WorldDatabase::GetCharSelectInfo.
KLS: Changed internal faction values to go in order this change will break some quests in the short term but should be more intuitive in the long run.
KLS: Changed player.pl loading slightly: it will now look for player quests in the following order: .\quests\{zone}\player_v{instance_version}.pl, .\quests\{zone}\player.pl, .\quests\templates\player.pl
KLS: CanClassX functions are no longer hardcoded, they will now check the skillcaps data instead.
KLS: EntityVariables are now identified with a string instead of an int ex: $npc->SetEntityVariable("SomeId", 5), this shouldn't break any existing quests.
KLS: Fixed an issue where bard songs could get stuck in the *on* position even if the bard had turned singing off.
KLS: Fixed an issue where merchants would load and send items more than once in cases where npcs had merchants that shared merchant_ids in a zone.

==10/09/2011==
Akkadius: Fixed an optional argument in client 'NukeItem'
Akkadius: Added two #npcedit commands; armortint_id and alt_currency_id
Akkadius: Exported $client->GetAggroCount();, this will get how many NPC's are aggroed on the client. This can also be used to determine when in combat.
Akkadius: Mysql ingame basic CLI to run select queries or execute queries from in-game, default account access 250, be careful when using this.
Akkadius: (Lerxst) Added a crash fix for spells that do not find a valid item in the database SE_SummonItem

Optional SQL:
utils/sql/svn/2023_optional_mysqlcli.sql

==10/01/2011==
Trevius: Added Destructible Objects for Underfoot.

==09/25/2011==
Derision: Implemented Tune Of Pursuance AA.

==09/24/2011==
JJ: Added hacker entry for possible instant camp disconnects.

==09/23/2011==
Trevius: Destructible Objects now change damage states as they reach 75%, 50%, 25% and 0%.
Trevius: Added Perl Mob quest object SendUntargetable(to_client, in) to toggle the ability to be targeted.

==09/22/2011==
Trevius: Initial implementation of Destructible Objects (SoD only for now).  Most of the work was done by Derision.
To Create a Destructible Object, use the 'lastname' field in npc_types to set the model (ie. DEST_DEV_TENT1), and add "o" in the 'npcspecialatks' field.

==09/21/2011==
Leere: Damage shields should no longer break root spells.

==09/20/2011==
Trevius: New rule added to allow a cap for GM skill training on specializations (default is 50).
Trevius: #maxskills will now only set specializations to 50 each to prevent them from all resetting to 1.
Trevius: GM Trainers will no longer allow training more than 1 (or 2 if you have the AA) specializations above 50.
Bad_Captain: Added rule for Bot AAs by expansion, bot bash fix (bots with bask/slam skill could bash regardless of weapon(s) or shield), various bot AA fixes, added a few bot AAs


Optional SQL:
utils/sql/svn/2015_optional_specialization_training_rule.sql
utils/sql/svn/2016_optional_rule_bot_aa_expansion.sql

==09/12/2011==
Leere: (Tabasco) Added a deque for signals received by an NPC.
Sorvani: Various message type fixes, most notably NPC Flurry/Enrage/Rampage and Pet Flurry/Rampage.

==09/05/2011==
Akkadius: (Akkadius/Lerxst) Fixed Beastlord 1.5 and 2.0 pet clickies.

==09/03/2011==
KLS: Added working Alternate Currency system for SoD and SoF(Untested but hopefully works).
KLS: Added two fields to merchantlist that allows one to filter which items are offered to players by minimum faction and minimum level.
KLS: Max stacks on items increased from 254 to 32767.
Akkadius: Modified items id cap to 200,000
Akkadius: Changed Perl Client Object 'NukeItem' to use the new fields implemented by KLS's Alternate Currency revision:
$client->NukeItem(itemnum, [where_to_check, 1 = invWhereWorn, 2= invWherePersonal, 4 = invWhereBank, 8 = invWhereSharedBank, 16 = invWhereTrading, 32 = invWhereCursor]); Ex: $client->NukeItem(1001, 2);
Akkadius: (Lerxst) Fixed Enduring Breath bot code, adjusted level requirements and added Beastlord class case.

Required SQL: utils/sql/svn/2004_charges_alt_currency.sql

==09/01/2011==
Derision: Spell resist messages now use the same MT as fizzles (for chat filter purposes).

==08/28/2011==
Bad_Captain: Rewrote Bot AAs to use aabonuses and GetAA(). Also added a few AAs.
Bad_Captain: Fixed Bot chance to hit. (they never missed with their primary weapon attacks, and only missed ~5% with their offhand)
Bad_Captain: Added WipeHateList to bot group attack, bot group follow, and bot group guard to allow target switching and keeps bots and their pets from attacking their target when you no longer want them to. (suggested by Criimson)

==08/23/2011==
Trevius: Exported to Perl Mob: SetDeltas(delta_x, delta_y, delta_z, delta_h), SetLD(value), SetTargetDestSteps(target_steps).
Trevius: (SuperUserJD) SpellOnTarget fix for casting beneficial spells on group members while in a raid.

==08/21/2011==
Derision: Added rule to prevent looting corpses when a player has an item on the cursor (to prevent item loss using Loot All).
Derision: Alcohol intoxication is maintained across zoning (can be turned off with a rule).
Derision: Intoxication level affects STR/STA/DEX/AGI/WIS/INT.
Derision: Added 'Update' button to #showstats window for SoD+ clients.

Optional SQL: utils/sql/svn/1998_optional_intoxication_and_looting_rules.sql

==08/18/2011==
Leere: Removed lore item from the restrictions for pick pocket.

==08/13/2011==
Derision: Player pets will now show their owners name. UF users can turn this off in options.
Derision: SoD/UF: Beneficial Pet Buffs can be clicked off in the Pet Window.
Derision: Underfoot: Can now click off buffs in the short buff box. Removed registraion of HoT in patches.cpp

==08/12/2011==
Bad_Captain: Fixed double class / race stats for bots.

==08/09/2011==
Derision: Underfoot: OP_ClearSurname

==08/05/2011==
Akkadius: Corrected a grammatical error with training disciplines.

==08/04/2011==
Bad_Captain: Updated Bot::MeleeMitigation to match mob version.

==08/02/2011==
Trevius: (Akkadius) Exported Freeze() and UnFreeze() to Perl Client.

==07/27/2011==
Caryatis: Added Special Attack 'p' (Makes mob immune to pacify)
Caryatis: Added Special Attack 'j' (Tether - returns mob to spawn point if its distance away from spawn point is greater than its aggro range)
Caryatis: Added Special Attack 'J' (Leash - same as Tether except heals mob to full, strips all buffs and wipes the hatelist as well)
Caryatis: Fixed TGB(if you cast a group buff with a corpse or an npc thats not a client's pet as target, it will use your group instead)

==07/26/2011==
Congdar: redo world container check

==07/24/2011==
Caryatis: Added support for higher level invis and see invis(eg Ethereal Invisibility & Skylight Sagacity)
Congdar: update check to world containers

==07/23/2011==
Congdar: (Criimson)Bot dyes (and tweaks)
Congdar: (lerxst2112)Bot dyes (and tweaks)
Bad_Captain: Fixed Bot GetAC() and GetATK() to work with #ShowStats

==07/22/2011==
Congdar: update check for Lore

==07/17/2011==
Congdar: (pfyon, Criimson)Various bot tweaks
Caryatis: Updated My/Showstats window.
        
Required SQL: 
utils/sql/svn/1974_required_bot_spells_update

==07/16/2011==
Trevius: Exported AssignToInstance(instance_id) to Perl Client.

==07/14/2011==
Caryatis: Implemented the Extra Skill Damage itembonus(+bash, +kick dmg)

Optional SQL:
utils/sql/svn/1972_optional_extradmg_item_cap.sql

==07/14/2011==
Leere: Fix for reading books in SoF and later clients.

==07/13/2011==
Derision: OP_DisciplineUpdate for SoF and Underfoot (expanded Disc struct in UF player profile, added encode for Disc update).

==07/12/2011==
Caryatis: Added Perl Object: $mob->SetBodyType(bodytype).
Caryatis: Fixed issue with swarm(and wake the dead) pets where they would not despawn if they spawned as the target died.
Caryatis: Changed when mobs enrage to 9%(from 14%) to match live, with a rule to customize the value if wanted.
Caryatis: Added rule to allow matching of new live rules for enrage(it was removed from all non player-pet npcs).

Optional SQL:
utils/sql/svn/1968_optional_enrage_rules.sql

==07/11/2011==
erde: FreeBSD compile fix for Rev1963 (no strncpy in FreeBSD).

==07/10/2011==
Derision: Underfoot - Support for /emote
Derision: Underfoot - Support for Guild Creation via new window in Underfoot.
Derision: SoD+ - Changing group leader should update Group Leadership AA to that of the new leader.
Caryatis: Live like focus effect behaviour added(Improved Damage, Healing and Reduce Manacost focus effects will now be random if the spell contains both a min(effect_base_value) and max value(effect_limit_value)

Optional SQL:

utils/sql/svn/1962_optional_guild_creation_window_rules.sql
utils/sql/svn/1963_optional_rule_live_like_focuses.sql

==07/09/2011==
Derision: Underfoot - Instrument modifiers / AAs should now improve runspeed.

==07/06/2011==
Trevius: Fix for EVENT_ITEM_CLICK_CAST bugging Titanium clients.

==07/05/2011==
Trevius: Fix for EVENT_ITEM_CLICK_CAST for SoF+ clients.
Trevius: (Akkadius) Added new rule Console:SessionTimeOut for adjusting console session timeout.

Optional SQL: utils/sql/svn/1960_optional_console_timeout_rule.sql

==07/02/2011==
JJ: Split wander type 4 to allow depop with/without spawn timer. Type 4 is with, type 6 is without.

==06/26/2011==
JJ: Added functions to count all corpses, get corpse ids, and allow checking of items on player corpses

==06/25/2011==
JJ: (Leere) Fix for bards in reagent code

==06/24/2011==
KLS: Dest zone would buffer overflow if it was >= 16 characters, fixed.
KLS: Comment clean up + added EntityList::FindDoor($doorid) to perlXS
KLS: Fixed the PerlXS export for GetDoorByID and GetDoorByDBID
Sorvani: Added door object perl functions GetKeyItem(), SetKeyItem([value]), GetNoKeyring(), SetNoKeyring([value]). Example Usage: my$doorobj = $entity_list->FindDoor(6); $doorbj->SetKeyItem(10615); $doorbj->SetNoKeyring(1);
JJ: (Akkadius) Exported some task functions to perl.

==06/23/2011==
JJ: (Sorvani) Stop forcing client to tutorial when button not selected.

==06/22/2011==
Trevius: Added new Perl Mob quest object RemoveNimbusEffect(effectid) for removing permanent nimbus particle effects.
JJ: EVENT_CLICKDOOR now passes the zone version to perl.

==06/20/2011==
JJ: Added message to client when using #instance destroy command.
JJ: Altered doors index to include version to help bring door ids below 256 in zones with multiple versions. Required SQL provided.

Required SQL: utils/sql/svn/1946_doors.sql

==06/19/2011==
JJ: (Leere) Fixed reagent consumption oddities

==06/18/2011==
JJ: Depop with spawntimer reset option now works properly. Default use is changed to false.
KLS: Added some minor stuff
KLS: Added animation field to spawn2 that will control what the spawned npc will do at their guard point. 0 = eaStanding, etc etc
KLS: Tweaked books in SoF+ as they weren't displaying right; it may still not be perfect though I haven't tested it with every book in the game. Required SQL Provided.

==06/17/2011==
KLS: Lowered resolution on QuestTimer process timer to actually allow you to use sub 1 second times.
KLS: Added quest::settimerMS(timer, duration) to allow timers not in integer second intervals.
JJ: Moved ENTERZONE event for items to execute before SCALE_CALC.

==06/15/2011==
Secrets: Modified the pound command #reloadstatic to respawn doors after it despawns them.
Secrets: Made the default door dest zone be "NONE" for quest::createdoor's constructor
Secrets: Added potential fix for UCS assertion error under windows after being up for so long.

==06/14/2011==
Secrets: Opcode to remove all doors.
Secrets: Perl door support.
Secrets: Perl objects added for Doors since first PerlDoors commit: SetSize, GetSize, SetIncline, GetIncline, GetOpenType, SetOpenType
Secrets: Added quest::createdoor(model, x, y, z, h, [opentype], [size]) . This spawns a door similar to quest::creategroundobjectfrommodel, and can be manipulated in the same way as other doors. To save it, get the door object using $entity_list->GetDoorByID(id), as it returns an entity ID (and preliminary DBID/DoorID is stored on the object itself) upon creation of the door. otherwise the door is temporary, and does not save the stored DBID.  $doorobj->CreateDatabaseEntry() saves it and its temporary DBID + DoorID.
Secrets: Added door object perl functions GetLockpick() and SetLockpick([value]).

==06/10/2011==
JJ: Added more tables to remove entries from when deleting character.

==06/06/2011==
Secrets: Adjusted the default value for Character:SkillCapMaxLevel. It now defaults to 75 because PEQ only has skillcaps up to 75, and if the level is higher than 75 it will always return 0, breaking skills. (layer 8 issue fix)
Secrets: Made stat cap adjustable via rules, Character:StatCap. The client won't be in sync but that's what #mystats is for. 0 = feature disabled, defaults to 0.

==06/05/2011==
Derision: Fixed /yell

==06/04/2011==
Secrets: Fixed pet HP resetting if the pet is above 32k when zoning.
Secrets: Fixed player HP rollover bug (~495k hitpoints, rarely encountered) with AAs by temporarily casting it as a float.
	 NOTE: the client only displays 10 million hitpoints in titanium. Keep that in mind when designing items. Only issue is displaying them, unlike the rollover bug you won't die and it will show on show/mystats.
Secrets: Fixed damage on weapons above 255. They only display on SoF+ clients, and Titanium will simply show a cosmetic issue (an incorrect value). You can set an item to any value up to the max for an uint32 and it will work.
Secrets: Added rules for the low-level damage cap. There is a rule for the pre-10 cap, and one for the pre-20 cap. Defaults to 20 and 40 respectively.

REQUIRED: You will have to recompile sharedmem with this update. Items will fail to load otherwise.

==05/31/2011==
Trevius: Added EVENT_CLICK_OBJECT to player quest events.  It exports variable $objectid which holds the entity id of the clicked object.

==05/29/2011==
Secrets: (Akkadius) Added quest::createguild(name, leader) for creating a brand new guild.

==05/28/2011==
Trevius: Added quest::getguildnamebyid(guild_id) for getting a guild name from the guild ID.

==05/25/2011==
JJ: Implemented Arcane Tongues research AA. Chance for research success increases for each rank (10, 25, 50).
JJ: Implemented New Tanaan Crafting Mastery tradeskill AA. Each rank allows an additional tradeskill above 200.
Note: For servers with players who have tradeskills already above the limit without previously purchasing these AAs will freeze the chance to increase until they purchase the proper amount of NTCM AAs.

==05/24/2011==
KLS: Changed Mob::NPCSpecialAttacks(atk, perm) to Mob::NPCSpecialAttacks(atk, perm, [reset = 1], [remove = 0]).  
This should allow one to add and remove flags individually without having to reset everything each time. 
ex: 
$npc->NPCSpecialAttacks(RQ, 0); //would enable the npc to rampage and quad.
$npc->NPCSpecialAttacks(S, 0, 0); //Would enable the NPC to summon as well as rampage and quad by telling it to set S but don't reset the earlier flags.

ex:
$npc->NPCSpecialAttacks(RQS, 0); //would enable the npc to rampage, quad and summon.
$npc->NPCSpecialAttacks(S, 0, 0, 1); //Would enable the NPC rampage and quad by telling it to set S but don't reset the earlier flags and also remove the flag being set.

==05/23/2011==
JJ: (Akkadius) Fixed camera shake usage output.

==05/22/2011==
KLS and Co: 
-All liquid should count for skill ups.
-Finished unified quest interface... this is fairly large and will probably have a few problems here and there; report them to me and ill fix them asap.  
The goal behind the system is to allow more than one scripting system to work at a time (though with limited interaction due to pre-existing implementation limitation).  
This was a feature requested by the Dalaya community as they plan to merge back to the eqemu codebase and clients but are stuck with an old parser and thousands of files 
that can't be realistically rewritten in a short time frame.

==05/20/2011==
JJ: Doubled buffer for tradeskill search when using experiment mode. Outputs message in error log when matches exceed buffer.

==05/17/2011==
JJ: Changed tradeskills to distinguish world containers in multiple recipe matches. Split invalid container vs. non-unique recipe error log entries. Allowed server to select first match for duplicate recipe contents.

==05/16/2011==
JJ: (Zothen) UCS message logic fix.
JJ: (Zothen) Learning basics clean name fix.

==05/09/2011==
KLS: (lerxst2112) *nix compile fix.
KLS: Added #picklock #sensetrap and #disarmtrap for LDoN traps since they still don't work quite right on the newer clients because we don't implement destructable objects yet.

==05/08/2011==
Congdar: (Timothy_nonax) Add Bot Command ( #bot pull )

==05/03/2011==
Trevius: (Vaion) Fix for focus effect decay over max level.
Trevius: (Zothen) Crash fix for UCS.
Trevius: Rule added for Skill Caps Max Level to resolve issues with servers that have Chars over level 75 after Rev1875.

Optional SQL: utils/sql/svn/1889_optional_skill_cap_rule.sql

==05/02/2011==
Secrets: Added OP_CameraEffect for Titanium.
Secrets: Added commands: #reloadallrules, #reloadrulesworld, and #camerashake. These default to 
Secrets: Added optional "global" flag as item 5 in the $mob->CameraEffect() quest object. This does #camerashake, but in quest form.
Secrets: #reloadallrules reloads rules in every single zone plus world. #reloadrulesworld reloads the rules in world only.
Secrets: #camerashake shakes the camera in every zone with required args intensity and duration.

==04/24/2011==
Trevius: Added new Perl Mob quest objects GetItemHPBonuses() and GetSpellHPBonuses().

==04/17/2011==
Secrets: Converted PVP flags to be a variable, as there are other PVP rulesets embedded in the client. These will need code support to work properly. (IsAttackAllowed specifically.)
Secrets: Enabled Firiona Vie ruleset as an option. This disables OOC, makes languages hard to understand between races (somehow), and disables no-drop. If set to 2, this rule will only affect GMs, allowing players to be traded no-drop items from GMs. Player-to-Player trades are still considered active hacks, and are still detected.
Secrets: Made a rule to toggle the GM Petition Window in titanium. You will need the guide petition files for that client, and it still needs code support to work. (find these yourself.)
Secrets: Added expansion settings to the rule_values table instead of the variables. The PVP settings will also be here now, too. (See Optional SQL with this update.)
Secrets: Fixed an issue pointed out by Trevius in the previous commit.

Optional SQL: utils/sql/svn/1885_optional_rules_fv_pvp_expansions.sql


==04/13/2011==
BadCaptain: Bot spell update- Group Heals, debuff spells, spell recast timers, healing AI tweaked, bot bards can now have more than one song active
Optional SQL: utils/sql/svn/1884_optional_bot_spells_update.sql

==04/12/2011==
Trevius: The mana regen portion of bard songs is no longer affected by instrument mods.
Trevius: (scruffy) Identified opcodes for /zone and petition queue on Titanium.

==04/06/2011==
Derision: Underfoot: Corrected OP_CompletedTasks.

==03/30/2011==
Trevius: Implemented spell formulas 1001 to 1998.  They subtract/add values by increasing amounts each tick based on the formula - 1000 value.

==03/23/2011==
JJ: (Danyelle) Face fix for Iksar Beastlord pet.

==03/21/2011==
JJ: (Jaekob/Danyelle) Texture fix for Iksar Beastlord pet.

==03/11/2011==
Trevius: Skill caps now use the MaxLevel rule for deciding max level of skill caps instead of being hard capped at level 75.
Trevius: All spells can be blocked in a zone by setting a spell id of 0 in the blocked_spells table.
Trevius: If a zone has all spells blocked by setting spell id 0 in blocked_spells, any additional spells added for that zone will become exceptions and be allowed.
Trevius: Reverted Sorvani's swarm pet change from Rev1872 due to some bugs it caused for normal pets.

==02/24/2011==
Trevius: Power Source slot can now be augmented.
Trevius: Corrected spell formula 122 (Splurt) and implemented the reverse splurt (Ex. Corath Venom) where damage reduces each tic.

==02/22/2011==
gaeorn: (sorvani) fix to make swarm pets not be targetable as NPCs

==02/19/2011==
Trevius: Added variable export $slotid to EVENT_ITEM_CLICK and EVENT_ITEM_CLICK_CAST, which exports the slot id of the item that triggered the event.

==02/18/2011==
Trevius: Fixed a potential crash in TrySpellOnKill().
Derision: Underfoot: Bard instrument modifiers now show (as focus effects) in the item stats window.
Derision: Allowed fishing in 'VWater' (Region type 7) on the basis this is the only type of water in Sleeper and you can apparently fish there.

==02/17/2011==
Derision: Fixed bug in GetZoneForage where generally only the first three zone specific items could actually be foraged.
gaeorn: (sorvani) fix for bard pacify songs

==02/13/2011==
Trevius: Finalized implementation of Item Faction Mods.  The bonuses now remove if the item is unequiped.
Trevius: Added Rule Character::ItemCastsUseFocus - If true, this allows item clickies to use focuses that have limited max levels on them
Derision: Handle Spell duration formula 15 (for Distillate of Skinspikes).

Optional SQL:
utils/sql/svn/1859_optional_item_casts_use_focus_rule.sql

==02/11/2011==
Trevius: Implemented item faction modifier stats (i.e. factionmod1, factionamt1).
Trevius: Added Power Source slot to item stat (charm) scaling.
Derision: SoD+: Fixed bug when looting items from last two inventory slots (commonly seen when using Loot All).
gaeorn: only send hp/mana/endurance updates to group members when in raid instead of entire raid

==02/10/2011==
JJ: (c0ncrete) Fixed shared bank database query to match schema.

==02/08/2011==
Trevius: Replaced most uses of strncpy with strn0cpy for consistency and stability.
Trevius: Increased zone name loading to 32 characters for doors.

Required SQL:
utils/sql/svn/1847_required_doors_dest_zone_size_32.sql

==02/07/2011==
Derision: SoD/UF: /makeleader and changing Group Leader via Roles works.
Derision: If the leader of a group of exactly 3 members quits, leadership should now be transferred to another member.

==01/30/2011==
Caryatis: Stability fixes for Mystats window.

==01/26/2011==
Derision: Support for door opentype 57 (instant intra-zone portals which don't require the client to click, such as in the bazaar).

Note: For opentype 57, the client automatically sends the click when the player moves onto the portal.

Optional SQL, to set the bazaar portal discs to type 57 (they are type 58 in the PEQ database, but collects show they should be type 57):

update doors set opentype = 57 where zone = 'bazaar' and name = 'PORTAL_DISC';

==01/24/2011==
Trevius: Exported GetFreeSpellBookSlot(start_slot=0) and GetSpellBookSlotBySpellID(spell_id) to Perl Client.
Trevius: Fix for potential crash with EVENT_ITEM_CLICK.
Trevius: (Secrets) Identified OP_SpellEffect for Titanium.
Congdar: bad_captain: more Bot Updates / Fixes V 2.0

==01/22/2011==
Congdar: fix stack buffer overflow

==01/20/2011==
Congdar: bad_captain: Bot Updates / Fixes V 2.0

==01/18/2011==
Trevius: Changed Perl NPC AddItem(itemid, charges, slot = 0) to AddItem(itemid, charges = 0, equipitem = true) since slot was unused anyway.
Trevius: Added equipitem option to quest::addloot(item_id, charges = 0, equipitem = true).

==01/16/2011==
Caryatis: Fix for Phantom line of discs not working.
Caryatis: Fix for buffdurationformula 5(0 value results in a 3 tick spell, was set to 1 tick).
Caryatis: Fix for discs(and AAs) setting a reuse timer if used while not able to(ie stunned)
Caryatis: Implemented SE_VoiceGraft
Caryatis: Added scaling for pet focus items based on the pet power in the spell file.

==01/15/2011==
Caryatis: Fix for fear effects not fading when the buff does, also added check so that a negative recast is not set with SE_ReduceReuse

==01/14/2011==
Trevius: (l0stmancd) Fix for invalid slot move warnings on SoF+ clients.
Trevius: (l0stmancd) Fix for potential item loss issue while using an inventory augmentation sealer.
Trevius: Adjustment to the augmentation code logic to remove potential issues.
Trevius: Added updateclient option to Perl Client TakeMoneyFromPP(copper, updateclient=false).
Derision: UF: Translated command code for /pet hold
Caryatis: Implemented SE_ReduceReuseTimer(epic 1.5/2.0 focuses, sof type3), SE_BlockNextSpellFocus(chance to block next spell matching focus)
Caryatis: Implemented SE_SetBodyType, SE_SpellOnDeath, SE_BlockSpellEffect, SE_Leap, SE_ImmuneFleeing, SE_AddMeleeProc
Caryatis: Delay Death AA is now functional(optional sql).

Optional SQL:
utils/sql/svn/1823_optional_delay_death.sql

==01/13/2011==
JJ: (Leere) Exported quest::LearnRecipe(recipe_id) to PERL

==01/12/2011==
gaeorn: possible fix for some short duration buffs (bard songs) fading one tick early
Caryatis: Changed SE_NoCombatSkills to SE_CombatSkills(0 = spells only, 1 = discs only)
Caryatis: Implemented SE_SpellDurationIncByTic(formerly SE_FocusCombatDurationMod), it adds tics to spells/discs
Caryatis: Added support for Special Attack 'Y'(Ranged Attack), so when an NPC can't reach or summon his target, he will use range if able to
Caryatis: Implemented SE_Forceful_Rejuv(refreshes spell gems), SE_HealFromMana, SE_ManaDrainWithDmg, SE_EndDrainWithDmg
Caryatis: Implemented SE_LimitHPPercent, SE_LimitManaPercent, SE_LimitEndPercent(limit you to a certain % while you have the buff)
Caryatis: Implemented SE_SwarmPetDuration(swarm pet focus)
Caryatis: Res Timer changes have been reverted temporarily.

Optional SQL:
utils/sql/svn/1817_optional_npc_archery_bonus_rule.sql

==01/11/2011==
gaeorn: fixed lull max level check to account for no max level
Caryatis: Change to Doppelganger NPCID due to PEQ's next rev already using the IDs.
Trevius: Added quest::stopalltimers() to allow stopping all current timers on an NPC at one time.
Trevius: Added option to stop all timers when using #reloadquest by adding any argument after the command (ie. "#reloadquest 1"). Also added new #rq alias for the command.

Required SQL:
utils/sql/svn/1813_required_doppelganger_npcid_change.sql

==01/09/2011==
Caryatis: Viral spells are now supported(field191 determines how many targets it will spread to and field 192 determines how often(in seconds)).
Caryatis: Lull spells will now only work on the levels they were intended to.
Caryatis: Corpses now have a res timer(like live). You may res a corpse as many times as you want however you will only recieve exp for the first.

Optional SQL:
utils/sql/svn/1809_optional_rules.sql

==01/08/2011==
Caryatis: Implemented Target's Target(target type 46). Places effect on your target's target(ie cast with mob as target but spell lands on mob's target)

==01/05/2011==
Trevius: Changed xpreward field in the tasks table to be signed so it can display negative values for the level based experience rewards.
Trevius: Tasks now show item links in Task Rewards correctly for all clients.
Trevius: Tasks now reward any set Experience and/or Coin even if the rewardmethod is set to 2 (perl quest).
Caryatis: Mobs now summon starting at 97%, not 94%(like live).
Caryatis: Charmed pets can no longer summon mobs from out of their LoS while charmed.
Caryatis: All fixed duration charm spells now have fixed duration instead of only 2 that were supported.
Caryatis: SpinStun effects now work on mobs up to the max level that the spell denotes(previously limited to 55 regardless of spell info)
Caryatis: SpinStun durations have been changed to be pulled from the effect_value, instead of buff duration(which stopped alot from working), also spins mobs now
Caryatis: Implemented SE_Fearless(Valiant Companion), SE_AntiGate(Translocational Anchor), SE_DispelBeneficial(various spells and clicks)
Caryatis: Implemented SE_IncreaseBlockChance, SE_CurrentEnduranceOnce, SE_CurrentManaOnce, SE_AEMelee(duration rampage)
Caryatis: Persistent Casting AA is now functional(required sql)
Caryatis: Rampage(-) and Destructive Force(+) have changed, the duration on both has been altered based on the live spell info(required sql)
Caryatis: Flurry will no longer hit the highest on hatelist, it will hit the mobs current target like live(fixes rooted flurrying mobs).
Caryatis: Updated spdat.h with current status of all spell effects
Caryatis: Reorganized spell_effects.cpp to remove alot of the clutter of effects handled elsewhere

Required SQL:
utils/sql/svn/1803_required_tasks_xpreward_signed.sql
utils/sql/svn/1804_required_ae_melee_updates.sql

==01/04/2011==
Trevius: (l0stmancd) BagType 53 can now be used as an Augmentation Sealer from inventory.
Caryatis: Implemented SE_Doppelganger(Doppelganger AA is now functional)

Required SQL:
utils/sql/svn/1802_required_doppelganger.sql

==01/03/2011==
Caryatis: Implemented SE_GravityEffect(424)
Caryatis: Added rule for endurance to be included in rest regeneration

Optional SQL:
utils/sql/svn/1799_optional_rest_regen_endurance_rule.sql

==01/01/2011==
Derision: UF: Tweaked Arrow_Struct and implemented new OPCode for changing player size.

==12/31/2010==
Derision: UF: Fix for extended duration buffs not reporting correctly after first tic.

==12/30/2010==
Derision: Added a new table aa_required_level_cost to allow specifying a required level and cost for each rank of an AA.
Derision: Implemented spell formulas required by AA versions of Harm Touch/Lay on Hands.
Caryatis: ShowStatWindow was changed to ShowWindow and had some features added
Caryatis: title_type = 0 for custom titles, 1 for first and last name and 2 for guild titles
Caryatis: Implemented a limit on how low a weapon speed can be when procs are calculated to reflect the innate swing speed limit

Required SQL:

utils/sql/svn/1790_required_aa_required_level_cost.sql

If there is no entry in this new table for a given rank of an AA, then the level (class_type) and cost_inc
from altadv_vars will be used as normal.

==12/28/2010==
Derision: /corpsedrag & /corpsedrop. Optional SQL: utils/sql/svn/1784_optional_corpsedrag_rules.sql

==12/25/2010==
Derision: Underfoot: Correct OP_SwapSpell
Derision: SoD/Underfoot: List of traders in /bazaar dropdown now works.
Derision: Implemented Advanced Tracking AA.

==12/24/2010==
Trevius: (Orkim) Zone Short Name restriction fixes.

==12/21/2010==
Derision: HoT: OP_SendFindableNPCs
gaeorn: bugfix for quest::movegrp to work with raids. no really, its fixed this time

==12/15/2010==
Trevius: Added an extra check for buffs while zoning to make sure it is a valid spell being applied.
Derision: Underfoot - Fix for /dismount not dispelling horse and Group Leadership fixes (opcode changes).
Congdar: fix for bot trading exploits

==12/13/2010==
gaeorn: fixed underfoot to properly handle new packet struct for LoadSpellSet_Struct
Derision: Underfoot - UCS should now retain /announce setting properly.

==12/11/2010==
gaeorn: bugfix for quest::movegrp to work with raids
Derision: UCS Support for Underfoot and later clients
Congdar: bot item trading fixes for lore, dual wield, augmenting, inspecting

==12/10/2010==
gaeorn: fixed quest::movegrp to work with raids
gaeorn: fixed casting group spells in a raid
gaeorn: (vanicae) code support for tactical mastery warrior aa
gaeorn: (vanicae) code support for touch of the divine cleric aa
gaeorn: (vanicae) item loot messages when in a raid
gaeorn: (Wolftousen) fixed spawn variance

==12/09/2010==
Derision: Updated HoT opcodes following patch.

==12/07/2010==
Trevius: Resolved a potential zone crash with memorizing spells.
Trevius: Added $item1_charges, and $item1_attuned exports for all 4 turn in slots item1-item4 for EVENT_ITEM.
Trevius: Fixed GetMinDMG() so it should work now.

==12/03/2010==
Caryatis: Fix for SpellResistChance effect.

Required SQL:
utils/sql/svn/1755_required_sql_fear_resist_aas.sql

==12/01/2010==
Caryatis: Fix for Reflect Spells and Healing Adept AAs
Caryatis: Showstats has been updated.

Required SQL:
utils/sql/svn/1754_required_sql_healing_adept_aa_fix.sql

Optional SQL:
utils/sql/svn/1753_optional_haste_cap_rule.sql

==11/30/2010==
Trevius: SoF+ - Stacked Potions will no longer show a factor of how many you have remaining in the potion belt.
Trevius: Increased the max spell ID allowed in the spell book from 20000 to 50000.
Derision: Underfoot. Corrected PP for LDoN points, Tribute and Leadership AA.  Corrected offset comments/unknown names.

==11/27/2010==
Derision: Renamed Live patch to Underfoot.
Derision: Added basic support for current live patch (HoT).
Caryatis: Reverted Bot changes due to crash issues
Caryatis: Reverted physical resist changes until we can find a more live-like solution
Caryatis: Gender Illusions are now functional
Caryatis: Implemented SE_Twinproc and Reflect spells

Note:

HoT support is limited to being able to enter a zone with spawns and items.
Combat, spells, moving items around, basically anything other than zoning, spawns, initial inventory load and movement will NOT work.
Note ZoneUnavailable is not implemented, so let at least one dynamic zone finish booting before attempting to enter.
This support is mainly to allow people to admire HoT zones, full playable HoT support is not planned at this time.

Optional SQL for zone and zonepoint table (thanks to robregen for the collects):

utils/sql/svn/1747_optional_HoT_zone_and_zonepoints.sql

For spawns etc, go to the PEQ logs repo for data collected by robregen.

Optional SQL: 

utils/sql/svn/1750_optional_sql_reflect_rule.sql

==11/24/2010==
Trevius: The Rule, NPC:ReturnNonQuestNoDropItems, will now also return items that have been Attuned to a character as well as normal NO DROP items if set to true.
Trevius: Fixed an issue with tradeskill auto-combines.
Caryatis: Fix for SpellResistChance, Hit-limited focus effects(eg Gift of Mana) & SpellDamageShield(no longer will trigger on beneficial spells).
Caryatis: Showstats window will not show mana fields if the class does not use mana(to preserve the already shaky alignment).
Caryatis: (bad_captain) Removed the level bonus granted to standing mana regen, it was not like live and diminished the need to sit or use a horse considerably.
Caryatis: (bad_captain) Bots have been updated, see forums for complete details(new command: #bot showstats).
Caryatis: (Secrets) Haste values can exceed 127%(ie Can o' Whoop Ass).

Optional SQL: 
utils/sql/svn/1746_optional_sql_bot_manaregen

==11/22/2010==
JJ: Updated waypoint handling to properly account for aggro and quest engagements. NPCs will no longer skip waypoints when distracted from their grid path when resuming wandering.

==11/21/2010==
Caryatis: Implemented SE_SkillDamageAmount & SE_Amnesia(silence vs disciplines), SE_CripplingBlow
Caryatis: Updated Silence so that is no longer prevents the use of disciplines(like live)

==11/20/2010==
Caryatis: Fix for discs being resisted too much, beneficial spells and resurrection effects will no longer be resistable.
Caryatis: Fix for CriticalHitChance being calculated incorrectly, leading to massively increased crit rates.
Caryatis: Fix for Healrate effect
Caryatis: Implemented ManaAbsorbPercentDamage, ReduceSkillTimer, HpToMana and LimitSpellGroup effects.
Caryatis: Updated DamageModifier effect to be more robust.

Required SQL: 
utils/sql/svn/1737_required_sql_rule_and_aa_update

Optional SQL: 
utils/sql/svn/1736_optional_sql_feral_swipe

==11/14/2010==
Derision: Underfoot: Buff removal should now work correctly.
Derision: Underfoot: Fixed Pet Buff window.
Trevius: Fixed quest::setnextinchpevent().
Trevius: Added Player EVENT_GROUP_CHANGE that exports variables $grouped and $raided when changes in group or raid status are made
Trevius: Added Perl Client MarkCompassLoc(x, y, z) and ClearCompassMark().
Trevius: Minor rewrite to EVENT_HP again to use less variables.

==11/13/2010==
Derision: Corrected OP_Track for Underfoot/June 8 2010 Client.
Derision: Corrected FindPersonRequest_Struct for Underfoot/June 8 2010 Client.
Derision: Buying AAs seems to work better now for Underfoot/June 8 2010 Client.
Derision: Most Pet commands should now work for Underfoot/June 8 2010 Client.
Caryatis: Corruption resist is now fully functional
Caryatis: Showstats has been updated.
Caryatis: Implemented SpellOnKill and CriticalDamageMob effects.
Caryatis: Fix for CriticalSpellChance

Required SQL:
utils/sql/svn/1723_required_sql_corruption.sql

Optional SQL:
utils/sql/svn/1723_optional_sql_new_stats_window_rule.sql

==11/12/2010
Caryatis: Implemented CriticalSpellChance, SpellCritChance, SpellcritDmgIncrease, CriticalHealChance, CriticalHealOverTime, CriticalDoTChance, SpellResistChance.
Caryatis: Migrated some AAs to the bonus system
Caryatis: Fading Memories is fixed(uses mana, cant use without mana, makes you invis and can use while singing.)
Caryatis: Support for new types of AAs: Expendable, Quest, Racial/Bloodlines.
Caryatis: New client object: IncrementAA(skill_id) and GetAALevel(skill_id)

Required SQL:
utils/sql/svn/1720_required_sql_AA_effects_update.sql

Optional SQL:
utils/sql/svn/1720_optional_sql_AAs.sql

==11/10/2010==
Caryatis: Added support for HealAmt, SpellDmg, Clairvoyance, DS Mitigation, SE_SpellDamageShield, SE_SpellDamage
Caryatis: Heroics fully supported now(points in brackets are how many Heroics to achieve a gain)
Caryatis: hInt = For int-based casters, increases mana pool, mana regen(25), and the maximum amount of mana regen a character can have(25).
Caryatis: hWis = For wis-based casters, increases mana pool, mana regen(25), and the maximum amount of mana regen a character can have(25).
Caryatis: hStr = Increases endurance pool, endurance regen(25), and the maximum amount of endurance regen a character can have(25). Also increases damage done by melee attacks(10) and improves the bonus granted to armor class while using a shield(2).
Caryatis: hSta = Increases hit point pool, hit point regen(25), and the maximum amount of hit point regen a character can have(25). Also increases endurance pool, endurance regen(25), and the maximum amount of endurance regen a character can have(25).
Caryatis: hAgi = Increases endurance pool, endurance regen(25), and the maximum amount of endurance regen a character can have(25). Also increases the chance to dodge an attack(25), grants a bonus to defense skill(10).
Caryatis: hDex = Increases endurance pool, endurance regen(25), and the maximum amount of endurance regen a character can have(25). Also increases damage done by ranged attacks(1), improves chance to successfully assassinate or headshot(10), and improves the chance to riposte, block, and parry incoming attacks(25).
Caryatis: hCha = Improves reaction rolls with some NPCs(25) and increases the amount of faction you gain or lose when faction is adjusted(5). 
Caryatis: AA Focus revamped to support new effects
Caryatis: Disciplines will no longer be dispelled

Optional SQL:
utils/sql/svn/1719_optional_triggerOnCastAAs.sql

==11/09/2010==
Caryatis: Implemented MaxHPChange, SkillDmgTaken, Endurance Pool and Stun Resist.

Optional SQL: 
utils/sql/svn/1717_optional_rule_bash_stun_chance.sql

==11/07/2010==
Congdar: Fixed OP_InterruptCast for newer clients(SoF, SoD, Live). You'll now see Npc's and other players cast interrupted message properly.

==11/06/2010==
Trevius: Fixed an issue with EVENT_HP that was sending $hpevent with a value of -1 in certain cases.

==11/04/2010==
Trevius: Added new Perl Client GetAAExp() quest object.
Trevius: Corrected the level based Experience quest command and task reward functionality to not affect AA Experience.

==10/30/2010==
KLS: Added NPC::AddAISpell() and NPC::RemoveAISpell() to perl NPC object.
KLS: Added field to limit AAs based on account creation time.
KLS: Implemented fade on meditate field for spells like the higher yaulp spells (it will fade just before a regen tic).
JJ: Cleaned up Win32 build locations, moved eqlaunch into build folder, and set project dependencies to guarantee build order in Windows.

==10/16/2010==
Trevius: Added optional slot_id field to Client SummonItem(item_id, charges, attune, aug1, aug2, aug3, aug4, aug5, slot_id) - Default is slot 30 (cursor).

==10/16/2010==
Trevius: Added Perl Item IsAttuned() and GetCharges() quest commands.
Trevius: Added Attune and Aug fields to Client SummonItem(item_id, charges, attune, aug1, aug2, aug3, aug4, aug5)

==10/15/2010==
Trevius: NPCs can now load a default.pl file from the /quests/zone_short_name/ of the zone they are in.

==10/14/2010==
Trevius: Added Race 502 Boats to be a controllable boat race.

==10/10/2010==
Trevius: Added Perl Client AddLevelBasedExp(exp_percentage, max_level=0) command to add experience as a percentage of the client's current level up to the max level entered.
Trevius: Level based experience percentage rewards for tasks can now be set using a negative value of the max level * 100 + experience percent (IE. -510 for 10% exp up to level 5).

==10/09/2010==
Trevius: Object model names can now use up to 32 characters.
Trevius: Zone short names can now use up to 32 characters.
Trevius: Added extra checks before AIYellForHelp call is made to prevent potential issues.
Secrets: Added Perl Client GetIP() and NPC GetMinDMG() commands.
KLS: Adjust procs: only check once per round now instead of once per hit, this will result in lower proc rates especially for dual wielding classes but this is how it should behave. Adjust your proc per minute rule up if you desire higher proc rates under this change.
KLS: Directional Cone Spells; still needs a little work as it isn't 100% accurate but it works enough that there's no point in me sitting on it.

Required SQL:
utils/sql/svn/1696_modify_zone_and_object_tables.sql

==10/03/2010==
Derision: Fixed bug in SoD+ tracking.
JJ: Removed redundant namespace usage.

==10/02/2010==
Derision: Players disconnected with the Respawn Window up will now return to bind.
Derision: Players rezzed in an instance via the Respawn Window will no longer zone.
Derision: Implemented Blocked Buffs.
Derision: Fixed Blocked Buff spam every time you zone.
Derision: Implemented OP_ClearBlockedBuffs.

==09/29/2010==
Derision: Fixed crash in combat logging when a player was DoTted, zoned and then died from the DoT.
Derision: Spells should no longer land on players with the Respawn Window up (e.g. AE DoTs, Evac spells).
Derision: The client should now ummem spells on death when the Respawn Window is in use.

==09/26/2010==
WildcardX: Updated bots.sql to catch a couple database object changes that affected bots over the last months.

==09/25/2010==
Derision: Only one Rez confirmation box is allowed to be up at a time (per character).
Derision: Enabled Respawn Window for SoF and later clients. Rule disabled by default.
Derision: Respawn Window only pops-up if a corpse is left (so #gm off to test it).

Optional SQL (and to enable it):

utils/sql/svn/1672_optional_rules_respawn_window.sql

==09/24/2010==
Congdar: Remove obsolete bot code, fix compile warning

==09/23/2010==
Congdar: Bots can now equip multi slot items in the desired slot. The first available empty slot will get the item.
Congdar: Bots now check Lore and Dual Wield with the new multi slot item code.

==09/13/2010==
JJ: Fix to prevent NPCs using death animation from facing target during EVENT_SAY and EVENT_ITEM
Derision: Fix for missing tradeskill objects etc in SoF and later clients.
Derision: Reverted stun resist changes.

==09/12/2010==
Derision: /guildstatus now works for SoD and UF.
Caryatis: Spells with a Melee Lifetap effect now cap the heal at the percentage specified in the spell data.
Caryatis: Work on stun resists.
Vanicae: Fix for potential world crash in online guild-member processing.

==09/11/2010==
Vanicae: Fix for guild management window updates
wheeljack: Fix for missing tradeskill favorites
Vanicae: Tribute Focus, SE_DivineSave, SE_Flurry, SE_Accuracy
wheeljack: Fix for losing items in world containers
pfyon: quest::createBot()
Derision: None potions that are potion belt enabled (mod rods etc) should now work from the potion belt when they are inside a bag.
Derision: Recast timers should now be honoured for clicky items with a single charge (e.g. Modulating Rod).
gaeorn: more fixes for newer gcc/glib

==09/08/2010==
gaeorn: fixes for new stricter version of gcc/glib

==09/08/2010==
JJ: ChannelMessageSend in Client now cleans the "from" name to allow NPCs to be used as the message sender.

==09/06/2010==
Trevius: Added to Perl Mob: SetSlotTint(material_slot, red_tint, green_tint, blue_tint).
Trevius: Added to Perl Mob: WearChange(material_slot, texture, color).
Trevius: Added to Perl Mob: GetArmorTint(material_slot).
Trevius: Changed EVENT_COMBAT to now export the normal client variables when combat state changes to 1.

==08/28/2010==
Derision: Fixed potential buffer overrun in item_struct. NOTE: Linux users may have to increase shmmax.
Trevius: Added to Perl Mob: SetGlobal(varname, newvalue, options, duration, other=NULL).
Trevius: Added to Perl Mob: TarGlobal(varname, value, duration, npcid, charid, zoneid).
Trevius: Added to Perl Mob: DelGlobal(varname).

==08/26/2010==
Trevius: Added new Perl Mob quest object GetItemStat(itemid, stat).
Trevius: Added new Perl Client quest object NPCSpawn(target_npc, option, respawntime=1200) to do create, add, update, remove, and deletes just like #npcspawn.
Trevius: Fixed a potential crash while augmenting items.
Trevius: Fixed a crash caused by using tradeskill container objects created with the CreateGroundObjectFromModel() quest command.
Trevius: Added an optional decay time setting for quest::creategroundobjectfrommodel(modelname, x, y, z, heading, [type], [decay_time]).
Trevius: Decay time is now optional for quest::creategroundobject(itemid, x, y, z, heading, [decaytime]) (default is not to decay at all).

==08/25/2010==
JJ: Updated PP comments/unknowns to match size changes over time

==08/24/2010==
gaeorn: mana updates for group should be sent to SoD clients when in raid now

==08/23/2010==
Trevius: EVENT_TARGET_CHANGE now also works for player scripts.
Trevius: Added new EVENT_ITEM_CLICK for SoF+ clients.  File naming format is: /quests/items/script_<scriptfileid>.pl (I.E. /quests/items/script_12345.pl)
Trevius: Effect Name overrides (SoF+) for the following item table fields: clickname, procname, wornname, focusname, or scrollname.
Trevius: Added to Perl Object: SetEntityVariable(id, var), EntityVariableExists(id), and GetEntityVariable(id).
Trevius: Added Rule UseRaceClassExpBonuses to allow choosing whether to use the Racial and Class Experience Bonuses (Default: True).

OPTIONAL SQL:
utils/sql/svn/1625_optional_rule_class_race_exp_bonus.sql

==08/15/2010==
Derision: Fixed crash when a mob died to a DoT in a zone where buff timers are suspended.

==08/14/2010==
Derision: Spells/Songs with a Locate Corpse effect now work in SoD and later clients.
Derision: Spells/Songs with a Sense Undead/Summoned/Animal effect now work in SoD and later clients.
Trevius: Exported Perl Mob SetCurrentWP(waypoint), Perl NPC SetSaveWaypoint(waypoint), and Perl Client GetTotalSecondsPlayed().
Trevius: Changed grid from int32 to sint32 since grid pausing requires negative values.

==08/13/2010==
Derision: Elemental Draw should now work for SoD.

==08/08/2010==
Derision: Added check for invalid neighbour nodes on loading .path files.
wheeljack: Fixed Bazaar search for items with focus effects.
wheeljack: Buff Timer Suspension.
wheeljack: Tradeskill messages for missing components.

REQUIRED SQL:

ALTER TABLE zone ADD suspendbuffs tinyint(1) unsigned NOT NULL DEFAULT 0;
UPDATE zone SET suspendbuffs = 1 WHERE short_name IN ('guildlobby', 'guildhall');

==08/01/2010==
Trevius: Exported the following to Perl Mob: GetWaypointX(), GetWaypointY(), GetWaypointZ(), GetWaypointH(), GetWaypointPause(), and GetWaypointID().

==07/27/2010==
Trevius: Exported SpellFinished(spell_id, spell_target = this, mana_cost = 0) to Perl Mob.

==07/26/2010==
Trevius: (Secrets) Added quest::creategroundobjectfrommodel(modelname, x, y, z, heading, [type]) command.
Trevius: (Secrets) quest::creategroundobject(itemid, x, y, z, heading) now returns object ID.
Trevius: (Secrets) Added Object List Iteration functions GetObjectByDBID(id), GetObjectByID(id), GetObjectList().
Trevius: (Secrets) exported Objects to Perl with the following commands:
		IsGroundSpawn(), Close(), Delete(reset_state=false), StartDecay(), DeleteItem(index), IsObject(), 
		Save(), SetID(set_id), ClearUser(), DBID(), GetID(), GetX(), GetY(), GetZ(), GetHeading(), VarSave(), 
		GetType(), SetType(type), GetIcon(), SetIcon(icon), GetItemID(), SetItemID(itemid), SetLocation(x, y, z), 
		SetX(XPos), SetY(YPos), SetZ(ZPos), SetHeading(heading), SetModelName(name), GetModelName(), Repop(), Depop().

==07/25/2010==
Trevius: (Caryatis) Added the following Spell Effects:
		SE_SympatheticProc, SE_ImprovedSpellEffect, SE_SpellVulnerability, SE_SpellTrigger
		SE_InterruptCasting, SE_CastOnWearoff, SE_ApplyEffect, SE_BossSpellTrigger, SE_Twincast
		SE_HealRate, SE_SkillDamageTaken, SE_EffectOnFade, SE_MaxHPChange, and SE_EndurancePool.

==07/19/2010==
gaeorn: fix for foraging

==07/17/2010==
JJ: Added events for tradeskill failure and success.
JJ: Added quest flag for tradeskills to be handled by perl. Required SQL in the utils folder.

==07/14/2010==
Trevius: Hopefully fixed the issue for SoF+ clients alcohol consumption causing item loss.

==07/13/2010==
Derision: Azone2 - Fixed crash processing fungalforest and possibly other Underfoot V4 .eqg zones.
Derision: Azone2 - Culled placeable shrooms to reduce fungalforest .map from ~80 to ~20MB.

==07/11/2010==
Trevius: Live - Environmental damage is now functional on this client.

==07/08/2010==
gaeorn: fixed confusing and likely flawed logic in GetZoneForage()

==07/06/2010==
Trevius: Fix to prevent a potential item loss bug.
Trevius: Fix for Nimbus Particle Effects to make them appear properly.
JJ: Added $oncursor as an export to the parser.
JJ: Added ability for NPCs to use heading in waypoint table. Added option to use heading when adding waypoints in game (-h switch). NPCs will use in-stride heading if the default heading (-1) is used. Optional SQL included in the utils folder.

==06/24/2010==
Trevius: EVENT_CLICKDOOR should now always show the correct door ID from the $doorid export.
Trevius: Doors with IDs higher than 126 should now work.
Trevius: Added perm_effect and client fields to SpellEffect(effect, [duration, finish_delay, zone_wide, unk20, perm_effect, client]).

==06/23/2010==
KLS: Instances can use spawn conditions now, requires SQL change in required sql folder.  Also updating will wipe all current spawn condition variables so you'll want to make sure they're set in the new table. (ps instance_id=0 for base zones!)
KLS: Added expedition expire warning to dynamic zones that aren't LDoNs, requires conf change for SoF/SoD.

==06/22/2010==
gaeorn: replaced calls to rand() with calls to MakeRandomInt()

==06/20/2010==
KLS: Added command #maxskills to max your skills instead of having to #setskill everything for testing.
KLS: Implemented partial melee and spell runes.
KLS: Right click tome learning in sof/sod.
KLS: Adjusted AC; should now be more sensitive to changes in gear as well as implemented softcaps.

==06/19/2010==
Trevius: Stopped NPCs from sending an appearance packet for each WP they arrive at or depart from.

==06/18/2010==
Trevius: Nimbus particle effects now show correctly from spells/clickies.
Trevius: Removed the ability to stack the same Nimbus particle effect repeatedly.
Trevius: Existing Nimbus particle effects are now sent to players as they zone in.
Trevius: EVENT_SPAWN should work better for more quest commands now.  Please report any bugs/issues with this change.
Trevius: SoF/SoD/Live - Stand state appearances are now set in the spawn struct.

REQUIRED SQL:
utils/sql/svn/1548_nimbuseffect_required.sql

==06/16/2010==
gaeorn: fixed possible bug with unlocking cursed containers in LDoN
Trevius: SoF/SoD/Live - Corrected the item structures to allow summonedflag setting to show on items.
Trevius: SoD/Live - Identified Clairvoyance and added it to load from the DB to be shown on items.
Trevius: SoD - Possible fix for empty corpse looting bugging clients.
gaeorn: fixed another issue with the integer transformation for the RNG where it was not converting from a double float properly

==06/15/2010==
Secrets: Characters with HPs higher than 30k will no longer be set back to 30k current health when zoning.
gaeorn: fixed integer transformation for RNG as it previously would only return the high value of the low to high range if the RNG returned exactly 0xffffffff
Trevius: The following item fields now load from the database: EliteMaterial LDoNSellBackRate ScriptFileID ExpendableArrow QuestItemFlag.
Trevius: Identified some unknown fields in the database from 13th floor findings, and removed multiple unused fields.
Trevius: The summonedflag field is copied from UNK109 field.

REQUIRED SQL:
utils/sql/svn/1542_items_table_cleanup.sql

==06/10/2010==
gaeorn: modified method of transforming RNG output into a range of integers. this should improve the equalization of the distribution of the returned random numbers

==06/09/2010==
Trevius: Added new Perl Mob quest object SpellEffect(effect, [duration, finish_delay, zone_wide, unk20, unk26]) for sending a spell paticle effects without casting a spell.
gaeorn: replaced random number generator with the first one on this page: http://www3.ocn.ne.jp/~harase/megenerators.html

==06/08/2010==
Trevius: Added new quest::resettaskactivity(task, activity) command for resetting a task activity done count to 0.

==06/07/2010==
gaeorn: compile fixes for linux
KLS: Added EVENT_SPELL_EFFECT_TRANSLOCATE_COMPLETE, EVENT_SPELL_EFFECT_BUFF_TIC_CLIENT, EVENT_SPELL_EFFECT_BUFF_TIC_NPC in the similar style of the other spell effect events.

==06/06/2010==
KLS: Added spell quests. Spell quests reside in {EQEMU_DIR}/quests/spells/ and are in the format of {spell_id}.pl.  (ex: C:/eqemu/quests/spells/15.pl for greater heal)
KLS: Spell quests allow the overriding of specific spell effect. If a spell quest and sub exists then a spell's effect aside from buff duration and knockback is not used and instead the script is executed.
KLS: Two acceptable subs for spell quests: EVENT_SPELL_EFFECT_CLIENT and EVENT_SPELL_EFFECT_NPC and has a special export of $caster_id.

==06/04/2010=
Trevius: Fixed a potential crash with pick pocket.

==06/02/2010=
KLS: Revert titanium hp boost.
KLS: Random 10 grid type(1) will actually return the 10 closest in 3d space not the 10 closest on the grid list.
KLS: Added new grid type(5): Random 5 with LOS.
Trevius: Added new command #tempname <newname>, to allow temporarily renaming NPCs and Clients.  Name resets on repop or zoning.

RECOMMENDED SQL:
utils/sql/svn/1519_zone_primary_key_id.sql

==06/01/2010=
Trevius: Added new Perl Mob quest object TempName(name) to allow changing a name temporarily.  Setting no name will return the name to the original name.

==05/31/2010=
Derision: Increased the name field in the internal Ground_Spawn struct from 16 to 20 characters to cater for ground_spawns that are longer than 15 characters.

==05/27/2010==
Trevius: Unreverted the revert from R1502 and added a fix for the tradeskill container combine issue.
Trevius: Fixed a crash when using NukeItem on the Power Source slot for a Titanium client.

==05/25/2010==
KLS: Many changes..
KLS: Rewrote much of the adventure subsystem; moved from zone based calculations to world based.
KLS: Implemented adventure leaderboard (sort by # kills only)
KLS: Custom merchant (Adventure/PvP/Discord) purchases should attempt to put the item in a player's inventory before the cursor.
KLS: Corpses should move to an adventure GY if possible on the end of an adventure.
KLS: Adventures should always award points to zoning/offline players when they reconnect now.
KLS: Collect adventures will populate the zone with enough dropped items always automatically now, relying on drop rates is now out of the picture.
KLS: Mech. treasure chests will now be affectable by spells and destroyable; at least until we figure out the spawn structure on SoF and beyond to enable them correctly with rogue skills.
KLS: Addressed an issue that made chests slightly harder to open than they were intended to be.
KLS: Addressed a few issues with raids not being duplicated along with groups in the code. This should be apparent in the spell code.
KLS: Added a default ruleset to the zone table and added a version to the zone table.  Version will default to 0 if non is found (base zone).
KLS: OP_MoveItem will ignore requests from a slot to the same slot.
KLS: Lowered the quick loot timer significantly, hopefully loot all works better.
KLS: Several memory leak and exploit fixes.
KLS: This could all probably use a bit more testing that I was able to give it as one person, I believe I got most if not all the crash bugs though!

==05/22/2010==
Trevius: Exported ModifyNPCStat(identifier, newValue) to Perl NPC.
Trevius: Added a check for destroying items to ensure the source slot is the cursor.
Trevius: Moved the SwapItem() check to verify the source and destination slots are both valid before doing anything else.
Trevius: The client will now be updated to delete an item if the server does not see an item in that slot while moving items around.

==05/20/2010==
Trevius: Added new Perl Mob quest object CameraEffect(duration, intensity, singleclient).  Duration is in ms, intensity is from 0 to 10, and singleclient can be set to a client.

==05/18/2010==
Trevius: Live - Corrected the end of the Item Structure.

==05/17/2010==
Trevius: Live - Updated more Live Opcodes.  The list should be about 95%+ accurate now.  Live Client is very playable now.
Trevius: Increased the race max to 667 for #race and #fixmob race to match Live's current race count.

==05/14/2010==
Trevius: Added new Perl Mob quest object QuestReward(client, silver, gold, platinum) that awards money to the client and makes the quest completed sound.
Trevius: Added 2 new optional fields to Perl Client quest object MaxSkill(skillid, [class, level]).
Trevius: Minor corrections for SetSkill(skill_num, value) and AddSkill(skillid, value) to set skill values to int16 instead of int8.

==05/13/2010==
Trevius: Live - Updated Player Profile and Spell Buff Structs to allow the May 12th Live patched client to enter the game.
Trevius: Live - Updated about 50% of the opcodes so most basic stuff should be functional.
Derision: Live - Encoded OP_GroundSpawn plus updated OP_ClickObject/OP_ClickObjectAction.
Derision: Added Live to the list of clients reported by #cvs.

==05/12/2010==
Trevius: SoD - Coin no longer adds weight for this client server-side, since the client itself no longer adds coin weight
Trevius: SoD - Heroic Stats should now add the correct amount of HP/Endurance/Mana to match the client in most cases.
Trevius: The scribespell and traindisc commands and quest commands should sort Disciplines properly once again.

==05/11/2010==
Derision: Guild invitations to a player already in receipt of an invitation will now be rejected.
Derision: Fixed quest::pvp("off")
gaeorn: fixed a couple issues with the login server code.

==05/10/2010==
Trevius: SoD - Heroic Stats/Resists now increase the cap server-side as they should.

==05/09/2010==
Derision: Live - Added an encode for OP_ChannelMessage
Derision: Live - Encoded OP_GuildsList and corrected OP_GuildUpdateURLAndChannel.
Derision: Live - Door and Group OPCodes. Set OP_GroundSpawn=0x00000 until an encode can be done for it (was causing crashes, particularly in PoK).

==05/08/2010==
Derision: Guild Bank fix.
Trevius(Derision): Added special handling for certain types of opcodes to correct an issue on the Live client.
Trevius: SoF/SoD - Type 5 clicky items can no longer be used if the character does not meet the race/class requirements of the item.
Trevius: Live - Can now log into the game with new character fine, but some existing characters cause zoning loops.
Derision: Live - Added a Decode for OP_ChannelMessage
Derision: Live - Corrected OP_Camp, OP_MoveItem and OP_ItemPacket.
Derision: Live - Corrected: OP_SetChatServer2, OP_MemorizeSpell, OP_CastSpell, OP_Death, OP_Animation, OP_SenseHeading
Derision: Live - Corrected: OP_Damage, OP_TargetCommand, OP_MobHealth, OP_DeleteSpawn, OP_AutoAttack, OP_AutoAttack2
Derision: Live - Corrected: OP_SaveOnZoneReq, OP_Track, OP_TrackTarget (Tracking messages not yet working, probably due to Filter opcode).
Derision: Live - LogServer_Struct.
Derision: Live - Corrected OP_FormattedMessage and padded out ServerFilter_Struc to match live. OP_WhoAllResponse.

==05/05/2010==
Trevius(Derision): Fixed a potential crash related to Saylinks and Antispam code.
Trevius: Live - Initial update to the Live patch files.  Can only get to a blank character select at this point.

==05/04/2010==
Trevius: SoF/SoD - Resolved an issue that was preventing some AAs from being able to be trained properly.
Derision: Updating a character's Alt or Banker flag no longer resends the entire guild member list.
joligario: quest::givecash cleaned up.
Congdar: SoF: Fix starting city for freeport characters.

==05/03/2010==
Derision: The facility to flag 'Alts' in the Guild Management Window now works for those clients that support it.
Derision: The facility to specify a Guild chat channel and URL now work for those clients that support it.
Derision: SoD - Item links for Task rewards now display correctly in the task window.

REQUIRED SQL:
utils/sql/svn/1451_guilds.sql

==05/02/2010==
Derision: The Guild Management Window should now reflect the true online status and zone of members at all times.
Derision: Added a command, #cvs (Client Version Summary) to display connected client version counts.

OPTIONAL SQL:
utils/sql/svn/1450_cvs.sql

==05/01/2010==
Trevius: Added new Perl NPC quest object GetSwarmTarget() to get the ID of a swarm pet's set target.
Trevius: Added new Perl NPC quest object SetSwarmTarget(target_id) to set the ID of a swarm pet's target.
Derision: Group member locations are now always updated in entity_list.SendPositionUpdates (for SoD group member location on map).
Derision: Certain detrimental spells will still allow the player to enter a rested state.

REQUIRED SQL:
utils/sql/svn/1446_allowrest_required.sql

OPTIONAL SQL: (Read the comments in it before executing)
utils/sql/svn/1446_allowrest_optional.sql


==04/30/2010==
Trevius: Fixed a bug that would cause clients in an existing trade to get bugged if another client tried to trade with them during their existing trade.
Trevius: Added new Perl Mob quest object MakeTempPet(spell_id, [name=NULL, duration=0, target=NULL]).
Trevius: Added new Perl NPC quest object GetSwarmOwner() to get the ID of a swarm pet's owner.
Trevius: Hide will now break if you move when not sneaking, even if you have invisibility on.
Derision: Fixed bug in Guild Bank.
gaeorn: reverted my change from 4/24 as it did not work.

==04/29/2010==
gaeorn: fixed tables to avoid login server hang if ServerTagDescription in tblWorldServerRegistration is null

Optional SQL: utils/sql/svn/1436_login_server_table_fix.sql

==04/28/2010==
Trevius: Attempting to trade with a player who is already in a trade will now give the "I'm busy right now" message for all clients.
Derision: Applied slot conversion so Apply Poison should now work in SoF.
gaeorn: login server now creates db entries for unregistered servers to keep same id across sessions
Derision: Fixed a cash amount display bug when the two participants in a Barter transaction are using different clients.

==04/27/2010==
Trevius: SoD/SoF - Clicky items with charges can no longer be cast if they have 0 charges left.
Secrets: Mana can now exceed 32k without rolling over to 0.

==04/26/2010==
Trevius: SoD/SoF - Failing a clicky item cast in certain scenarios should no longer cause the client to get bugged where the spells won't refresh.
Trevius: SoD/SoF - Cast bars from clicky items now use the cast time from the item, not from the spell.
Trevius: SoD - Potions in the potion belt can now be used even if they are inside bags.

==04/25/2010==
Derision: Fixed azone2 to handle missing model files (no longer crashes on oldfieldofbone.eqg)

==04/24/2010==
gaeorn: possible fix for long standing reconnect to login server problem if login server connection is down for an extended period of time.
Trevius: SoD - Added AA support for Harm Touch and Lay on Hands to replace the innate skills of the PAL/SK classes.

Optional SQL: utils/sql/svn/1410_optional_sod_aas_ht_and_loh.sql

==04/23/2010==
cavedude: Added Drakking to faction_list, updated wolf form and Skeleton.

REQUIRED SQL:
ALTER TABLE `faction_list` ADD COLUMN `mod_r42` smallint(6) NOT NULL default '0' AFTER `mod_r14`;
ALTER TABLE `faction_list` ADD COLUMN `mod_r367` smallint(6) NOT NULL default '0' AFTER `mod_r330`;
ALTER TABLE `faction_list` ADD COLUMN `mod_r522` smallint(6) NOT NULL default '0' AFTER `mod_r367`;
UPDATE faction_list SET mod_r367 = mod_r60;
UPDATE faction_list SET mod_r42 = mod_r120;
ALTER TABLE `faction_list` DROP COLUMN `mod_r60`;
ALTER TABLE `faction_list` DROP COLUMN `mod_r120`;

==04/22/2010==
Trevius: Added the following to Client Perl; GetEndurance(), GetMaxEndurance(), GetEnduranceRatio(), SetEndurance(amount).
Trevius: SoD - Size fix for player races.
Trevius: SoD - Manual consumption of food/drink works and deletes the consumed item.
Trevius: SoD - Consumption of alcohol now gives a chance for skilling up tolerance and also deletes the consumed item.

==04/21/2010==
Trevius: SoD - The Mana and Endurance formulas are as close as I can get them for now.
Trevius: SoD - NPC default size is now 6 if the database is set to 0.
Trevius: It is no longer possible for current Endurance to be higher than max Endurance.
Trevius: Corrected a mistake pointed out by Rogean that was sending an unnecessary packet when clients were moving.

==04/19/2010==
gaeorn: bug fix so login server does not send world local_ip if option local_network is not set in login.ini

==04/18/2010==
Trevius: SoD - Added HP formulas for the SoD client, and a new rule to enable them for SoD clients only.

Optional SQL: utils/sql/svn/1394_optional_rule_sod_hp_mana_end.sql

==04/17/2010==
gaeorn: fixed login server auto-reconnect
cavedude (Leere): Tradeskill recipe learning
Congdar: fix windows compile: warning C4405: 'crc32' : identifier is reserved word
Congdar: fix windows compile: warning C4554: '>>' : check operator precedence for possible error; use parentheses to clarify precedence
Congdar: fix windows compile: warning C4800: 'char *' : forcing value to bool 'true' or 'false' (performance warning)

Required SQL: utils/sql/svn/1392_recipe_learning.sql

==04/16/2010==
KLS: (Leere) Melody Fix.
KLS: Other merges from spell branch, some more to come.  Tell me if there are any crashes I only tested it for about 25 minutes.

==04/15/2010==
cavedude (Leere): Increased the number of tradeskill favorites that can be stored client side to 500.
cavedude (Leere): Fixed avgcoin. 
cavedude (renoofturks): Fixes to SK harm touch.
cavedude: Lowered snare movement speed when fleeing to 41% or higher to allow "Snare" to prevent movement at all levels.
gaeorn: multiple login server support in world. protocol to update login server account information from within game. "trusted" field for world accounts in loginserver to limit where account updates can come from. in eqemu_config.xml, use <loginserver1></loginserver1> to specify first of multiple login servers. increment the number to specify additional login servers. NOTE: be sure to replace the <loginserver></loginserver> entry or you will be limited to just one login server. MULTIPLE LOGIN SERVERS WILL NOT WORK WITH MINILOGIN.

Required SQL for loginserver tables:
alter table tblWorldServerRegistration add ServerTrusted integer NOT NULL after ServerAdminID;

==04/12/2010==
Derision: SoD - /who <name>, /whotarget now work.
Derision: Corpses summoned in Shadowrest should no longer decay before you can finish looting them.

==04/11/2010==
Derision: SoD - Corpses should now vanish instantly rather than decay when using /hidecorpse.
Derision: SoD - Players can now see other players buffs in their target window.
Derision: SoD - Tracking - Player filter now works.
Trevius: SoD - Added Primary/Secondary weapon textures into the spawn struct for non-playable races.

==04/10/2010==
Trevius: SoD - Identified showhelm in the spawn struct.
Trevius: SoD - Corrected Face in the Player Profile.  Frogloks and Vah Shir now show matching head and body correctly.
Trevius: SoD - Added Mana and Endurance update packets for clients.

==04/08/2010==
Derision: SoD - Tracking Auto-refresh should no longer fail with Recovery timer not met.
Derision: SoD - Previously memmed spells are now unmemmed when loading a spell set.
Derision: SoD - Added Slot conversion to ApplyPoison_Struct (Apply poison should work as well as Titanium).
Derision: AllButSoD - Fixed bug in Barter code.

==04/06/2010==
Derision: SoD - Players may now be tracked and fixed a bug where tracking would not work when switching tracking targets without cancelling tracking.
Derision: SoD - Initial work on /hidecorpse serverside support. All but /hidecorpse looted should work.

==04/05/2010==
Derision: SoD - Loot All now works.

==04/04/2010==
Derision: SoD - Group member (client or bot) mana and endurance should update correctly in the group window.
Derision: SoD - Altered SpawnStruct encode to send colors for all playable races (including corpses and NPCs).
Derision: SoD - Group Main Assist may be assigned via the Group Window. As the group leader cannot explicitly assign it to himself, use /grouproles set <leadername> 2
Leere:	A moving mob that becomes mezzed will no longer appear to continue moving.
Fourier: Added location to the output of #listnpc.

==04/03/2010==
Trevius: SoF/SoD - Total Spent AA Points now show correctly for these 2 clients.
Trevius: Froglok characters now default to size 5 instead of 7.  This corrects size issues when using illusions.
Derision: SoD - Bazaar Trader Mode/Bazaar Search should now work correctly.
Derision: SoD - Found the helm field in the spawn struct.
Derision: SoD - Implemented new packets for sending the list of findable NPCs to the client.
Derision: SoD - Flymode and Titles in the spawn struct.

==04/02/2010==
Derision: SoD - Group Leadership AA should mostly work (Main Assist is no longer a GLAA and Health Awareness seems intermittent).
joligario: Pet behavious change.
Trevius: SoF/SoD - Added clicky item checks to match previous clients. All clicky item hacker entries should now be actual hack attempts.
Trevius: Added an extra hacker check for clicking a must equip effect without having it equipped.
Trevius: SoD - Removed the opcodes for the Pet Buff Window until the structure is updated.  Prevents pet classes from crashing when pets are buffed.
Derision: SoD - Pet Buff Window now works.
Derision: SoD - Fixed OnLevelMessage struct (popup windows).
Derision: SoD - Fixed Barter mode.
Congdar: (Taurinus) Drakkin bots

==04/01/2010==
Derision: SoD - Tracking
Derision: SoD - Fixed price bug when buying from merchants.
Trevius: SoD - Spell books now display all scribed spells (was previously hiding the first 9 slots).
Trevius: SoD - Stopped the Barter error that was reporting when logging in due to an incorrect opcode.

==03/31/2010==
Derision: SoD - Groups should be as functional as previous clients, except Group Leadership AA doesn't work.
Derision: SoD - Fixed items being incorrectly flagged as No Trade/Copied

==03/30/2010==
Trevius: SoD - Corrected the opcode for Mob Health Updates so they update properly.
Trevius: SoD - Added a few new Opcodes and Structures for SoD packets that aren't used yet.


==03/28/2010==

Derision: SoD - Fixed client animation/runspeed glitch.
Derision: All Clients - Player position updates to other players should be more accurate.
Trevius: Updated #race and #fixmob commands to allow up to race 626 which is the total for the SoD client.
Derision: SoD - Very preliminary work on groups. You can form a group, but nothing else.

==03/27/2010==
Trevius: SoD - A couple more Opcode updates.
Trevius: SoD - Some group structures work, but grouping is still not functional.
Derision: SoD - Fixed random client crashes due to spawn packets and invisible mobs should now be invisible.
Derision: SoD - Did a basic Encode on OP_WhoAllResponse. Still needs work for various flags (LD/Trader/Buyer) etc.


==03/26/2010==
Trevius: SoD - Finished updated Opcodes and they should now be caught up with what we have in SoF.
Trevius: SoD - Updated Item Struct and now 1 inventory item can load correctly.
Trevius: SoD - Updated Position Update packet structures.
Trevius: SoD - Character Inventory now fully loads.
Trevius: SoD - AAs now load and appear to function properly.
Derision: SoD - Spawns work, sometimes. Client will crash randomly sometimes when receiving spawns
Derision: SoD - Added SoD.cpp to .vcproj files
Derision: SoD - Found showname field in Spawn Struct.
Derision: SoD - Identified equip_chest2 field in Spawn Struct.
Trevius: SoD - Looting now works.
Trevius: SoD - Commands that display item links now show links correctly.

==03/25/2010==
Trevius: SoD - Updated PlayerProfile_Struct and CharacterSelectEntry_Struct
Trevius: SoD - Updated Spawn_Struct and the encode (hackish for now), but can get in game with it!

==03/24/2010==
Trevius: SoD - Updated the NewZone struct and encode

==03/23/2010==
Trevius: SoD - Initial addition of the Seeds of Destruction patch files.  Note: The SoD Client is not functional at all yet, but work has begun!

==03/22/2010==
Derision: Implemented the Guild Bank.

REQUIRED SQL: utils/sql/svn/1293_guild_bank.sql

==03/20/2010==
cavedude: Added $client->UpdateGroupAAs(), exported GetGroupPoints() and GetRaidPoints() to Perl.

==03/19/2010==
cavedude: Added $client->GetLDoNPointsTheme() Perl function.
Trevius: Added new EVENT_TARGET_CHANGE perl event.  It triggers when an NPC target changes or is removed. It exports $hastarget which is 0 if no target and 1 if there is a target.
Trevius: Exported new quest objects to Perl Mob - SetRace(race), SetGender(gender), and SetTexture(texture).
Trevius: Exported to Perl Mob - SendIllusion(race,[gender,texture,helmtexture,face,hairstyle,haircolor,beard,beardcolor,drakkin_heritage,drakkin_tattoo,drakkin_details,size]).
Trevius: Added rule: Character:DeathExpLossMaxLevel - Any level greater than this will no longer lose experience.  Default is 255 (disabled).

Optional SQL: utils/sql/svn/1290_optional_exp_loss_rule.sql

==03/18/2010==
Trevius: Added 3 new Perl Entity commands - GetMobByID(id), GetNPCByID(id), and GetNPCByNPCTypeID(npc_id).
Congdar: Bots: Fixed picklock and summon corpse

==03/16/2010==
Trevius: Saylinks should no longer cause zone crashes if used outside of EVENTs.  They should function from anywhere now.

==03/13/2010==
Trevius: Added new SetFlyMode(0|1|2|3) Perl Mob command.
Trevius: NPCs in flymode 1 or 2 will no longer use BestZ when pathing to waypoints.
Trevius: Added new optional single client argument to SendAppearanceEffect(effect1, effect2, effect3, effect4, effect5, client) to allow sending the effect only to specific players.

==03/12/2010==
joligario: Fixed some spelling mistakes.

==03/11/2010==
Congdar: bots can now equip items with augments.  required sql:  \utils\sql\svn\1280_bot_augs.sql
Congdar: new bot command '#bot augmentitem' Allows you to augment items for your other bot classes. Your must have the Augmentation Sealer window filled.

==03/10/2010==
Derision: Begging should no longer bug the client. Still needs some work around chance/amount/skillups etc.

==03/07/2010==
Derision: Fix for temporary items on merchants appearing to increase in price.
Leere: Refinement to above and fix for purchase price of stacked items != displayed price * quantity.

==03/05/2010==
Trevius: Inspecting SoF players is now possible.
Derision: A mob corpse will now be left even if a Bot's pet does the most damage.

==03/03/2010==
Trevius: Added functionality to the EQEmu Web Tool to show IP information based on account searches.
Derision: Set Message Type for spells wearing off, experience and leadership messages so they aren't classed as 'Other' by the client chat filters.
Derision: Removed -fpermissive from zone/makefile so invalid type conversions should now cause an error rather than a warning for Linux compiles.

==03/01/2010==
Trevius: Added 2 new optional arguments to quest::gmsay(text, [color, send_to_world?]) - allows changing color and sending to world or just zone.
Trevius: Normal Saylinks should now work without requiring a target for proximity says.  Silent saylinks still require a target.
Trevius: Added a check for valid slots when moving items from 1 slot to another.
Trevius: NPCs using 2 Hand Pierce weapon models can be set to skill 99 in the prim_melee_type field of the npc_types table to show the correct attack animations and messages.

==02/26/2010==
Derision: Fix for crash in Mob::DetermineSpellTargets.
Congdar: fixed bot right-click inspect window title bar shows player name instead of target bot name.

==02/25/2010==
Secrets: Added new Perl::Client command, ReadBook(Book Text, Type), to allow sending a book/scroll to clients via quests.  Type 0 = scroll, type 1 = book.
Trevius: GMs with #gm on should now be able to /target NPCs across the zone again.
joligario: Fixed typo relating to Pet pursuit speed in MobAI.cpp
joligario: Manual WP Add fix.
joligario: Fixed duplicate declaration of command_wp in command.h

==02/24/2010==
Derision: SoF: TRADER/BUYER will now be displayed as appropriate in /who for SoF clients.

==02/23/2010==
Trevius: Added new Perl::Mob quest object SendAppearanceEffect(effect1, effect2, effect3, effect4, effect5) which can send up to 5 particle effects at once.
realityincarnate: spells requiring dragon/giant targets will now work on velious raid targets

==02/22/2010==
Trevius: Added 2 new fields (prim_melee_type and sec_melee_type) to the npc_types table to allow setting attack animations/messages to go with weapon models (Default is 28 - Hand to Hand)
Trevius: Added Perl Quest Objects; GetPrimSkill(), GetSecSkill(), SetPrimSkill(skill_type), SetSecSkill(skill_type) for altering the above setting temporarily.

Required SQL: utils/sql/svn/1259_npc_skill_types.sql

==02/17/2010==
Trevius: Added new quest::untraindiscs() command to untrain all disciplines
Trevius: Added Client Perl Objects UntrainDisc(slot) and UntrainDiscAll() to untrain either just 1 discipline slot or all disciplines
Trevius: Added functionality to quest::traindisc() to allow it to use the spell_globals table and system
Trevius: Added in code to prevent a zone crash related to group/raids using group recourse spells as a temporary fix until the Spells branch goes live

==02/15/2010==
Gaeorn: (iRFNA) Fixed flaw in IsPureNukeSpell() logic. Fixes bug where bots were healing enemies.
Derision: Added default value to suspendeduntil column in utils/sql/svn/1195_account_suspendeduntil.sql

==02/07/2010==
Derision: Reverted cross-zone group invites from Rev1086

==02/06/2010==
Trevius: Added an account status setting option to the database page of the EQEmu Web Tool.

==02/02/2010==
Richardo: Added options wep1 and wep2 to #npcedit to allow changing primary and secondary weapon models.

==02/01/2010==
Trevius: Renamed BoolNPCSpecAtks() to HasNPCSpecialAtk() to fit better into the proper naming format and to make more sense.
Derision: Added $client quest methods to get current PVP point and crystal counts and to award PVP points and crystals.
Derision: Mapped out the part of the player profile used for recording recent PVP kills.
Derision: Removed EVENT_WAYPOINT. Use EVENT_WAYPOINT_ARRIVE or EVENT_WAYPOINT_DEPART instead.

==01/31/2010==
Trevius: Exported new BoolNPCSpecAtks() to Perl::Mob.  This can be used to check if an NPC has certain special attacks set.
Derision: Added support for purchasing from Discord Merchant (Class 59).
Derision: Added support for purchasing from Norrath's Keepers and Dark Reign Merchants (Classes 67 and 68).
Derision: Added commands #setpvppoints <amount> and #setcrystals <radiant|ebon> <amount>
Derision: EVENT_POPUPRESPONSE is now passed to player.pl

==01/30/2010==
cybernine186: Implemented the #suspend command.

Required SQL: utils/sql/svn/1195_account_suspendeduntil.sql

==01/28/2010==
gaeorn: added EQEmuLoginServer/EQCryptoAPI.h (contents from a EQEmu forum post by KLS)

==01/28/2010==
Rabayn: Fixed reference to freed memory in Doors::HandleClick.
Derision: Anti Kill-Stealing fix.

==01/27/2010==
Trevius: Suspend Minion AA now requires level 62 or greater to use it.
Secrets: Implemented quest::voicetell(PlayerName, MacroNumber, RaceNumber, GenderNumer).

==01/26/2010==
Trevius: Exported new ProjectileAnim(mob, item_id, [IsArrow?, speed, angle, tilt, arc]) command to perl::mob.
Trevius: Added the following to perl::NPC - GetSpawnPointX(), GetSpawnPointY(), GetSpawnPointZ(), GetSpawnPointH(), GetGuardPointX(), GetGuardPointY(), and GetGuardPointZ()
Derision: Leadership abilities should now work correctly for groups with 1 Player + Bots.

==01/25/2010==
Trevius: Exported CheckLoSToLoc(x, y, z, [mob_size]) to perl::mob.
Trevius: Exported FindGroundZ(x, y, [z_offset]) to perl::mob.

==01/24/2010==
Trevius: Exported CheckLoS() to perl::mob.
Trevius: Added SoF Decode/Encode for OP_InspectAnswer.  SoF clients can now inspect Titanium clients and everything shows up properly.  SoF clients still cannot be inspected at all by either client.
Derision: Fix for armor not showing to other player's after looting your corpse.
Derision: Call of the Hero should no longer transfer aggro to the caster.
LeftRoad: Implemented /pet leader command.
Derision: Fix for item loss when going Linkdead with items in the trade window.
Derision: /getguildmotd now works.
Derision: Fixed Bazaar search filter for Endurance, Attack, HP & Mana Regen, Haste and Damage Shield.

==01/23/2010==
Trevius: Added NPC:ReturnNonQuestNoDropItems rule to enable/disable a new feature that allows all NO DROP items to be returned if turned into a non-item-quest NPC (no EVENT_ITEM).
Trevius: Removed a possible exploit with quest turn-ins.
Derision: Added check for spell target type SummonedPet (e.g. Elemental Draw).
Derision: Implemented /searchcorpse GM command.
Derision: Reset Trade Accepted state if money is added to a trade.
Derision: Shrunk/Grown players/mobs will now appear the correct size to new players entering the zone.
Derision: OP_GuildMemberList for SoF (used to populate Guild Management Window Roster.
Derision: OP_GuildDemote for SoF.
Derision: OP_GuildPublicNote for SoF.
Derision: Corrected message produced when trying to use Suspend Minion on a charmed pet.

Optional SQL: utils/sql/svn/1144_optional_rule_return_nodrop

==01/22/2010==
Trevius: Adjusted quest::wearchange(slot, texture) so it will now show the weapon slot changes to players who zone in after the change has already happened.
Derision: Implemented Secondary Forte AA.

==01/21/2010==
Trevius/Andmetal: Added new Spell Globals system.  Adding spells to the new spell_globals table with a qglobal name and value there will require characters to have the matching qglobal in the quest_globals table in order to scribe spells via the quest::scribespells command. Note: Only integers can be used for values currently.
Trevius: Added EnableSpellGlobals rule to enable/disable the new Spell Globals system.
Trevius: Minor change to how NPC loot tables are handled for selecting drops.  This should make actual drop rates a bit closer to how they are set in the database.
WildcardX: Implemented a new client animation rate to server-side speed ratio for bots to make bot movement as precise and natural looking as possible. It is possible all other Mob's could benefit from this same tuning if anyone wants to try it on their server.
WildcardX: (Frumph) Implemented a new set of #bot commands to customize bot appearances within the game!
WildcardX: (Frumph) Fixed so bot spell casters don't ghost while casting a spell with a long cast time and bot casters don't sit while a spell is being casted.
WildcardX: Fixed bot casters from doing rapidly and repeatidly going from sit to stand and back to sit during buff casting.

Required SQL: utils/sql/svn/1136_spell_globals.sql

==01/20/2010==
Trevius: Added quest::wearchange(slot, texture) to allow any slot to be changed to any texture/weapon model.  This works just like the #wc <slot>, <texture> command.
blmille2: Implemented Calliav line of spells.
Derision: Reverted flawed change to client_packet.cpp.

==01/19/2010==
WildcardX: Tweaked bot spell healing ai to improve general group healing.
WildcardX: Fixed a zone crash caused by adding an non-existent mob to a bot's hate list.
blmille2: Implemented Suspend Minion and Persistent Minion AA.
garim12: Mastery of the Past AA Ranger/Beastlord version fix.
WildcardX: Added new command, #distance to return the in game distance between you and your target.
WildcardX: Bot casters will now stay in ange to cast heals and other spells during combat.

==01/18/2010==
WildcardX: Potential bug fix for #bot camp zone crash bug. Continued work on bot animations. (thanks much to Frumph and Secrets for their assistance)
joligario: New EVENT_WAYPOINT_ARRIVE and EVENT_WAYPOINT_DEPART. The old EVENT_WAYPOINT will be removed shortly, so be sure to replace all occurences of EVENT_WAYPOINT with EVENT_WAYPOINT_DEPART in all your current scripts.
joligario: Faction values of zero are no longer written to the faction_values table.
WildcardX: Smoothed out bot melee animations. Another attempt at isolating the #bot camp zone crash bug.

==01/17/2010==
WildcardX: More bot ai refactoring that is focused on making the bot movements more smooth and accurate. Still a lingering issue when bots fight a mob that has a giant body type.
WildcardX: Bots in melee range of their target will now seperate themselves some so they won't appear so much on top of each other in combat. "Tank" classes will always be closer than "DPS" classes.
WildcardX: Fixed a issue with bot pet hitpoints not persisting correctly to the database and an issue that prevented the client from getting all HP updates for bots and their pets.

==01/15/2010==
Derision: Added check in Handle_ApplyPoison to verify the specified inventory slot contains a poison in case the player moved items around after beginning to apply the poison.
Derision: Fixed a bug where Mend would not report failures for skill levels below 75.

==01/15/2010==
WildcardX: Refactored the general bot ai logic. It appears I have bots properly showing their run animations and bots will now stand before they cast a spell. Because I touched soo much bot ai code, this rev should be evaluated fully before implementing on a public play server. I may decide to revert this rev of the bot code if it proves too unstable.

==01/14/2010==
WildcardX: Fixed a bug in the EQEmuLoginServer that resulted in the server not processing login requests because the application's connection to its MySQL database engine was closed. I have implemented an auto reconnect feature of the MySQL client api.
WildcardX: Cleaned up a couple compiler warnings for EQEmuLoginServer.
WildcardX: Refactored some code that worked fine on a Windows OS, but was incompatible with a Linux OS. New code is compatible with both operating systems.

==01/13/2010==
WildcardX: Implemented auto melee or archery weapon selection for the bot ranger if the bot ranger is level 61 or better and the bot owner toggled the #bot archery command. After toggeling once, the bot then decides on archery or melee until the #bot archery command is toggled again or the bot zones or camps.
WildcardX: Fixed a bug that prevented bots from being created on systems running MySQL on a linux OS. Windows MySQL servers were unaffected.
WildcardX: Enchanter bots will no longer cast any illusions as part of "buffing". In the near future, I will implement a new #bot command to cast illusions instead.
WildcardX: Fixed a bug that prevent enchanter bots from casting any damage over time or nuke spells against their target.
WildcardX: Fixed a bug that caused bots to "ghost" as they followed their client owner.

==01/12/2010==
WildcardX: Implemented a bot spellcasting ai overhaul that improves upon the existing ai and creates a framework to expand additional ai enchancements around for bot coders. NOTE: Please evaluate this version of bots BEFORE you replace your existing server as this is still a work in progress.
WildcardX: Implemented bot wizard nuke spell selection for the new bot spellcasting ai.
WildcardX: Fixed various bugs to now allow any characters except the bot owner to give bot commands or spawn the bot. Also fixed #bot mana command to filter out non-caster bots.

==01/10/2010==
Derision: /invite can now be used to invite a player in another zone into a regular group.

==01/09/2010==
Derision: Changed Client::GroupInvite2 to use the Invitee name passed in the OP_GroupInvite packet rather than the player's target.

==01/08/2010==
WildcardX: Fixed a bug that allowed a bot to be created with the same name as an existing player character. This would cause said bot to not zone with other bots the group.
WildcardX: Added new bot command, #bot mana. This will give a mana report for all spawned bots in the zone. Bot mana report spamming is now disabled.

==01/07/2010==
WildcardX: Fixed a EQEmuLoginServer crash that can happen as the result of a null reference in the database code.
WildcardX: Fixed a bug with bot archery. The command shouldn't crash the zone and the bot should correctly display the bow only.

==01/06/2010==
WildcardX: Fixed a bug that prevented Bot casters from casting if a mob becomes enraged.
WildcardX: Changed #bot list and #bot spawn commands to use bot name instead of the bot table id
WildcardX: Added new commands to save, load, delete and view bot groups. See the #bot botgroup help command to view them.
WildcardX: Fixed SQL syntax issues with database scripts for bots.
WildcardX: Fixed a bug that may have made it difficult to add bots to bot only groups.

<SQL Required for BOTS> 1077_botgroups.sql

==01/05/2010==
WildcardX: Fixed the EQEmuLoginServer project file, fixed a crash caused by referencing a NULL object and made a couple improvements to error handling.
Derision: Fix for quest::depopall related crash.
WildcardX: Improved healing for Bots inspired by contribtions from Bad_Captain! Bot healers won't let a HoT spell block them from casting a heal spell when in combat.
WildcardX: Bot pets will now seek to engage their target's from behind when their Bot master's are fighting the same mob from in front.

==12/30/2009==
Derision: Update azone2 with EQG v4 support.

==12/27/2009==
Derision: Fix to set required heading when zoning.

==12/23/2009==
cavedude: (Kilelen) Added quest functions quest::checktitle(int titleset), quest::enabletitle(int titleset), and quest::removetitle(int titleset) to allow Perl to enable or remove titles for a player.

Required SQL: utils/sql/svn/1057_titles.sql

==11/21/2009==
KLS: Ad hoc task selectors should ignore tasks that are not enabled now.

==11/19/2009==
Congdar: Fixed Resist Stat Caps, Removed GetMax...() methods calculating some AA's twice.

==11/18/2009==
KLS: Added check for character deletion as pointed out by Rogean.

==10/31/2009==
AndMetal: Changed HP regen calculations to be Live-like. Basically higher level regen will be about 50% more than it is currently & FD regen should be better than standing, but less than sitting (instead of 25% of sitting regen).
AndMetal: Races that get the HP Regen "bonus" (Iksar & Troll by default) can be customized as a bitmask via rule Character:BaseHPRegenBonusRaces(4352).
AndMetal: Added #setallskills alias for #setallskill/#setskillall.
AndMetal: Added '#rules get [rule]' for a single rule & '#rules values [catname]' for a category to allow real-time viewing of the rule values from the zone (not the DB).
AndMetal: Added client HP, Mana, & Endurance regen info to #showstats/#mystats

==10/30/2009==
KLS: Exported DoSpecialAttackDamage() to perl::mob;

==10/25/2009==
WildcardX: Tweaked guilds a little to accomodate integrating BOTS.
WildcardX: Bots can not join guilds in the same way as characters can. Bots can only be members, not officers.
WildcardX: Deprecated the legacy BotRaids system and all #bot raid commands. Also deprecated the legacy botgroups table.
WildcardX: Renamed the #bot group order ... series of commands into only #bot group ...

<SQL Required for BOTS> 1040_DeprecatedBotRaidsSystems.sql

==10/23/2009==
KLS: Added discussed work around for SoF > level 75 issue from forums.
WildcardX: Bot pets and bot pet items and bot pet buffs will now save their state to the database between zones and camps just like a character.
WildcardX: Add SQL to create unique columns in group_id and group_leaders tables in hopes of removing the last of the seemingly random issues with groups and zoning.

<SQL Optional> 1038_grouptablesuniquecolumndefinitions.sql
<SQL Required for BOTS> 1038_botpetstatepersists.sql

==10/21/2009==
WildcardX: Bots will now persist their buffs to the database while zoning or camped.

<SQL Required for BOTS> 1036_botbuffs.sql

==10/20/2009==
WildcardX: Bots can now be a group leader. A character can now make not only a group mixed with both bots and other characters, but also groups with all bots and lead by a bot the character designates. Please see #bot botgroup help for details. The legacy BotRaids logic will be removed from the server code in the next 24/48 hours. This effectivly makes bot raiding the same as before the raid system was created. Much of the existing "#bot group order" commands will also be deprecated soon.
WildcardX: Fix for a bug with #bot botgroup add.
WildcardX: Fix for a bug with bot group leader's record in group_id table not removing any older records.
WildcardX: Fix for a bug that caused a bot group leader to say it is following itself.
WildcardX: Fix for a bug that caused a zone crash when a client ungracefully disconnects from zone but zone still runs and the client had spawned bots.
KLS: Added #globalview
KLS: QGlobals will update instantly for the zone they're in.

==10/19/2009==
WildcardX: Fixed a number of bugs with support bots zoning. Refactored the code and eliminated the botactives table.

<SQL Required for BOTS> 1030_botzoningsupport.sql

==10/18/2009==
WildcardX: Bots can now zone with their bot owners as long as they are in a group. Bots not in a group will camp instead of zone.

<SQL Required For BOTS> 1027_botactives.sql

==10/17/2009==
WildcardX: A character and a bot can now recieve an ldon adventure.

<Required SQL> 1022_botadventuring.sql

==10/15/2009==
AndMetal: Added rule Combat:ProcTargetOnly(true). Allows the change from Rev 606 that limits procs to only the target to be removed. Note: AE procs can still cause stability issues if it is set to false.
AndMetal: Fixed some "no newline at end of file" warnings.
AndMetal: Corrected formatting/typo for some # commands.
AndMetal: Fixed a memory leak in Client::ZonePC().
KLS: Changed how QGlobals are tracked on the server to reduce the amount of times we query the database.  I've tested it quite a bit but if you find anything wrong with the new implementation: report it.

==10/07/2009==
Rogean: #motd now updates clients instantly serverwide.

==09/30/2009==
Rogean: Fixed possible crash in Mob::CheckWillAggro();
Rogean: Temporarily Disabled Fear MaxLevel Check causing a crash.
Trevius: Added Quest Commands quest::playerfeature(feature, setting) and quest::npcfeature(feature, setting) - See Wiki for details on usage.
Trevius: Added Quest Objects GetHairColor(), GetBeardColor(), GetEyeColor1(), GetEyeColor2(), GetHairStyle(), GetLuclinFace(), GetBeard(), GetDrakkinHeritage(), GetDrakkinTattoo(), and GetDrakkinDetails().

==09/29/2009==
Rogean: Direct Heal and Rune Aggro are now based off the mana cost of the spell.
Rogean: HoT Aggro is now based off the per-tic heal amount, when the spell lands.
Rogean: Fixed several issues with focus effects. Beneficial Hate Reduction Focus should now work.
Rogean: Fixed AA Spell Casting Subtlety not applying to heal aggro. Also changed to correct values.

==09/27/2009==
cavedude: (Shin Noir) Implemented Wizard AA: Teleport Bind.
cavedude: (tsowl) GMs will no longer need a key for locked portal doors.
cavedude: (tsowl) Fix for shared and normal bank dupes.
cavedude: (Nachyoz) Corrected a bug preventing $faction from reporting correct values.
cavedude: (drakelord) Runes will now block stuns, provided the damage does not exceed the rune's limit.

==09/23/2009==
gaeorn: small fix to pathing code for 64bit
gaeorn: a few changes to makefiles to clean things up

==09/20/2009==
Rogean: Small (Big?) Aggro change, melee swings now generate same aggro regardless of hit/miss/dodged.
Rogean: Aggro Formula changed to weapon_damage + dmg bonus + elemental dmg + (if applicable) bane dmg.

==09/18/2009==
KLS: Fixed an error with Perl::Group::GetMember(index) added Perl::Raid::GetMember(index).
KLS: Added new npc types field: 'unique_spawn_by_name'.  NPC will only attempt to spawn if there isn't already a npc with it's exact name in the zone already.
Rogean: Added World IP Logging @ Login.

<Required SQL> 980_account_ip.sql

==09/16/2009==
KLS: Added support for raid all loot (type 4), raids will default to this loot type now(may have some appearance issues).
KLS: Added command #raidloot to change raid loot manually, this is needed for titanium if they want to switch from 4 to another and back to 4 since the client does not support type 4 natively.
KLS: Added private_corpse to npctypes to dictate whether a corpse will unlock to outside people or not, by default(0) it will unlock.

==09/08/2009==
Trevius: SoF - Corrected disciplines for SoF clients so they can load up to 100 instead of being cut-off at 50 max.

==08/28/2009==
KLS: Fix for bug with AI_Start not clearing feign death.
KLS: Worked out basics for /claim, not yet implemented but worked out all the packets needed for sof/titanium.
KLS: Finished with /claim implementation.

==08/26/2009==
KLS: Significantly lowered karma required to talk globally if using the system.
KLS: Fixed some small potential exploits.
KLS: Extended anti-spam to /tell, will extend fully to universal chat server soon.
KLS: Started work on /report but did not finish implementation yet.
KLS: Added hotzone support.
KLS: Finished /report implementation.

==08/23/2009==
WildcardX: *BOTS* Fixed a bug that made bots ghost when moving.
KLS: More tweaks to anti-hack systems, should trigger MQWarp less often.
KLS: Instituted a cooldown on looting items from corpses, 200ms per item looted.

==08/17/2009==
KLS: Fix for zonesummon variables influencing next zone attempt if you inner-zone first.

==08/13/2009==
KLS: Added method to enable / disable spawn2 entries from spawning, enabled by default obviously.
KLS: Two quest methods to modify spawn2 behavior quest::enable_spawn2(spawn2_id) and quest::disable_spawn2(spawn2_id), disable will force depop whatever mob is currently spawned in that spawn2 point if any.
KLS: quest::spawn_from_spawn2(spawn2_id), will force a spawn_2 point to spawn a npc even if disabled or it already has a npc spawned.
KLS: Exported several new C-Objects to perl: MobList, ClientList, NPCList, CorpseList, HateEntry, HateList. Examples of how to use can be found in utils/Examples/ListIteration.pl

==08/11/2009==
WildcardX: *BOTS* Refactored some bots code and implemented a new feature. Players can now inspect bots and their equipment just like players inspect other players. Enjoy!
Trevius: (Secrets) Minor fix for the new Maxlevel Scaling for NPCs to correct a HP issue if they have visible armor/weapons or buffs.
Trevius: SoF - Updated Opcodes for Voice Macros. They now function in SoF (/vtell, /vgroup, /vraid).
WildcardX: *BOTS* Cleaned up bot inventory code a little and fixed a bug that caused some items to display in incorrect slots in the inspection window.
WildcardX: *BOTS* Bot bards are now holding concerts for those willing to listen...

==08/10/2009==
WildcardX: Tweaked Groups a little to allow a group to consist of both Bots and Clients, doesn't matter what order you invite either nor does it matter how many of each.
WildcardX: *BOTS* A client camping out or zoning will now auto camp out all their bots and clean up any group those bots may have been in.
gaeorn: renamed zone->map to zone->zonemap to eliminate compile warning
gaeorn: added lots of type casting for 64bit compatibility
KLS: Added #revoke support to /auction and UCS chat channels.
KLS: Added rule Chat:KarmaGlobalChatLimit amount of karma needed to be able to chat in global channels below the minimum level and Chat:GlobalChatLevelLimit. By default the level is 8 and the karma amount equal to 24 hours of /played time. Meaning that unchanged someone must be >= level 8 or have more than a day of played time before they can chat in global channels.

==08/09/2009==
WildcardX: *BOTS* Fixed the bots illusion bug that caused a bots gender and race values to be changed to that of the illusion in the bots table.
WildcardX: *BOTS* Added new bots command, "#bot giveitem". This command lets you give a NO DROP, NO TRADE item to your bot as long as its on your cursor.
WildcardX: *BOTS* Added new commands, "#bot camp" and "#bot camp all". The first orders your bots to camp out if you target them. The second orders all bots you own to camp out, no need to target each.
Trevius: Created methods for when an NPC is spawned to clean up the NPC code some.
WildcardX: *BOTS* Fixed a bug caused by using #bot giveitem that didn't update the client that the iyem that was on the cursor is now gone.
WildcardX: *BOTS* Fixed a bug that crash the client when trading with a bot.
KLS: Fix for #ban
KLS: #ban will now update the player's flag and kick them from the server.

==08/08/2009==
WildcardX: *BOTS* More code refactoring.
WildcardX: *BOTS* Bots now appear as another client player to your client. This will lead to using your UI to perform operations like group invites/disbands and the raid UI. Perhaps even guilding your bot! (Thanks Trev for your assistance!)
WildcardX: Fixed a bug that negatively impacted BOTS when the NPC scaling logic was introduced. This caused bots to spawn as outrageously large levels, like level 185!
WildcardX: *BOTS* Bots can now be invited and disbanded from your group by simply using the group "Invite" and "Disband" buttons from the client's UI.
WildcardX: *BOTS* Tweak to the bots total play time calculation to make it more accurate.
KLS: Added #path meshtest simple to do a faster search on errant path nodes.
KLS: Modified the accurate hazard code to make automatic path maps with more accurate info that requires less manual editing afterward.
cavedude: (demonstar55) Pets will now be amiable to their owners, indifferent to all else.
cavedude: (demonstar55) Added $client->KeyRingCheck() and $client->KeyRingAdd() to allow Perl to manipulate the keyring.
cavedude: (demonstar55) Casting an invis spell on a player that already has a similar type invis spell will no longer drop the existing buff.
cavedude: (demonstar55) Corrected message string for heal spells.
cavedude: Added rule to determine at what HP a fleeing NPC will halt due to being snared.

==08/07/2009==
WildcardX: *BOTS* More code refactoring.
WildcardX: Implemented 4 additional abstract methods in the mob object, HasRaid(), HasGroup(), GetRaid(), GetGroup(). These will be implemented as common interfaces by any class deriving from Mob.
WildcardX: *BOTS* Tweaked bot logic so group channnel doesnt get spammed with every swing.
Trevius: Minor adjustment to the flow of logic for the MaxClientsSetByStatus rule to allow it to override settings for the additional max client rules if enabled.
Trevius: Corrected the Attack Rating portion of #showstats and #mystats
Trevius: (Secrets) Added new quest::gmsay("message") command that will send a message to all GMs (GMs only) on the server.
Trevius: (Secrets/Trevius) Added 2 new fields (maxlevel & scalerate) to npc_types for allowing NPCs to spawn within a range of levels and scale stats at the rate set
WildcardX: NPC is no longer a friend class in the Mob class. Moved the class member Mob::target to Mob's private scope to ensure other classes use the Mob::GetTarget() and Mob::SetTarget() methods.
WildcardX: *BOTS* Commented out code that let bots use the groups chat channel until I can fix I bug I found that causes bots to have their targets repeatedly reset to null values and back to their attacker while in combat.

Required SQL: utils/sql/svn/898_npc_maxlevel_scalerate.sql

==08/06/2009==
WildcardX: *BOTS* Significantly modified the bots table. Removed several unnecessary columns and changed  many interger columns to accept signed values. Added new columns to track dates and times for bots.
WildcardX: *BOTS* Slowed bot runspeed to a more reasonable default value.
WildcardX: *BOTS* Bots will now depop instead of being murdered to go away.
WildcardX: Only a Client object will try to update its group id in the database when a group member is removed from the group.
WildcardX: *BOTS* Bots will now record their total play time.
WildcardX: Modified Group::AddMember() to be more bots friendly and removed specific bot code to do the same thing.
WildcardX: *BOTS* Modified the IsBotAttackAllowed() method to prevent a bot wizard's familiar from attacking.
WildcardX: *BOTS* More code refactoring. Bots will now use group message channel to communicate with the group (idea being bots may eventually be in a different zone than the group and/or client).

Optional SQL: *BOTS* utils/sql/svn/892_optional_bots_table_mod.sql
Optional SQL: *BOTS* utils/sql/svn/893_optional_bots_table_mod.sql

==08/05/2009==
WildcardX: Fixed a bug that prevented COMBAT_EVENT signaling to NPC's from working correctly.
WildcardX: Bots will now call the database a lot less regarding their inventory. They can get info about their inventory from memory during runtime.
WildcardX: Bots appearance like face, hair, etc is now persisted to the database and used during runtime.
WildcardX: (Taurinus) Tweaked the way bots calculate their AA's so the code isn't as long and is easier to read.
WildcardX: A bot getting aggro will aggro its group members for them to come to the bots defense.
gaeorn: added utils/sql/svn/botsconvert.sql to convert old schema bots and inventory to new schema. if you need to convert old bots, use this instead of bots.sql.

==08/04/2009==
WildcardX: Fixed a bug that broke cash handins with NPC's.
WildcardX: Fixed a bug that reversed a riposte attack's target.
WildcardX: Merged the "bots" branch into trunk and removed the prior "EQBOTS" system from trunk. Please carefully evaluate this version before making any decision to upgrade your servers.
Trevius: Added a Distance option for quest::follow(entity_id, distance) to allow setting the distance for the NPC to follow at.

==08/02/2009==
realityincarnate: SoF - Added opcode values to avoid packet dumps of some of the more annoying unknowns
realityincarnate: SoF - Tradeskill success messages now display the recipe name instead of %1
realityincarnate: Added #myskills command to bring up an SoF-style skills window showing current and capped skill levels
realityincarnate: Skills can no longer pass the cap from initial training (specifically bard meditate)

==7/31/2009==
WildcardX: Implemented a method to calculate the reciprocal heading of a specified mob object.

==7/30/2009==
Trevius: Added heading option and bool option for saving guard spot to quest::moveto(x,y,z,[h,saveguardspot?]).
Trevius: Added rule MaxClientsSetByStatus. If True, IP Limiting will be set to the status on the account as long as the status is > MaxClientsPerIP.

==7/29/2009==
AndMetal: Small fix to quest::scribespells() to return the correct amount of scribed spells.
AndMetal: #setaapoints/#setaapts will now consistently add the correct amount of AA points. Also added a rule AA:ExpPerPoint(23976503).
AndMetal: Added a little bit of logging for exp (CLIENT__EXP). Disabled by default.

Optional SQL: utils/sql/svn/853_optional_rule_aaexp.sql

==7/27/2009==
gaeorn: changes to login server to compile under linux. added linux makefile for linux. converted utf16 sql files to normal ascii text.
KLS: Fix for issue where client would stop recieving communication when recieving more than 36 nodes in a find reply. Resolved by capping the amount of nodes find can return, more than 36 will result in unable to easily find message.

==7/26/2009==
AndMetal: AGI Penalty for being encumbered now matches the Titanium client. The old formula was much higher than the client was reporting.
AndMetal: Added InLiquid() function to the WaterMap class. Will return true if you're in Water or Lava (or both?)
AndMetal: Converted to some more Message Strings in zone/spells.cpp.
AndMetal: Changed GetNextAvailableSpellBookSlot() & FindSpellBookSlotBySpellID() to return a result much faster.
AndMetal: The scribespells commands/quest functions should no longer overwrite existing spells & will use only unused book slots.
KLS: Added #path resort nodes to facilitate with keeping the pathing nodes in order.
KLS: Fix for crash from adding/removing nodes.
KLS: Combat range will now check the z axis as well.

==7/25/2009==
KLS: Added a much more accurate but slower Hazard Detection algorithm for #path process that will calculate water and very spikey terrain between two points, other instances of PathManager::NoHazards untouched.
KLS: Added #path move and #path disconnect all.

==7/24/2009==
Derision: Moved RecalcWeight to after CalcAABonuses in bonuses.cpp because valgrind complained aabonuses.packrat was used uninitialised.
Derision: Fixed memory leak in /who all processing.
KLS: Added functionality to #path to faciliate making .path files in game, including a very CPU intensive #path process filename which will try to create a connected path from unconnected laid out nodes.
KLS: /find will now do a hazards check.

==7/22/2009==
realityincarnate: Added quest::factionvalue() command to give more logical faction values than the client uses (Scowling = 1, Ally = 9)

==07/21/2009==
Trevius: Added a 4th type for quest::getlevel(type) that will get the characters level2 value, which is the max level the character has ever reached.
Trevius: Added a 3rd option for saylink() to allow the link to be different than the say message. Ex quest::saylink("bind my soul", 0, "bind your soul")

==07/20/2009==
Trevius: Corrected/Updated some minor size stuff with illusions and player races.

==07/19/2009==
Trevius: EVENT_PROXIMITY_SAY will now work whether you have a target or not.
Trevius: Added bool option to quest::saylink() to allow them to be silent. Ex. quest::saylink("silent link",1)
Trevius: Added quest::FlyMode() command to allow setting flymode on players via quest scripts.
WildcardX: Fixed the build by casting this->GetTarget() as NPC in void Client::Handle_OP_ItemLinkClick method as a parameter to a EVENT_SAY call.
WildcardX: Added the changelog file to the solution for convenience.
realityincarnate: Spells cast from items now reduce the charges before creating spell effects (stops loregroup conflict with Gloves/Hammer of Infuse)

==07/15/2009==
Trevius: (Shendare) New object command (#object List|Add|Edit|Move|Rotate|Save|Copy|Delete|Undo) to manipulate objects in real-time from in-game in almost every possible way!

==07/14/2009==
WildcardX: (for BOTS alpha code only) Set textures to 0 to create the correct appearance of a naked bot on spawn without any equipment.
AndMetal: Changed AA Effects to be loaded into a map instead of a static array.
AndMetal: Changed weight in the client class to uint32 from int16 since the client uses 32 bits for the weight. This should prevent it from overflowing.
AndMetal: Corrected Packrat from 10% per level to 1% per level per the Titanium client. It also now affects coin weight (also 1% per level) per the Titanium client.
AndMetal: Cleaned up a few compile warnings.
WildcardX: Advanced a couple error messages before a return statement in the EQEmuLoginServer project.

==07/13/2009==
KLS: Reimplemented pet hate scaling.
KLS: Removed code that ports you if you're found warping.
WildcardX: (for BOTS alpha code only) Inviting a bot to group will show the bot name without any numeric characters (ie, mob::cleanname()).
WildcardX: (for BOTS alpha code only) Detecting pacified mobs via spell effect type instead of specific spell id's.

==07/12/2009==
Trevius: Added "featuresave" option to #npcedit that will save all currently set facial features.
Trevius: Fixed crash for #randomfeatures if no target was selected before using it.
Congdar: Fix EQBOTS AISpells break. Add new rules, features too much to list.
KLS: Upped default monk melee damage, halved default monk special attack damage by a little over half.

SQL: /utils/sql/svn/773_monk_rules.sql

==07/11/2009==
KLS: SoF - Changed raid join packet encode slightly.
KLS: SoF - Added workaround for disconnection on death for now.
WildcardX: Fixed BOTS so the bot doesn't warp to its owner.
WildcardX: All commands for the BOTS system can be tested now except for bot raiding and bot group raiding.

==07/10/2009==
Trevius: (Zeice) Added #mystats command as an alternative to #showstats that only shows stats for the client or it's own pet.
WildcardX: Migrated more code from EQBOTS to BOTS. The BOT code is less buggy than last iteration and now has even more active features that can be tested but there is a known issue or two I am aware of and working to correct.
KLS: Fix for fear not wearing off properly.
KLS: Small tweaks to npc spell ai.
KLS: SoF - Raids should now function properly.

==07/09/2009==
WildcardX: Migrated more code from EQBOTS to BOTS. The BOTS code can do basic functions now but its still "buggy" compared to EQBOTS until migration/integration is complete.
KLS: Clients are no longer immune to charm.
KLS: Added several checks for IsFeared where we were previously only checking IsStunned.
KLS: EVENT_COMBAT should no longer be called when a NPC dies.
KLS: Changed way AISpells was loading, did away with arbitrary 16 spell limit on npc spell lists.

==07/08/2009==
WildcardX: Migrated more code from EQBOTS to BOTS.
WildcardX: Included StringIDs.h to the zone project file and allowed the ";" to replace the "," characters in the WORLD project file.
Trevius: Added rule ArcheryBaseDamageBonus to allow easy adjustments to archery base damage
Trevius: SoF - Adjusted how AAs are loaded to allow all to be fully functional.  This is a temp work-around until the correct way is finalized.
KLS: Lowered aggro backstabs generates by roughly 2/3 for a high level rogue, probably a bit less for a low level rogue.
KLS: Backstab will now use the backstab damage field from items instead of weapon damage.
KLS: Redid all combat skill ups, can only skill up against light blue targets or better for offensive and defensive actions, wont work against clients or NPCs who don't have aggro lists.
KLS: Mobs will prefer targets who are not feared to targets who are feared when selecting new targets.
KLS: Added Rule (Character, MaxFearDurationForPlayerCharacter).
KLS: Fear will now cause PCs to run instead of just be stunned, beware.

==07/07/2009==
Derision: Fix for mobs getting stuck if their path between waypoints attempts to take them 'under the world'.


==07/06/2009==
KLS: Reworked EVENT_ATTACK to be more efficient.
KLS: Reworked EVENT_COMBAT to be both more efficient and smoother, no longer having an arbitrary delay before it fires.
KLS: Took out code in HateList::IsEmpty() that no longer makes any sense to me, it should be noticably faster.
KLS: Took out old unused quest::flagnpc stuff.
KLS: Added #netstats command, allows GM to view the network sent/recv & sent/recv per second on their target or themselves.
WildcardX: Migrated more code from EQBOTS to BOTS and reworked BOTS to derive from NPC object instead of Mob.

==07/05/2009==
gaeorn: (drakelord) Added slow migitation. Set npc_types.slow_mitigation with the portion of slow you want mitigated: 0 = 0%, 1 = 100%, .5 = 50%, etc.
AndMetal: AAs are now calculated in CalcBonuses for clients.
          AAs that have been converted: (Advanced) Innate STR / STA / AGI / DEX / INT / WIS / CHA, Innate Enlightenment, Natural Durability, Physical Enhancement, Planar Durability, Packrat. They should already be in the PEQ aa_effects table.
          For new AAs, you'll want to modify the StatBonuses struct in zone/mob.h. You'll also need to add a case in ApplyAABonuses in zone/bonuses.cpp to add it to aabonuses.
AndMetal: (via Congdar) Fix for quest::traindiscs().
AndMetal: Fixed Packrat. However, it doesn't seem to be updating correctly to the client (or we're taking too much off).
AndMetal: Added weight to #showstats, accurate to 1 decimal point.
KLS: NPCs will no longer try to base their attack speed off weapons they're using, the code wasn't working anyway.
KLS: Lowered monk kick damage and damage table bonuses but added rules to govern this damage so they can be boosted up for any servers that want.
KLS: More work on ranged damage for npcs, not yet fully implemented but quest functions can cause NPCs to ranged attack.
KLS: Added quest::IsEffectInSpell(spell_id, effect_id), quest::IsBeneficialSpell(spell_id), quest::GetSpellResistType(spell_id), quest::GetSpellTargetType(spell_id)

Required SQL:

utils/sql/svn/745_slow_mitigation.sql


==07/03/2009==
KLS: Fix for AA reuse timer text.
KLS: Added rules to replace defines: Combat:MaxRampageTargets, Combat:MaxFlurryHits
KLS: Redid inner workings of rampage a bit to be more efficient memory wise and to hold an unlimited number of rampage targets instead of capping at 20.
KLS: Made ranged combat stuff virtual so I can implement npc ranged attacks tomorrow.
KLS: Added 3 perl functions for the mob scalar type: SetEntityVariable(id_num, var), GetEntityVariable(id_num) and EntityVariableExists(id_num), taking int32 for id_num and string for var. Allows someone to store as many variables on the entity being targeted as they would like.

==07/02/2009==
KLS: Berserker NPCs will now frenzy instead of kick.
KLS: Fix for GetHateRandom() method crash if there are 0 people on the hate list.
KLS: Repop force was broken when we went to the instancing system, it has now been fixed.
KLS: Updated #advnpcspawn to be able to edit respawn and variance timers of spawn points in game.

==07/01/2009==
AndMetal: Added rules for Sacrifice, which also corrects the minimum level you can use it on: Spells:SacrificeMinLevel(46), Spells:SacrificeMaxLevel(69), & Spells:SacrificeItemID(9963).
AndMetal: Switched to some more Message String IDs.
AndMetal: quest::scribespells can now accept minimum level as a 2nd argument. Examples: quest::scribespells(60,60) will scribe just level 60 spells, quest::scribespells(75,71) will scribe spells from 71 through 75.
AndMetal: Ditto with #scribespells, quest::traindiscs, & #traindiscs.
AndMetal: quest::scribespells & quest::traindiscs will now return the amount of spells/disciplines that were scribed/learned (an optional way to verify success or failure).
AndMetal: #scribespells & #traindiscs will limit the max level to whatever the rule Character:MaxLevel is set to, unless you have GM Mode turned on, in which case it's limited to 255 (uint8).
AndMetal: Fixed a compile error introduced in Rev 729.
gaeorn: SE_Harmony and SE_ChangeFrenzyRad effects were reversed. This is based on info from alla regarding spells post OoW that only have SE_Harmony effect (reaction radius).
KLS: Added NPC code 'd' to make npcs be able to see through feign death attempts. (mostly implemented, still have to look into aggroing people who are feigned by proximity)
KLS: Fixed a typo in the petition code and un-reverted the petition.h file (hi, there's a reason it was changed).
KLS: Added mob perl object HealDamage(amount, caster = 0);

Optional SQL:
utils/sql/svn/732_sacrifice_rules.sql

==06/30/2009==
Derision: Fix for mobs in pathing enabled zones fleeing at low health at full run speed.
Derision: Made rule Map:UseClosestZ default to false. Only set true if using azone2 generated maps (specifically those for EQG zones).
realityincarnate: Starting cities are now tracked for newly created characters.
realityincarnate: Enabled the /setstartcity command for characters without a start city assigned.
realityincarnate: Added $client->SetStartZone and $client->GetStartZone perl commands. 
KLS: Petitions will assign id based on character id instead of this stupid desyncing junk.
KLS: Max NPC name length increased to 50 characters up from 30.
KLS: Save on zone success will now commit immediately instead of possibly delaying. Hopefully will help with some of the situations where people zone to bad locations.
gaeorn: New rule NPC:SmartLastFightingDelayMoving. When true (default), if a mob is already wandering home during a FD pull and the puller stands up and then FD again, the mob's timer to return home will not reset, but instead will return home immediately. The timer will be reset if the mob forgets about the FD puller.
gaeorn: New rule Combat:AssistNoTargetSelf. When assisting a target without a target: true = target self (default), false = leave target as was before assist (this is the behavior on live).

Optional SQL:

utils/sql/svn/730_smart_delay_moving.sql
utils/sql/svn/731_rule_assist_notarget_self.sql

==06/29/2009==
Derision: Fixed a pathing bug relating to nodes incorrectly culled from the front of a path.
KLS: Reworked bind code a bit.
KLS: Pets no longer get client war/berserker crit bonuses.

==06/28/2009==
Derision: Began work on pathfinding for aggro/fear and Find NPC.

The path files for the first few zones can be found at http://code.google.com/p/projecteqemu/downloads/list
Put the .path files in your Maps directory with your .map and .wtr files.

Optional SQL:

utils/sql/svn/721_pathing_rules.sql

==06/27/2009==
KLS: Specialization should now never increase the amount of mana it takes to cast a spell.
KLS: Fix for mana preservation focus not functioning correctly.
KLS: Fix for duration enhancement focus effects not affecting detrimental spells.
KLS: Fix for summoning focus not reducing the cast time of nec/beast pets serverside.
KLS: Insufficient mana serverside check will now be before any modifiers instead of after, if you don't have enough mana in your mana pool to cast a spell after modifiers but do before modifiers the spell will cost your entire mana pool.
KLS: Added new npc code 'g', lets npcs resist spells by casters that are not in melee range.
WildcardX: More code migration from EQBOTS to BOTS.

==06/26/2009==
Trevius: SoF - Tradeskill containers within a character inventory can now combine recipes.
Trevius: SoF - Items with Recast Delays no longer appear as greyed out.
KLS: More changes to archery damage.

==06/25/2009==
Trevius: Structure work for Player Profile Recast Timers and Illusions in 6.2 Client.

==06/24/2009==
Trevius: #wc (wearchange) as well as all of the facial feature commands will now retain armor tint when used.
Trevius: Using #wc now makes temporary changes visible by all clients.
Trevius: Decimals can now be used with the #size command instead of it only accepting whole numbers.
Trevius: Size is now identified in the illusion struct for SoF and Titanium.
KLS: Implemented quiver haste.
KLS: Change to ranger stationary archery bonus. (Re: Nerfed)
KLS: Adjusted high level ranger archery hate.
KLS: Fix for mana reduction focus effect checking base instead of base2
KLS: Fix for hybrids not getting mana reduction effects.

Optional SQL: /utils/sql/svn/710_tint_set_naming.sql

==06/23/2009==
KLS: /surname changes
KLS: Implemented OP_ClearSurname
KLS: (gaeorn) Several 64-bit compile and runtime fixes
KLS: (gaeorn) NPC wander back rules.
Trevius: #texture will now allow player races to retain armor tint for both PCs and NPCs.
realityincarnate: bug fix for changing max_hp with the modifynpcstat command 

Required SQL: /utils/sql/svn/704_rules.sql

==06/22/2009==
Trevius: (Rabayn) When creating recipes, it is no longer required that componentcount be on separate rows from the successcount or failcount row.
Trevius: (takatok) AA Shield Block added.
Trevius: (Shendare) Armor Tint on NPCs can now be set on a per-slot basis.
cavedude: Added rules to disable/change #peqzone debuffs. Cleaned up code regarding it some.
Derision: Fixed the BestZ stuff I broke in Rev686

WildcardX: More work migrating EQBOTS code into BOTS.

Required SQL: /utils/sql/svn/702_aashieldblock_tint_table.sql
/utils/sql/svn/703_peqzone_rule.sql

==06/20/2009==
WildcardX: Migrated more code for BOTS from database.cpp to bot.cpp.
AndMetal: Added rule 'Zone:PEQZoneReuseTime' to adjust the reuse time on the #peqzone command. Defaults to 300 per change in Rev 612.
AndMetal: Correction to the item link code used in quests.
AndMetal: Cleaned up zone/StringIDs.h to make it easier to read, plus added some additional String IDs.
AndMetal: Cleaned up fishing some.
AndMetal: Fishing failures should now happen immediately instead of waiting for the timer to run.

Optional SQL: /utils/sql/svn/699_peqzone_rule.sql

==06/19/2009==
KLS: NPCs will no longer warp to their very first waypoint if they start on a grid, make sure they're spawned near their first waypoint!
KLS: Added quest::SetRunning(value) (1 for run, 0 for walk) to let a NPC run when out of combat instead of walk.
KLS: Added quest::IsRunning() return 0 for walk, 1 for run to let quest know if the npc is walking or running.
cavedude (nilbog): Added many missing pet names.
realityincarnate: Restricted monster summoning to things more traditionally considered monsters (no boats, among others)

==06/18/2009==
Derision: Fixed some flawed database queries and a few compile warnings.
Derision: Added command #reloadtitles to reload titles from the database.
Derision: Added second optional argument to #title and #titlesuffix to save the title to the database if 1.
Derision: Added second optional argument to $client->SetAATitle/SetTitleSuffix to save the title to the database.
realityincarnate: Monster Summoning pets should work properly now.

==06/17/2009==
Derision: Removed redundant flymode on/off in water code (not needed since Rev161).
Trevius: New fields added to the alt_vars table to allow SoF and Titanium to both use it.
KLS: Aggro tweaks + melee spell procs wont proc off ranged attacks anymore.

Required SQL: /utils/sql/svn/687_aa_table_changes.sql

==06/16/2009==
Derision: Old corpses summoned by Expedient Recovery will no longer rebury after 5 seconds.
Derision: Added optional duration parameter to quest::popup.
Trevius: SoF - Adventure Merchant Selling is now functional.
Trevius: SoF - Items with click effects now show the min level required to click them.
Trevius: SoF - Items being sold now show the correct price that the merchant will pay for them.
cavedude: Changed the items-0.6.0-DR2-0.6.1-DR1-convert.sql error message to stop confusing people.
cavedude: Green con KOS NPCs will now aggro clients while sitting.
Derision: Spells Gems now stay greyed out after zoning until their recast time is met.
KLS: More aggro tweaks.
KLS: Fix for zone crash from world server.
WildcardX: Migrated more code for BOTS from database.cpp to bot.cpp.

==06/15/2009==
Trevius: SoF - The following fields now show up on items that have values set for them, but the stats are not actually used by the server yet:
	       svcorruption, purity, backstabdmg, dsmitigation, heroic_str, heroic_int, heroic_wis, heroic_agi, heroic_dex, heroic_sta
	       heroic_cha, heroic_mr, heroic_fr, heroic_cr, heroic_dr, heroic_pr, heroic_svcorrup, healamt, and spelldmg
Trevius: SoF - Corrected Max Stat calculation for SoF clients over level 75.
Trevius: Fix for compile error; should have been fixed already *hint*.
Trevius: More tweaks to make illusions work better with features and armor/helm graphics
Trevius: Added alias #rf for the #randomfeatures command. Note that the feature changes are not permanent.
Trevius: Changed the default way of loading spells to now load from the spells_new table instead of from the spells_us.txt file.
Derision: Implemented the Title Window.
KLS: Aggro tweaks.
KLS: Fixes to compile errors/warnings.

Required SQL: \utils\sql\svn\665_heroic_resists.sql
Required SQL: utils/sql/svn/667_titles.sql

Recommended SQL: (This is recommended for databases that don't stay current with PEQ or are custom)
UPDATE items SET backstabdmg = damage WHERE backstabdmg = 0 AND itemtype = 2;

Warning: If you do not have a spells_new table yet, you must create one and load spells into it or zones will crash when loading in.
	 To create the spells_new table, use the SQL from \utils\sql\svn\230_spells_table.sql
	 After creating the table, you can import or export your spells from the spells_us.txt file by using the scripts:
	 import_spells.pl
	 export_spells.pl
	 
	 The easiest way to import your spell file to the table is to move the import_spells.pl file to your main server directory
	 where your spells_us.txt file and your eqemu_config.xml file are.  Then run the following command at a command prompt:
	 perl import_spells.pl

See this post for more information on importing/exporting the spell file:
http://www.eqemulator.net/forums/showpost.php?p=160509&postcount=45

==06/14/2009==
Trevius: Added new command #randomfeatures which will randomize all possible features for playable races.
Derision: Code support for Steadfast Servant Veteran AA.
Derision: Added entity_list::GetRandomClient accessible from Perl.
Dersiion: Fixed infinite loop in EntityList::RadialSetLogging.
Derision: AATimers are now sent at level 1 rather than level >= 51.
KLS: Fix for name_filter checking.
KLS: Name filters will now apply to surnames and will consider any name with 3 repeating characters or more invalid.
KLS: Fix for compile error; should have been fixed already *hint*.

==06/13/2009==
Derision: Implemented SE_PercentXPIncrease and Resist caps.
Trevius: Removing an Illusion should now restore all features to their original settings in most cases.
Trevius: SoF - Adjusted Power Source code some to remove a bug with using the slot.
Derision: Implemented SE_SummonAndResAllCorpses
KLS: Rebalanced some spell effects aggro values.
KLS: Hate added should now be treated correctly.
KLS: Archery should now cause aggro.
KLS: Added rule Aggro:PetAggroAmount to control how much hate a pet causes, 50% default.
KLS: Bash will now cause extra hate depending on the AC of the shield you're using if any.
KLS: Implemented resist reduction and hate reduction spell focus.
KLS: quest::updatespawntimer will now set the respawn timer in the database.
KLS: Stole Trevius' idea to let augments work as focus items.

==06/12/2009==
Trevius: The #nukeitem command and related quest commands is now able to remove items on the cursor and within bag slots of the cursor.
Trevius: SoF - The Power Source Slot is now a usable slot.  Items set to use slot 22 in the items table will be able to use this new slot.
KLS: On successful completion of an adventure players should be removed from the adventure immediately instead of after 30 minutes.

==06/11/2009==
AndMetal: Rule values can be viewed and modified through the web interface. They're updated into the database only, so they won't go into effect until you restart the server.

==06/10/2009==
realityincarnate: Added /makeleader command functionality
realityincarnate: Non-leaders can no longer kick members from the group
KLS: Added $zoneweather perl export

==06/09/2009==
Trevius: Added rule Combat:ArcheryStationaryPenalty to allow adjustment of the Archery damage penalty for moving or rooted targets.
KLS: Backstab tweak again.
KLS: Added Perl commands: GetItemAt(slot), GetAugmentAt(slot, aug_slot) both returning type ItemInst usable from the Client object.
KLS: Added Perl command: IsType() for use on the ItemInst object.

Optional SQL: \utils\sql\svn\646_archery_penalty_rule.sql

==06/08/2009==
KLS(realityincarnate): Charms: Added charm item scaling with scriping support and initial work on evolving items.
KLS(realityincarnate): Added perl method $client->GetModCharacterFactionLevel(FactionID)
KLS(realityincarnate): Added perl method $group->GetMember(index)
KLS: Added perl method $client->GetLDoNWins()
KLS: Added perl method $client->GetLDoNLosses()
KLS: Added perl method $client->GetLDoNWinsTheme(theme 1-5)
KLS: Added perl method $client->GetLDoNLossesTheme(theme 1-5)
KLS: Added support for item clicklevel and item clicklevel2
Trevius: Increased spellbook from 400 to 480 in the Player Profile for use with SoF (60 page spell book)
Trevius: SoF - Added new functions to SoF.cpp for converting Slot IDs between Titanium and SoF
Trevius: SoF - Corrected the location of the spellbook field in the Player Profile to fix an issue with loading spells
WildcardX: Check in of the start of what will become the new BOTS subsystem/framework. This is far from done so just continue to use the existing EQBOTS code you have been using. 
KLS: Change to dangerous item inst aug creation, hopefully addresses segfault on 64 bit linux.
KLS: Hopefully fix for pets not giving adventure credit to players in ldon instances.

==06/07/2009==
NOTE (WildcardX): This version of the server code is a little dangerous for BOT enabled servers. I do not recommend using this revision for BOT enabled servers. Most of the existing BOT code is going to be re-implemented as a "BOT" object in the server code so until I complete this architecture change the BOT code may become somewhat unstable. I apologize for the inconvience but this is necessary to allow the server code for the BOTs to be more flexible and extensible than it is now.

Derision: Check for duplicate lore items when fishing.
Derision: Fixed a memory leak in fishing/foraging code.
WildcardX: Traded static integer values for the appropriate enumeration that defines group action types.
WildcardX: A Player grouping with one or more BOTS will now correctly be set as the group leader.
WildcardX: You can now target your BOT to disband it from the group just as you would a player. This does not call the logic that #bot group remove does, though. Keep using the BOT command for now.
WildcardX: A group of one Player and a BOT can now request a LDoN Adventure, but doing so will crash the zone.
KLS: Change to BS formula: moved backstab bonus to damage table. Still might be off but I have another change in mind if so.
KLS: Fix for bug in client calcbonuses.

==06/06/2009==
Trevius: SoF - Corrected Char select Primary/Secondary slot display order.
Trevius: SoF - Added gender to the conversion for bodytypes 66 and 67, which should resolve any remaining issues with it.
Derision: New Universal Chat Server combining both mail and chat server functionality.
          Required to support mail, chat and friends/ignore for SoF clients.
          See http://www.eqemulator.net/wiki/wikka.php?wakka=UCS
WildcardX: Corrected the project file for eqlaunch. This should allow eqlaunch to execute correctly for Windows XP and Windows 2003 Server.
WildcardX: Corrected database table definition that created a bug which prevented a BOT from being created.

REQUIRED SQL:

CREATE TABLE `friends` (
  `charid` int(10) unsigned NOT NULL,
  `type` tinyint(1) unsigned NOT NULL default '1' COMMENT '1 = Friend, 0 = Ignore',
  `name` varchar(64) NOT NULL,
  PRIMARY KEY  (`charid`,`type`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

634_TrapTemplateDefaultValue.sql

==06/05/2009==
Derision: SoF - Adventure OPCode updates

==06/04/2009==
Trevius: SoF - Added conversion for bodytypes 66 and 67 so they are now untargetable, invisible and have no showing name as they should be.
Congdar: Bots - Implemented raid maintarget, updates to magepet and pvp.  Added Sinister Strikes & Strikethrough AAs and several other updates.
KLS: Pets will no longer gain aggro from their owners before their owners load in. Fixes both a dupe and crash issue.
KLS: Players will no longer take damage or die before they finish loading into the game.
KLS: Fixed a crash in /open.

==06/03/2009==
KLS: Used Cbodmer old ldon trap code as a base for ldon trap implementation. About 50% of the code for this system was his so I figured he deserves credit too.
Derision: Added messages when Leadership Exp is toggled on/off.
Derision: Fixed bug where group retained Leadership AA benefits of previous leader.

Required sql: 621_LDoNTraps.sql
Updated titanium .conf file for ldon opcodes. Will look at other clients later.

==06/02/2009==
Trevius: Updated the new Adventure Opcodes for SoF

==06/02/2009==
KLS: Forgot to update .conf files with the merge. Please update yours if haven't.
KLS: Added settable flavor text to adventure recruiter entries.

Required sql: 619_Adventure_Recruiter_Flavor.sql

==06/01/2009==
KLS: (takatok) Fix for agil being factored twice in to-hit calc.
KLS: (tsowl) Reimplemented corpse reloading timer fix.  Should work with burried corpses now. (Sorry it took so long to get back to).
KLS: Finished implementing Assassinate and Rescue adventure type
KLS: AC in calc will now not cap at 0.  What this means: A level 65 hitting a level 1 will now hit for a majority of attacks at or near maximum damage, it should affect any other situations.
KLS: Spells shouldn't cause interrupts any longer.
KLS: LDoN theme "ALL" items should show up properly now.
KLS: Added sanity check on adventure merchant for both lore items and trying to purchase items of one theme that has a min point requirement while not meeting that requirement.
KLS: Rule Adventure:ItemIDToEnablePorts will now actually cause the door to ignore this rule if it is set to 0.
KLS: Changed the evacuate work around to use zone 1 and zone 2 instead of plane zones that probably have requirements set on them.

==05/31/2009==
realityincarnate: Added EVENT_CAST to player quests
realityincarnate: AA $quest functions: $client->GetAAPoints(), SetAAPoints(value), AddAAPoints(number), RefundAA(), GetSpentAA()
KLS: Procs will now only occur on a player's targeted mob.
realityincarnate: fixed a calculation error with spent AA's
KLS: Merged instance branch to trunk.

==05/30/2009==
KLS: Redid procs a bit, spell procs should work more consistently and ppm formula should be less broken and will also take into account haste now.
Highly suggested you change your Combat:AvgProcsPerMinute rule to 2.0 if you want it to be live like.
Derision: Group Leadership AA

REQUIRED SQL:

ALTER TABLE `group_leaders` ADD `assist` VARCHAR( 64 ) NOT NULL ,
ADD `marknpc` VARCHAR( 64 ) NOT NULL ,
ADD `leadershipaa` TINYBLOB NOT NULL ;

OPTIONAL SQL:

INSERT INTO `rule_values` VALUES (1,'Character:KillsPerRaidLeadershipAA','50','');
INSERT INTO `rule_values` VALUES (1,'Character:KillsPerGroupLeadershipAA','50','');

==05/29/2009==
Derision: Lay Hands/Harm Touch hot buttons now remain depressed across zoning until reuse timer is up.

==05/28/2009==
Congdar: Bots - updates to bot pvp, raidexp and magepet

==05/27/2009==
Trevius: SoF - Added new opcode and structure to support the Respawn Window.  It isn't fully functional yet, but most of the code is there now.
Congdar: Bots - Fixed botraid experience distribution.

==05/26/2009==
WildcardX: Fixed a bug that displayed the name of a target being summoned in an incorrect format.
Angelox: Bots- Weapons that proc'd rune-types were proc'ing for the whole group. 3 fighters with PGTs made you pretty much bullet-proof.

==05/25/2009==
cavedude: (gaeorn) Added a possible fix for some NPCs not always spawning.
Congdar: Bots - Added PvP for bots.
WildcardX: (erde) Added include for limits.h.

==05/24/2009==
KLS: Fixed dodge/parry/riposte, lowered their effectiveness from skill points slightly.
Congdar: Bots - Added new command #bot magepet [earth|water|air|fire|monster] - Select the pet type you want your Mage bot to use.

==05/23/2009==
KLS: Spells with 0 spell mod will now act as if their mod was 100% or normal instead of 0% of normal.
KLS: (Derision) Implemented discipline reuse timer's client side effects
Congdar: New feature to choose if a key should go on the keyring or not.
	required sql 564_nokeyring.sql

==05/21/2009==
Trevius: Added new quest command quest::saylink() to create itemlinks in quest text that can be clicked for a response

Recommended SQL: .\utils\sql\svn\553_saylink_table.sql

==05/20/2009==
Angelox: Bots- Bots can't stack invis-undead, invis-live, or any other invis type spell.
KLS: Fix for NPCs jumping in place when they have the fixpathingZ rules for movement enabled.
KLS: Traps will no longer attempt to clean up their npcs, every time a trap is destroyed so are the NPCs so it's redundant and risky.
Congdar: Bots - Added Magician AA Elemental Durability, Fixed #bot corpse summon, AI Tweak

==05/19/2009==
Trevius: Identified hairstyle, haircolor, beard, and beardcolor in the Titanium Illusion struct so the related commands now work in Titanium.
KLS: PvP info will only be set if the server type is set to 1 (pvp)
KLS: Adjusted chances on dodge/parry/riposte modifiers
KLS: Made experience con scaling into a rule.
KLS: Added Rules: (Character, UseXPConScaling), (Character, LightBlueModifier), (Character, BlueModifier), (Character, WhiteModifier), (Character, YellowModifier), (Character, RedModifier)
Derision: Bandolier bug fix.
Derision: Equipped items that should confer an extra potion belt slot now do so in Titanium and the 6.2 client (was already working in SoF).
Angelox: Bots- (Congdar) fixed Bot illusion / change form spells as to who is affected.
Angelox: Bots- added check to Bot pacify for casting from a distance. 


==05/18/2009==
Trevius: New Commands added: #face, #helm, #hair, #haircolor, #beard, #beardcolor, #heritage, #tattoo, #details
Trevius: Adjusted the #fixmob command to use all features.  The new format is "#fixmob featurename prev/next"
Trevius: Corrected the R524 optional SQL file

==05/16/2009==
Trevius: (Shendare) Added armor tinting functionality for NPCs by setting it in the npc_types table
Trevius: Added base support for illusions to use all facial features, but functionality still needs to be added.
Derision: Reverted (Minimum 3% chance to proc from weapon proc buffs)
KLS: Reduced chance to hit for min damage with AC.
KLS: Added AC scaling by level, will put it in a rule soon.
KLS: Enabled both petition window 'p' and pvp window 'ctrl p' on titanium/sof; neither are functional but they're enabled now and we can work on that later.
Congdar: Bots - fix compile error and update to current combat code
Congdar: Bots - fix pet exploit
KLS: Added backward compatibility to older corpses.

Required SQL: .\utils\sql\svn\527_npc_armor_tint.sql

==05/15/2009==
Trevius: (Trevius/Shendare) Swapped Beardcolor and Beard in the spawn struct for Titanium and Titanium Facial Features should be finalized now.
Trevius: SoF - Drakkin Specific Features (Heritage, Tattoo and Details) should now be fully functional for NPCs and PCs
Derision: Minimum 3% chance to proc from weapon proc buffs (e.g. vampiric embrace, call of sky etc.)
Trevius: Added encode for Illusion packets in Titanium so they see Drakkin as human after clicking off an illusion
Trevius: Optional SQL for adding a notes field to the rule_values table with notes from ruletypes.h

Required SQL: .\utils\sql\svn\518_drakkin_npc_type_features.sql
Optional SQL: .\utils\sql\svn\524_rule_values_notes.sql

==05/14/2009==
Trevius: More work on Facial Features for Characters. Trying to get them functioning properly without hacks before adding SoF Features.
Trevius: SoF - Character Facial Features other than Drakkin specific ones all now work 100% in Character Select and in game.

==05/13/2009==
Trevius: SoF - (Shendare) Corrected the FaceChange Structure and added an encode to make it work
Trevius: SoF - Identified the Drakkin related fields of the Character Select Structure
KLS: Fix for elemental dmg not calculating correctly.

==05/12/2009==
Trevius: SoF - (Shendare) Added a temp commented out test section of code to spawn struct encode
Trevius: SoF - (Shendare) Identified hairstyle, haircolor, flymode, drakkinheritage and drakkintattoo in the spawn struct
Trevius: SoF - (Shendare) Changed facial feature code for getting features slightly
Trevius: SoF - Identified beardcolor, invis, and drakkinspikes in the spawn struct
Trevius: SoF - Updated the OP_CastSpell to convert bag slot from Titanium to SoF for potion use
KLS: Reverted player corpse changes from 5/10 as they caused shadow rest to stop functioning.
KLS: Fixed the /bug structure and updated the table to be more useful.

Required SQL: .\utils\sql\svn\503_bugs.sql

==05/11/2009==
demonstar55: Added a function to allow Perl to check augments within items.
cavedude: Increased bind wound skill up speed some.
KLS: Fix for potentially dangerous typo in spawn conditions code.
KLS: Removed some non-functioning but still taking up database resources database code.
KLS: Change to a spawn2 table query to reduce disk writes.

Suggested SQL: ALTER TABLE `spawn2` DROP INDEX `ZoneGroup`, ADD INDEX `ZoneGroup` (`zone`);

==05/10/2009==
KLS: Fix for a add/remove raid looter across zones error.
KLS: Changed order of split raid exp, ensures amount given to a player is always at least 1.
KLS: (tsowl) Various Fixes

==05/09/2009==
realityincarnate: Modified quest::say to allow npcs to speak in other languages, added $langid quest variable
realityincarnate: Made low language skill/drunkenness a bit less understandable
realityincarnate: Duplicate lore items from foraging/ground spawns are now handled correctly
realityincarnate: Lore items in the shared bank no longer trigger conflicts with items in individual inventories
KLS: Fix for Group:: and Raid:: splitexp bonus calculations happening once for every person in the group / raid, resulting in very high numbers for group and non-positive numbers for raid.
Trevius: SoF - Corrected a minor issues with new mounts where they weren't setting helm texture properly.

==05/08/2009==
Derision: Fixed a bug where a pet set to guard would appear not to stop on returning to it's guard spot after being ordered to attack.
Derision: Fixed a bug where a mob aggroed would sometimes appear to run past it's target.

==05/07/2009==
Trevius: (Erde) The Web Tool now shows the name of the process running each Dynamic zone (example: dynamic_01)

==05/06/2009==
Angelox: Bots: Added command '#bot shrinkme' requires Shaman or Beastlord (defaults to Shaman). 
Derision: Added redux_aa2, redux_rate2 fields to aa_actions.
Derision: Improved Hasty Exit should now reduce the reuse time of Escape.
Derision: The reuse timer in the AA window now shows the reuse time reduced by applicable AAs.
	  (although if you purchase an AA that reduces the reuse time, you must camp before the reduced reuse time will be updated).

REQUIRED SQL:

ALTER TABLE `aa_actions` ADD `redux_aa2` MEDIUMINT( 8 ) UNSIGNED NOT NULL DEFAULT '0',
ADD `redux_rate2` TINYINT( 4 ) NOT NULL DEFAULT '0';
UPDATE `aa_actions` SET `redux_aa2` = '886',
`redux_rate2` = '10' WHERE `aa_actions`.`aaid` =243 AND `aa_actions`.`rank` =0 LIMIT 1 ;

==05/05/2009==
Trevius: SoF - Melee stun/bash no longer causes you to spin
Trevius: SoF - Spell Fizzles and Interrupts no longer cause abnormally long refresh times
realityincarnate: Fixed lore check bug with items in lore group -1
KLS: DoTs should no longer break roots early.
KLS: Added Special Attack hit magical 'm' and special attack hit bane 'b', will allow the mobs affected to hit things that require magical or bane weapons to hit.

==05/04/2009==
KLS: Code block for pets getting sent into attack did not verify that other was not null, causing rare crashes the old way and a pretty common crash with it's new positioning.  This has been corrected.
Derision: Updated spell_type in altadv_vars table to reflect the shared reuse timer ID that it really is.
Derision: AA reuse timers should now display correctly with hotkeys remaining depressed when appropriate.
KLS: Code block for pets getting sent into attack did not verify that other was not null, causing rare crashes the old way and a pretty common crash with it's new positioning.  This has been corrected.
KLS: Added area rampage 'r' npc special attak code.
Congdar: Bots - Added Rogue Triple Backstab AA, Enhanced #bot list, Fixed beneficial weapon procs to not effect the entire group.
realityincarnate: Fix for SoF attunable items
realityincarnate: Added checks for multiple items in the same lore group
Congdar: Bots - Fix Cleric resurrect spell selection, Added zone profiles, Fixed crash with bot follow

REQUIRED SQL: utils/sql/svn/463_altadv_vars.sql

==05/03/2009==
KLS: Some optimizations for the aggro code.  Added a timer for aggro checking will do it twice a second by default: lower AItarget_check_duration in features.h if aggro feels too sluggish for your tastes and recompile.
Derision: Increased reuse_time in AA_DBAction to a uint32 to support reuse timers greater than 18 hours.
Derision: Code support for Chaotic Jester Veteran AA.
Congdar: Bots - Improve Cleric healing ai, fix ae break, update attack code.
Congdar: Bots - Fix sql error for bot table
KLS: (Secrets) min/max damage updated to int32
KLS: Fixed a bug with accuracy tweaks and finished them up.  The system should work fairly well now.
KLS: Removal of several rules associated with the dual accuracy system and the old system for defensive and offensive accuracy bonus.
KLS: Some warning fixes on MSVS.
KLS: Fixed pets not getting sent into battle on attack.
KLS: (theblaz) Pets who were previously guarding after a pet attack command will return to their guard spot; though it appears a stop moving packet is missing on the pet guard spot waypoint.
KLS: Rampage will no longer hit the main tank unless the main tank is the only target in range.
KLS: Swarm pets will once again disappear when their target dies.
KLS: Added zone zone profiling stuff.

==05/02/2009==
realityincarnate: Augment Item Info.
realityincarnate: Show helm option will now save on camping/zoning.
Derision: Corrected a few memory leaks.
Derision: 'Live'/Anniversary patches no longer registered.
Derision: Fix for random client crashes when combining items in world containers (e.g. augmenting items).
BWStripes: Fix for quest::echo.
erde: Added long zone name support to the web interface.
Cripp: Fix for the web interface for those using Perl 5.10.
Congdar: Bots - randomized face/hair etc. so they don't all look the same.  Fixed Bard AE songs.

==4/30/2009==
Congdar: Bots - bots can now use bows, new command '#bot archery'. Added Ranger archery AA's. Reduced chat mana spam. Tweaked spell ai. Fixed memory leak. Updated '#bot corpse summon'. 
Derision: SoF - AAs affecting stats now show the correct stats in the client.
Derision: Tweaked base resists to match the client.
gatorman: Fix for QuickSummoning AA (to include Call of the Hero)
Congdar: Bots - root/snare spell ai fix

==4/29/2009==
Trevius: SoF - Added rule for setting a startzone for SoF Clients separate from where Titanium Clients are set to start.  Set as Zone ID number.

optional sql: utils\sql\svn\447_sof_startzone_rule.sql

==4/27/2009==
Derision: SoF: Reading books/notes/scrolls now works.

==4/25/2009==
Derision: SoF: Ranged attack animations.
Derision: When shooting a bow, there is no longer a superfluous 1HS animation.

==4/23/2009==
Trevius: (realityincarnate) Added new quest command quest::varlink(item_id) for putting item links into variables. 
Derision: Fix for Tradeskill combines where a LORE ingredient is returned.
Derision: Fix for pet names containing spaces losing the space after zoning/camping.
Derision: Fixed bug where Return Home sent players bound in Grobb to Qeynos/Unknown Zone.

==4/22/2009==
Derision: When Tribute is manually deactivated, it should stay deactivated.
Derision: Tribute will not continually try and reactivate when you run out of tribute points.

==4/20/2009==
Derision: Added EVENT_PROXIMITY_SAY

==4/19/2009==
Wolftousen: Player Flurry rate was slightly increased
Wolftousen: Player Flurry messages will now show up as red text, but use the same filter as NPC flurry messages
Wolftousen: Rage Volley no longer requires you to have an thrown weapon in your ranged slot
Wolftousen: Rage Volley now uses the proper damage calculation and is not based on the item you have in the ranged slot
Wolftousen: Rave Volley can no longer be dodged/blocked/parried/reposted.
Wolftousen: Procs from Buffs have been tweaked to go off more often Wolftousen: Players will now receive the "proper" bonus HP for stamina above 255.
Wolftousen: Knight class Tactical Mastery AA was implemented and should now give the strike through message 
renoofturks: Created rule Aggro:StunAggroMod to dial in on aggro of stun based attacks.
cavedude: Reverse DS and some DS will now cause aggro on intial cast.
realityincarnate: Controllable boats should now work. Please see: http://eqemulator.net/forums/showthread.php?p=167892#post167892 for additonal information.
realityincarnate: Safe fall skill up is now checked on failure.

Optional SQL:

INSERT INTO rule_values VALUES(1,'Aggro:StunAggroMod',750);

==4/18/2009==
Derision: Changed Account Session Limiting to kick off the old connection and allow the new one.
drakelord: Rest State HP and MP Bonus
Derision: SoF - Combat/Rest state indicator now works.
Derision: No longer need to zone for /corpse to work.
Derision: Fixed Bazaar bug.

Optional SQL:

INSERT INTO rule_values VALUES(1,'Character:RestRegenPercent',0);
INSERT INTO rule_values VALUES(1,'Character:RestRegenTimeToActivate',30);

==4/13/2009==
Congdar: Bots - Fix release vs. debug compile for focus effects, updated bots to new attack code.

==4/13/2009==
Trevius: SoF - Corrected corpse looting slots so that the correct item is looted when there are multiple on a corpse
Trevius: SoF - Item Links from corpse looting messages now display properly for both client versions
Derision: Personal Tribute should now have an effect serverside, rather than just showing increased stats in the client.
Derision: Deactivating Tribute should no longer crash the client.
Derision: SoF - Personal Tribute should now work.

==4/12/2009==
Trevius: SoF - Commands that return itemlinks will now show the full name instead of cutting off the first 5 characters
Trevius/Derision: SoF - Fix for subitem serialization.
Derision: SoF - Corrected money update opcodes.
Derision: SoF - Bazaar Trader mode.

==4/11/2009==
Trevius: SoF - Stopped the bogus "Deleting Item" messages from being sent to SoF Clients
cavedude: (Congdar): You can now safely delete a key item after its been added to your keyring.
cavedude: (realityincarnate): Added quest::MerchantSetItem and quest::MerchantCountItem to add temp items to a merchantlist. See Wiki for usage.
cavedude: Added rule World:MinGMAntiHackStatus to manage the min status checked against the GM AntiHack list.
Derision: Sof: Added support for regular /who

==4/10/2009==
Derision: Tradeskill recipes involving weapons as an ingredient should no longer dupe the weapon.
Derision: Expendable items with charges are now deleted when the last charge is used.
Derision: Tradeskill skillups now based on unmodified skill level.
Derision: (realityincarnate): Prevent bard skillups for instruments they aren't trained in.
Derision: (realityincarnate): Implemented SE_Hunger (e.g. for Song of Sustenance).
Derision: (realityincarnate): Undying armor by setting RGB to 255 255 255 fixed.
Derision: (realityincarnate): Title suffix quest command, Syntax: $client->SetTitleSuffix(title)
Derision: (erde): cleanipc fix for GCC 4.3.2
Derision: (BWstripes): Beastlord pets are now named SoAndSo's Warder.

==4/09/2009==
Derision: Fix for Alchemy, Poison Making and Tinkering.

==4/08/2009==
Derision: Added $client->GetClientVersion(). Returns: 1 (6.2 Client), 2 (Titanium), 3 (SoF)

==4/07/2009==
Derision: Fixed crash in chatserver.
Derision: Fixed possible crash in QuestManager::attacknpc

==4/06/2009==
Derision: (Image): Check packet length is at least 4 bytes in EQStream::ProcessPacket
Derision: (Image): EQStreamFactory::ReaderLoop - Assure that the incoming buffer contains an opcode to analyze.
Derision: (Image): Sanity checks on OP_SessionResponse/OP_SessionStatRequest size in EQStream::ProcessPacket

==4/05/2009==
Derision: GM Training: SoF - Points now update correctly in the Training Window.
Derision: GM Training: Points now update correctly in the Training Window for languages.
Derision: GM Training: The correct amount of money is deducted from the player profile.
Derision: SoF - Mapped findable field in Spawn struct and OP_FindPersonRequest/Reply.
Derision: SoF - Duelling now works.
KLS: Compile option to ignore login fatal errors in world.

==4/04/2009==
Derision: Tracking: Now works in SoF and as a side effect, Tracking 'sort by distance' works properly in 6.2 and Titanium clients.

==4/03/2009==
Congdar: Bots - Added Healing and Lifetap AA's and Focus Effect support
Derision: SoF - Fix for incorrect animation (NPCs frozen/walking while standing still).

==3/29/2009==
Derision: SoF - OP_PetBuffWindow, OP_Charm, OP_Stun

==3/28/2009==
Derision: SoF - Tasks now work.
Derision: SoF - OP_Sacrifice, OP_Sound, OP_OnLevelMessage, OP_PopupResponse
Derision: Item Links in Task Descriptions are now formatted correctly based on the client version.

==3/25/2009==
Derision: 'Hack' to display Froglok/Drakkin corpses correctly.
Derision: SoF - OP_Translocate & OP_LevelAppearance

==3/23/2009==
Trevius: SoF - Corrected Right Click item effects so they no longer fizzle
Trevius: SoF - Right Clickable item effects with set recast delays now observe that delay properly
Trevius: SoF - Item Effect Charges now get used and updated properly
Trevius: SoF - Food and Drink are now consumed at the proper rates

==3/21/2009==
Derision: Implemented 'Your total time entitled on this account' in /played.

==3/20/2009==
Trevius: SoF - Fixed a fairly major crashed caused when attempting to use the 8 new bank slots, or shared bank
Trevius: SoF - Banking is now fully functional including the 8 new bank slots, shared bank and bag slots in the bank
Trevius: SoF - Bandolier and Potion Belt are now both functional
Trevius: SoF - Filled in multiple missing opcodes

==3/19/2009==
Trevius: SoF - Grouping should now be fully functional
Trevius: SoF - (Xinu) Added many missing opcodes
Angelox: Bots- More mobs for the "#bot track rare" filter.
Derision: Fixed memory leak in Chatserver /announce processing.

==3/15/2009==
Trevius: SoF - Tradeskill Objects/Containers and Augment Pools should now be fully functional
Trevius: SoF - PC to PC/NPC trading should now be fully functional without bugs
Trevius: SoF - Auto-Consume and Right Click consume of food/drink is functional
Trevius: SoF - Right Click Effects on Items now works in most cases, but needs coding to clean it up a bit
Trevius: SoF - Spell Interrupts are now functioning properly

==3/15/2009==
cavedude: (realityincarnate) Languages can now be taught to other players. Also implemented drunk speak.
cavedude: (realityincarnate) Bonuses will now properly apply when switching items with bandolier.
cavedude: (realityincarnate) Corrected some instances of Bard songs that were incorrectly requiring an instrument.
cavedude: (Wolftousen) Fixes for Rage Volley, Blur of Axes, and Dead Aim.
Derision: Spells that damage the caster will now do full damage.
Congdar: Spells that summon items with charges will now summon said item fully charged.
Angelox: Bots:Added a few more mobs to the "#bot track rare" filter.
Congdar: Bots - Added commands #bot saveraid, #bot spawnraid, #bot groupraid
	required sql: utils\sql\svn\386_bot_save_raid.sql

==3/14/2009==
Trevius: SoF - Tradeskill/Augment Combines in tradeskill containers/objects now works, but currently bugs players when they close the window.
Derision: Fixed bug when activating a bandolier set without a required item in your inventory.
Trevius: SoF - Identified more fields in the Spawn Struct; Face, LFG, Beard, ShowHelm and more

==3/13/2009==
Trevius: SoF - Added a few more encodes/decodes to resolve more slot change issues related to the addition of the Power Source Slot
Trevius: SoF - Ammo now depletes properly when used.  Probably some other minor issues resolved by this change as well.

==3/12/2009==
Trevius: SoF - AAs can now be trained and will update without needing to zone. Point Spent is still wrong.
Trevius: SoF - Char Select now shows Primary and Secondary items properly.

==3/10/2009==
Trevius: SoF - PC to PC/NPC Trading now works, though canceling a trade will bug the character and require them to zone or relog
Trevius: SoF - Players can now sell to merchants
Trevius: SoF - Corrected a bug introduced in Revision 376 that was causing single stackable items to not be stackable

==3/09/2009==
Trevius: SoF - Buffs and debuffs now last for the correct duration.

==3/08/2009==
Trevius: SoF - Corrected Item Struct to fix the issue with non-stackable items showing up as being stackable
Trevius: SoF - Identified an unknown field in Item Serialization as being item charges and set it accordingly so that items should now show accurate current charges.
Trevius/Xinu: SoF - Adjusted a few opcodes for more accuracy - No visible change yet

==3/07/2009==
Trevius: SoF - AAs now show up in the AA window, but do not give bonuses yet.
Trevius: SoF - Spent AA points are partially showing up, but still need work.
Trevius: SoF - Updated some grouping structs, but grouping still isn't working just yet
Trevius: SoF - Buffs can now be clicked off, but the duration still isn't working for them
cavedude: Added new AA, group, and raid EXP multiplier rules. Removed the associated variables.
cavedude: Removed the USE_RACE_CLASS_XP_MODS define as it was outdated and horribly broken.
cavedude: Added group XP bonus. The larger the group, the higher the XP gain.
cavedude: Added XP bonus for Warrior, Rogue, and Halfling.
cavedude: Corrected ZEM for AAs.
cavedude: (Thanks to demonstar55) Pet Affinity will no longer effect charmed pets.
cavedude: (realityincarnate) Bard songs that require instruments will now require them.

Please note: XP gain has pretty much been overhauled. You may need tweak the multiplier rules for your server. 

Optional SQL:

REPLACE INTO `rule_values` VALUES ('1', 'Character:ExpMultiplier', '0.5');
INSERT INTO `rule_values` VALUES ('1', 'Character:AAExpMultiplier', '0.5');
INSERT INTO `rule_values` VALUES ('1', 'Character:GroupExpMultiplier', '0.5');
INSERT INTO `rule_values` VALUES ('1', 'Character:RaidExpMultiplier', '0.2');

==3/03/2009==
Angelox: Fixed most (if not all) npc pet ghosting at zone safepoints.

==3/02/2009==
cavedude: (realityincarnate) Implemented Bard song Magical Monologue
cavedude: (Theeper) Attuneable items will now save over zoning/camping and will no longer auto-loot from corpses.
cavedude: Implemented quest::buryplayercorpse, similar syntax as quest::getplayerburriedcorpsecount. This will bury and depop the oldest of a specified player's unburried coprses. It will bury all corpses, but it only depops corpses in the same zone, or in zones that aren't currently open. Hopefully, somebody else out there can finish this one up so corpse summoners can be implemented.

==2/28/2009==
WildcardX: Begun work on LDoN expansion. Adventure Recruiter window is now operational.

==2/27/2009==
Trevius: SoF - Corrected the NewZone struct a bit, which fixed Fall Damage and Environment Damage
WildcardX: Implemented the rogue skill, Apply Poison. Includes support for the 6.0 client, Titanium and SoF.

==2/26/2009==
Trevius: Added #define options in /zone/attack.cpp to allow an easy switch to use the old hit change code until the new code is finalized.
Trevius: Added new rule MinRangedAttackDist for setting the Minimum Ranged Attack Distance
Trevius: SoF - Updated the SoF opcodes, one of which corrects a false Hacker message and log entry

Optional SQL:
364_ranged_dist_rule.sql

==2/25/2009==
KLS: Fix for backwards rule in anti-spam.

==2/24/2009==
KLS: Added initial anti-spam features to global chat operations at popular request.
KLS: Added option to turn off IP verification in chat and mail servers (for people who use internal networks and find it troublesome).
cavedude: Added peqzone column to zone to allow or deny access to zones using #peqzone.
cavedude: #peqzone will give you the approximate time remaining before reusing.
cavedude: Altered merchant price structure to better match Live. Created rules to govern its behaviour. See ruletypes.h for basic explanations!
cavedude: Added command #givemoney.
Trevius: SoF - Corrected WearChange Struct so primary and secondary items now show properly after zoning and #wc works as well.

Required SQL:
ALTER TABLE `account` ADD `karma` INT(5) UNSIGNED DEFAULT '0' NOT NULL AFTER `revoked`;
ALTER table zone ADD column `peqzone` tinyint(4) NOT NULL default '1';

Optional SQL: 360_peqzone.sql

==2/23/2009==
Trevius: (Xinu) SoF - Many more Opcodes filled in from the client
Trevius: SoF - Doors are now able to open and clickable portals now function as well
Trevius: SoF - Armor tint from dyes is now showing properly
Congdar: Bots: '#bot group remove' now removes any of your spawned bots, if it's a group leader then that whole group

KLS: Changes to combat:
-AC has a slightly higher chance to mitigate into a miss than before
-AC is no more effective per point but the bonus ac every character and npc gets in the calculation has been effectively increased.
-The accuracy falloff from level is now more variable based on defender's level, this should address the issue where at higher levels you can grind npcs that are still blue or light blue at little risk.
-The base chance to hit has been increased.
-Added both hit and avoidance mods for class types that are adjustable by rules.
-Archery now has an accuracy penalty that is rule adjustable, with ranger buffs the penalty should make it so archery is slightly more accurate than melee at default.
-Skill is now a flat 0.33% chance to miss for every point under your max skill you are.
-The benefit from agility to avoidance has been decreased by roughly 33%.
-Maximum chance to hit is now 95%, down from 99%.
KLS: Bug fix in skill up with the skill up mod rule.

Recommended SQL and Optional SQL:
356_combat.sql

==2/21/2009==
cavedude00: Removed Combat:ChanceToHitDivideBy rule. Default value is now Live Like.
	Required SQL: delete from rule_values where rule_name = 'Combat:ChanceToHitDivideBy';
Congdar: Bots: Revert svn328
	Required SQl:	delete from rule_values where rule_name = 'EQOffline:SpawnBotCount';
			delete from rule_values where rule_name = 'EQOffline:CreateBotCount';
			delete from rule_values where rule_name = 'EQOffline:BotQuest';
Congdar: Bots: UN-Revert svn328 + bug fixes
	(if you updated to svn354)
	Required SQl:	328_bot_management.sql
	Optional SQL:	328_optional_bot_management.sql

==02/19/2009==
Trevius: (Xinu) SoF - Many Opcodes filled in from the client
Trevius: SoF - Aligned the Player Profile a bit more.  Should be pretty accurate now
Trevius: SoF - Added Drakkin race again for use of equipment.  Should work correctly this time.

==02/19/2009==
